#line 1 "dfa_riscv.cpp"
//
// Copyright (c) 2003, 2022, Oracle and/or its affiliates. All rights reserved.
// Copyright (c) 2014, 2020, Red Hat Inc. All rights reserved.
// Copyright (c) 2020, 2022, Huawei Technologies Co., Ltd. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/ad_riscv.hpp"
#include "oops/compressedOops.hpp"
#include "opto/cfgnode.hpp"
#include "opto/intrinsicnode.hpp"
#include "opto/matcher.hpp"
#include "opto/narrowptrnode.hpp"
#include "opto/opcodes.hpp"
#include "opto/convertnode.hpp"
#include "utilities/powerOfTwo.hpp"

//------------------------- Source -----------------------------------------

//------------------------- Attributes -------------------------------------

// AttributeForm 
static const int op_cost = 1;

// AttributeForm 
static const int ins_cost = DEFAULT_COST;

// AttributeForm 
static const int ins_size = 32;

// AttributeForm 
static const int ins_short_branch = 0;

// AttributeForm 
static const int ins_alignment = 4;

//------------------------- Macros -----------------------------------------
#define DFA_PRODUCTION(result, rule, cost)\
  assert(rule < (1 << 15), "too many rules"); _cost[ (result) ] = cost; _rule[ (result) ] = (rule << 1) | 0x1;

//------------------------- DFA --------------------------------------------
// DFA is a large switch with case statements for each ideal opcode encountered
// in any match rule in the ad file.  Each case has a series of if's to handle
// the match or fail decisions.  The matches test the cost function of that
// rule, and prune any cases which are higher cost for the same reduction.
// In order to generate the DFA we walk the table of ideal opcode/MatchList
// pairs generated by the ADLC front end to build the contents of the case
// statements (a series of if statements).


void  State::_sub_Op_RegN(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGNNOSP, iRegNNoSp_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegNNoSp_rule, c)
        DFA_PRODUCTION(IREGN, iRegN_rule, c)
        DFA_PRODUCTION(IREGNORP, iRegN_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegN_rule, c)
    }
    {
      unsigned int c = 0;
    }
}
void  State::_sub_Op_RegI(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGIHEAPBASE, iRegIHeapbase_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGI_R14, iRegI_R14_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGI_R13, iRegI_R13_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGI_R12, iRegI_R12_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGI_R10, iRegI_R10_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGINOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
    }
    {
      unsigned int c = 0;
    }
}
void  State::_sub_Op_RegP(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGP_R28, iRegP_R28_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGP_R16, iRegP_R16_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGP_R15, iRegP_R15_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGP_R14, iRegP_R14_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGP_R13, iRegP_R13_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGP_R12, iRegP_R12_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGP_R11, iRegP_R11_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGP_R10, iRegP_R10_rule, c)
        DFA_PRODUCTION(IREGP, iRegP_rule, c)
        DFA_PRODUCTION(JAVATHREAD_REGP, javaThread_RegP_rule, c)
        DFA_PRODUCTION(INDIRECT, indirect_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
        DFA_PRODUCTION(INLINE_CACHE_REGP, inline_cache_RegP_rule, c)
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGPNOSP, iRegPNoSp_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c)
    }
    {
      unsigned int c = 0;
    }
}
void  State::_sub_Op_RegF(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(FREGF, fRegF_rule, c)
    }
}
void  State::_sub_Op_RegD(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(FREGD, fRegD_rule, c)
    }
}
void  State::_sub_Op_RegL(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGL_R10, iRegL_R10_rule, c)
        DFA_PRODUCTION(IREGLNOSP, iRegLNoSp_rule, c+1)
        DFA_PRODUCTION(IREGL, iRegL_rule, c+1)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c+1)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c+1)
        DFA_PRODUCTION(IREGL_R28, iRegL_R28_rule, c+1)
        DFA_PRODUCTION(IREGL_R29, iRegL_R29_rule, c+1)
        DFA_PRODUCTION(IREGL_R30, iRegL_R30_rule, c+1)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c+1)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGL_R30, iRegL_R30_rule, c)	  // overwrites higher cost rule
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGL_R29, iRegL_R29_rule, c)	  // overwrites higher cost rule
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGL_R28, iRegL_R28_rule, c)	  // overwrites higher cost rule
    }
    {
      unsigned int c = 1;
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGL, iRegL_rule, c)	  // overwrites higher cost rule
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)	  // overwrites higher cost rule
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)	  // overwrites higher cost rule
    }
}
void  State::_sub_Op_VecA(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(VREG_V5, vReg_V5_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(VREG_V4, vReg_V4_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(VREG_V3, vReg_V3_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(VREG_V2, vReg_V2_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(VREG_V1, vReg_V1_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(VREG, vReg_rule, c)
    }
}
void  State::_sub_Op_RegFlags(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(RFLAGSREG, rFlagsReg_rule, c)
    }
}
void  State::_sub_Op_AbsD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD] + XFER_COST;
        DFA_PRODUCTION(FREGD, absD_reg_rule, c)
    }
}
void  State::_sub_Op_AbsF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF] + XFER_COST;
        DFA_PRODUCTION(FREGF, absF_reg_rule, c)
    }
}
void  State::_sub_Op_AbsI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) &&
        (
#line 428 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 267 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+ALU_COST * 2;
        DFA_PRODUCTION(IREGINOSP, absI_reg_b_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, absI_reg_b_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, absI_reg_b_rule, c)
        DFA_PRODUCTION(IREGI_R12, absI_reg_b_rule, c)
        DFA_PRODUCTION(IREGI_R13, absI_reg_b_rule, c)
        DFA_PRODUCTION(IREGI_R14, absI_reg_b_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+ALU_COST * 3;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, absI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, absI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, absI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, absI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, absI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, absI_reg_rule, c)
      }
    }
}
void  State::_sub_Op_AbsL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) &&
        (
#line 446 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 320 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+ALU_COST * 2;
        DFA_PRODUCTION(IREGLNOSP, absL_reg_b_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, absL_reg_b_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, absL_reg_b_rule, c)
        DFA_PRODUCTION(IREGL_R29, absL_reg_b_rule, c)
        DFA_PRODUCTION(IREGL_R30, absL_reg_b_rule, c)
        DFA_PRODUCTION(IREGL_R10, absL_reg_b_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+ALU_COST * 3;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, absL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, absL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, absL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, absL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, absL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, absL_reg_rule, c)
      }
    }
}
void  State::_sub_Op_AddD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[FREGD] + FMUL_DOUBLE_COST;
        DFA_PRODUCTION(FREGD, addD_reg_reg_rule, c)
    }
}
void  State::_sub_Op_AddF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[FREGF] + FMUL_SINGLE_COST;
        DFA_PRODUCTION(FREGF, addF_reg_reg_rule, c)
    }
}
void  State::_sub_Op_AddI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _CONVL2I_IREGL_) && STATE__VALID_CHILD(_kids[1], IMMIADD) ) {
      unsigned int c = _kids[0]->_cost[_CONVL2I_IREGL_]+_kids[1]->_cost[IMMIADD] + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, addI_reg_imm_l2i_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, addI_reg_imm_l2i_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, addI_reg_imm_l2i_rule, c)
        DFA_PRODUCTION(IREGI_R12, addI_reg_imm_l2i_rule, c)
        DFA_PRODUCTION(IREGI_R13, addI_reg_imm_l2i_rule, c)
        DFA_PRODUCTION(IREGI_R14, addI_reg_imm_l2i_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMIADD) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMIADD] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, addI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, addI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, addI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, addI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, addI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, addI_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, addI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, addI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, addI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, addI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, addI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, addI_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_AddL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL__CONVI2L_IREGI__IMMISCALE) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 293 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZba
#line 462 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL__CONVI2L_IREGI__IMMISCALE]+_kids[1]->_cost[IREGL] + ALU_COST;
        DFA_PRODUCTION(IREGLNOSP, shaddL_reg_reg_ext_b_0_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, shaddL_reg_reg_ext_b_0_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, shaddL_reg_reg_ext_b_0_rule, c)
        DFA_PRODUCTION(IREGL_R29, shaddL_reg_reg_ext_b_0_rule, c)
        DFA_PRODUCTION(IREGL_R30, shaddL_reg_reg_ext_b_0_rule, c)
        DFA_PRODUCTION(IREGL_R10, shaddL_reg_reg_ext_b_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__CONVI2L_IREGI__IMMISCALE) &&
        (
#line 293 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZba
#line 479 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_LSHIFTL__CONVI2L_IREGI__IMMISCALE] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, shaddL_reg_reg_ext_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, shaddL_reg_reg_ext_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, shaddL_reg_reg_ext_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, shaddL_reg_reg_ext_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, shaddL_reg_reg_ext_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, shaddL_reg_reg_ext_b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_IREGL_IMMISCALE) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 275 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZba
#line 514 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_IREGL_IMMISCALE]+_kids[1]->_cost[IREGL] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, shaddL_reg_reg_b_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, shaddL_reg_reg_b_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, shaddL_reg_reg_b_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, shaddL_reg_reg_b_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, shaddL_reg_reg_b_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, shaddL_reg_reg_b_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_IREGL_IMMISCALE) &&
        (
#line 275 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZba
#line 549 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_LSHIFTL_IREGL_IMMISCALE] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, shaddL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, shaddL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, shaddL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, shaddL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, shaddL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, shaddL_reg_reg_b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMLADD) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMLADD] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, addL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, addL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, addL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, addL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, addL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, addL_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, addL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, addL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, addL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, addL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, addL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, addL_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_AddP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__CONVI2L_IREGI__IMMISCALE) &&
        (
#line 256 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZba
#line 646 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[_LSHIFTL__CONVI2L_IREGI__IMMISCALE] + ALU_COST;
        DFA_PRODUCTION(IREGPNOSP, shaddP_reg_reg_ext_b_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c)
        DFA_PRODUCTION(IREGP, shaddP_reg_reg_ext_b_rule, c)
        DFA_PRODUCTION(JAVATHREAD_REGP, shaddP_reg_reg_ext_b_rule, c)
        DFA_PRODUCTION(INDIRECT, shaddP_reg_reg_ext_b_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
        DFA_PRODUCTION(INLINE_CACHE_REGP, shaddP_reg_reg_ext_b_rule, c)
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
        DFA_PRODUCTION(IREGP_R10, shaddP_reg_reg_ext_b_rule, c)
        DFA_PRODUCTION(IREGP_R11, shaddP_reg_reg_ext_b_rule, c)
        DFA_PRODUCTION(IREGP_R12, shaddP_reg_reg_ext_b_rule, c)
        DFA_PRODUCTION(IREGP_R13, shaddP_reg_reg_ext_b_rule, c)
        DFA_PRODUCTION(IREGP_R14, shaddP_reg_reg_ext_b_rule, c)
        DFA_PRODUCTION(IREGP_R15, shaddP_reg_reg_ext_b_rule, c)
        DFA_PRODUCTION(IREGP_R16, shaddP_reg_reg_ext_b_rule, c)
        DFA_PRODUCTION(IREGP_R28, shaddP_reg_reg_ext_b_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_IREGL_IMMISCALE) &&
        (
#line 238 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZba
#line 672 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[_LSHIFTL_IREGL_IMMISCALE] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION(IREGPNOSP, shaddP_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, shaddP_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(JAVATHREAD_REGP) || _cost[JAVATHREAD_REGP] > c) {
        DFA_PRODUCTION(JAVATHREAD_REGP, shaddP_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, shaddP_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEMA) || _cost[VMEMA] > c) {
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, shaddP_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c) {
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION(IREGP_R10, shaddP_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R11) || _cost[IREGP_R11] > c) {
        DFA_PRODUCTION(IREGP_R11, shaddP_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R12) || _cost[IREGP_R12] > c) {
        DFA_PRODUCTION(IREGP_R12, shaddP_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R13) || _cost[IREGP_R13] > c) {
        DFA_PRODUCTION(IREGP_R13, shaddP_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R14) || _cost[IREGP_R14] > c) {
        DFA_PRODUCTION(IREGP_R14, shaddP_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R15) || _cost[IREGP_R15] > c) {
        DFA_PRODUCTION(IREGP_R15, shaddP_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R16) || _cost[IREGP_R16] > c) {
        DFA_PRODUCTION(IREGP_R16, shaddP_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R28) || _cost[IREGP_R28] > c) {
        DFA_PRODUCTION(IREGP_R28, shaddP_reg_reg_b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IMMLADD) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IMMLADD] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION(IREGPNOSP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(JAVATHREAD_REGP) || _cost[JAVATHREAD_REGP] > c) {
        DFA_PRODUCTION(JAVATHREAD_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEMA) || _cost[VMEMA] > c) {
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c) {
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION(IREGP_R10, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R11) || _cost[IREGP_R11] > c) {
        DFA_PRODUCTION(IREGP_R11, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R12) || _cost[IREGP_R12] > c) {
        DFA_PRODUCTION(IREGP_R12, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R13) || _cost[IREGP_R13] > c) {
        DFA_PRODUCTION(IREGP_R13, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R14) || _cost[IREGP_R14] > c) {
        DFA_PRODUCTION(IREGP_R14, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R15) || _cost[IREGP_R15] > c) {
        DFA_PRODUCTION(IREGP_R15, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R16) || _cost[IREGP_R16] > c) {
        DFA_PRODUCTION(IREGP_R16, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R28) || _cost[IREGP_R28] > c) {
        DFA_PRODUCTION(IREGP_R28, addP_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IREGL] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION(IREGPNOSP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(JAVATHREAD_REGP) || _cost[JAVATHREAD_REGP] > c) {
        DFA_PRODUCTION(JAVATHREAD_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEMA) || _cost[VMEMA] > c) {
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c) {
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION(IREGP_R10, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R11) || _cost[IREGP_R11] > c) {
        DFA_PRODUCTION(IREGP_R11, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R12) || _cost[IREGP_R12] > c) {
        DFA_PRODUCTION(IREGP_R12, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R13) || _cost[IREGP_R13] > c) {
        DFA_PRODUCTION(IREGP_R13, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R14) || _cost[IREGP_R14] > c) {
        DFA_PRODUCTION(IREGP_R14, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R15) || _cost[IREGP_R15] > c) {
        DFA_PRODUCTION(IREGP_R15, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R16) || _cost[IREGP_R16] > c) {
        DFA_PRODUCTION(IREGP_R16, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R28) || _cost[IREGP_R28] > c) {
        DFA_PRODUCTION(IREGP_R28, addP_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], JAVATHREAD_REGP) && STATE__VALID_CHILD(_kids[1], IMML_PC_OFF) ) {
      unsigned int c = _kids[0]->_cost[JAVATHREAD_REGP]+_kids[1]->_cost[IMML_PC_OFF];
        DFA_PRODUCTION(THREAD_ANCHOR_PC, thread_anchor_pc_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_IREGN_) && STATE__VALID_CHILD(_kids[1], IMMLOFFSET) &&
        
#line 3530 "src/hotspot/cpu/riscv/riscv.ad"
CompressedOops::shift() == 0
#line 852 "dfa_riscv.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_IREGN_]+_kids[1]->_cost[IMMLOFFSET];
        DFA_PRODUCTION(INDOFFLN, indOffLN_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indOffLN_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_IREGN_) && STATE__VALID_CHILD(_kids[1], IMMIOFFSET) &&
        
#line 3515 "src/hotspot/cpu/riscv/riscv.ad"
CompressedOops::shift() == 0
#line 864 "dfa_riscv.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_IREGN_]+_kids[1]->_cost[IMMIOFFSET];
        DFA_PRODUCTION(INDOFFIN, indOffIN_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indOffIN_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IMMLOFFSET) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IMMLOFFSET];
        DFA_PRODUCTION(INDOFFL, indOffL_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indOffL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IMMIOFFSET) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IMMIOFFSET];
        DFA_PRODUCTION(INDOFFI, indOffI_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indOffI_rule, c)
      }
    }
}
void  State::_sub_Op_AndI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _XORI_IREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 465 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 892 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORI_IREGI_IMMI_M1]+_kids[1]->_cost[IREGI] + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, andnI_reg_reg_b_0_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, andnI_reg_reg_b_0_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, andnI_reg_reg_b_0_rule, c)
        DFA_PRODUCTION(IREGI_R12, andnI_reg_reg_b_0_rule, c)
        DFA_PRODUCTION(IREGI_R13, andnI_reg_reg_b_0_rule, c)
        DFA_PRODUCTION(IREGI_R14, andnI_reg_reg_b_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], _XORI_IREGI_IMMI_M1) &&
        (
#line 465 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 910 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[_XORI_IREGI_IMMI_M1] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, andnI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, andnI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, andnI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, andnI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, andnI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, andnI_reg_reg_b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI_16BITS) &&
        (
#line 151 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 948 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI_16BITS] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, convS2UI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, convS2UI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, convS2UI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, convS2UI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, convS2UI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, convS2UI_reg_reg_b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMIADD) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMIADD] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, andI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, andI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, andI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, andI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, andI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, andI_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, andI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, andI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, andI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, andI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, andI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, andI_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_AndL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _XORL_IREGL_IMML_M1) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 481 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 1054 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORL_IREGL_IMML_M1]+_kids[1]->_cost[IREGL] + ALU_COST;
        DFA_PRODUCTION(IREGLNOSP, andnL_reg_reg_b_0_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, andnL_reg_reg_b_0_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, andnL_reg_reg_b_0_rule, c)
        DFA_PRODUCTION(IREGL_R29, andnL_reg_reg_b_0_rule, c)
        DFA_PRODUCTION(IREGL_R30, andnL_reg_reg_b_0_rule, c)
        DFA_PRODUCTION(IREGL_R10, andnL_reg_reg_b_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _XORL_IREGL_IMML_M1) &&
        (
#line 481 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 1071 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_XORL_IREGL_IMML_M1] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, andnL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, andnL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, andnL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, andnL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, andnL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, andnL_reg_reg_b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_IREGIORL2I_) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) &&
        (
#line 166 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZba
#line 1106 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_IREGIORL2I_]+_kids[1]->_cost[IMML_32BITS] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, convI2UL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, convI2UL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, convI2UL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, convI2UL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, convI2UL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, convI2UL_reg_reg_b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_IREGIORL2I_) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_IREGIORL2I_]+_kids[1]->_cost[IMML_32BITS]+ALU_COST * 2;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, convI2UL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, convI2UL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, convI2UL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, convI2UL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, convI2UL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, convI2UL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMLADD) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMLADD] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, andL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, andL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, andL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, andL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, andL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, andL_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, andL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, andL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, andL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, andL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, andL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, andL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L__LOADI_MEMORY__) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L__LOADI_MEMORY__]+_kids[1]->_cost[IMML_32BITS] + LOAD_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, loadUI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, loadUI2L_rule, c)
      }
    }
}
void  State::_sub_Op_AryEq(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP_R11) && STATE__VALID_CHILD(_kids[1], IREGP_R12) &&
        (
#line 1850 "src/hotspot/cpu/riscv/riscv_v.ad"
UseRVV && ((AryEqNode*)n)->encoding() == StrIntrinsicNode::UU
#line 1263 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R11]+_kids[1]->_cost[IREGP_R12] + DEFAULT_COST;
        DFA_PRODUCTION(IREGI_R10, varray_equalsC_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_R11) && STATE__VALID_CHILD(_kids[1], IREGP_R12) &&
        (
#line 1835 "src/hotspot/cpu/riscv/riscv_v.ad"
UseRVV && ((AryEqNode*)n)->encoding() == StrIntrinsicNode::LL
#line 1272 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R11]+_kids[1]->_cost[IREGP_R12] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, varray_equalsB_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_R11) && STATE__VALID_CHILD(_kids[1], IREGP_R12) &&
        (
#line 10396 "src/hotspot/cpu/riscv/riscv.ad"
!UseRVV && ((AryEqNode*)n)->encoding() == StrIntrinsicNode::UU
#line 1283 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R11]+_kids[1]->_cost[IREGP_R12] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, array_equalsC_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_R11) && STATE__VALID_CHILD(_kids[1], IREGP_R12) &&
        (
#line 10379 "src/hotspot/cpu/riscv/riscv.ad"
!UseRVV && ((AryEqNode*)n)->encoding() == StrIntrinsicNode::LL
#line 1294 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R11]+_kids[1]->_cost[IREGP_R12] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, array_equalsB_rule, c)
      }
    }
}
void  State::_sub_Op_Binary(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP_R11) && STATE__VALID_CHILD(_kids[1], IREGI_R13) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R11]+_kids[1]->_cost[IREGI_R13];
        DFA_PRODUCTION(_BINARY_IREGP_R11_IREGI_R13, _Binary_iRegP_R11_iRegI_R13_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _NEGVD_VREG_) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_NEGVD_VREG_];
        DFA_PRODUCTION(_BINARY_VREG__NEGVD_VREG_, _Binary_vReg__NegVD_vReg__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGVD_VREG_) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[_NEGVD_VREG_]+_kids[1]->_cost[VREG];
        DFA_PRODUCTION(_BINARY__NEGVD_VREG__VREG, _Binary__NegVD_vReg__vReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _NEGVF_VREG_) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_NEGVF_VREG_];
        DFA_PRODUCTION(_BINARY_VREG__NEGVF_VREG_, _Binary_vReg__NegVF_vReg__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGVF_VREG_) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[_NEGVF_VREG_]+_kids[1]->_cost[VREG];
        DFA_PRODUCTION(_BINARY__NEGVF_VREG__VREG, _Binary__NegVF_vReg__vReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG];
        DFA_PRODUCTION(_BINARY_VREG_VREG, _Binary_vReg_vReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_R11) && STATE__VALID_CHILD(_kids[1], IREGP_R13) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R11]+_kids[1]->_cost[IREGP_R13];
        DFA_PRODUCTION(_BINARY_IREGP_R11_IREGP_R13, _Binary_iRegP_R11_iRegP_R13_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_R13) && STATE__VALID_CHILD(_kids[1], IMMI_1) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R13]+_kids[1]->_cost[IMMI_1];
        DFA_PRODUCTION(_BINARY_IREGP_R13_IMMI_1, _Binary_iRegP_R13_immI_1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_R13) && STATE__VALID_CHILD(_kids[1], IMMI_LE_4) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R13]+_kids[1]->_cost[IMMI_LE_4];
        DFA_PRODUCTION(_BINARY_IREGP_R13_IMMI_LE_4, _Binary_iRegP_R13_immI_le_4_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_R13) && STATE__VALID_CHILD(_kids[1], IREGI_R14) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R13]+_kids[1]->_cost[IREGI_R14];
        DFA_PRODUCTION(_BINARY_IREGP_R13_IREGI_R14, _Binary_iRegP_R13_iRegI_R14_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_R11) && STATE__VALID_CHILD(_kids[1], IREGI_R12) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R11]+_kids[1]->_cost[IREGI_R12];
        DFA_PRODUCTION(_BINARY_IREGP_R11_IREGI_R12, _Binary_iRegP_R11_iRegI_R12_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPUL_IREGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPUL_IREGL_IREGL];
        DFA_PRODUCTION(_BINARY_CMPOPU__CMPUL_IREGL_IREGL, _Binary_cmpOpU__CmpUL_iRegL_iRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGLNOSP) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGLNOSP]+_kids[1]->_cost[IREGL];
        DFA_PRODUCTION(_BINARY_IREGLNOSP_IREGL, _Binary_iRegLNoSp_iRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPL_IREGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPL_IREGL_IREGL];
        DFA_PRODUCTION(_BINARY_CMPOP__CMPL_IREGL_IREGL, _Binary_cmpOp__CmpL_iRegL_iRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPU_IREGI_IREGI) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPU_IREGI_IREGI];
        DFA_PRODUCTION(_BINARY_CMPOPU__CMPU_IREGI_IREGI, _Binary_cmpOpU__CmpU_iRegI_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGINOSP) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGINOSP]+_kids[1]->_cost[IREGI];
        DFA_PRODUCTION(_BINARY_IREGINOSP_IREGI, _Binary_iRegINoSp_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPI_IREGI_IREGI) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPI_IREGI_IREGI];
        DFA_PRODUCTION(_BINARY_CMPOP__CMPI_IREGI_IREGI, _Binary_cmpOp__CmpI_iRegI_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], _NEGD_FREGD_) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[_NEGD_FREGD_];
        DFA_PRODUCTION(_BINARY_FREGD__NEGD_FREGD_, _Binary_fRegD__NegD_fRegD__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGD_FREGD_) && STATE__VALID_CHILD(_kids[1], FREGD) ) {
      unsigned int c = _kids[0]->_cost[_NEGD_FREGD_]+_kids[1]->_cost[FREGD];
        DFA_PRODUCTION(_BINARY__NEGD_FREGD__FREGD, _Binary__NegD_fRegD__fRegD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], _NEGF_FREGF_) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[_NEGF_FREGF_];
        DFA_PRODUCTION(_BINARY_FREGF__NEGF_FREGF_, _Binary_fRegF__NegF_fRegF__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGF_FREGF_) && STATE__VALID_CHILD(_kids[1], FREGF) ) {
      unsigned int c = _kids[0]->_cost[_NEGF_FREGF_]+_kids[1]->_cost[FREGF];
        DFA_PRODUCTION(_BINARY__NEGF_FREGF__FREGF, _Binary__NegF_fRegF__fRegF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[FREGD];
        DFA_PRODUCTION(_BINARY_FREGD_FREGD, _Binary_fRegD_fRegD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[FREGF];
        DFA_PRODUCTION(_BINARY_FREGF_FREGF, _Binary_fRegF_fRegF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) && STATE__VALID_CHILD(_kids[1], IREGN) ) {
      unsigned int c = _kids[0]->_cost[IREGN]+_kids[1]->_cost[IREGN];
        DFA_PRODUCTION(_BINARY_IREGN_IREGN, _Binary_iRegN_iRegN_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI_R12) && STATE__VALID_CHILD(_kids[1], IREGI_R13) ) {
      unsigned int c = _kids[0]->_cost[IREGI_R12]+_kids[1]->_cost[IREGI_R13];
        DFA_PRODUCTION(_BINARY_IREGI_R12_IREGI_R13, _Binary_iRegI_R12_iRegI_R13_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI];
        DFA_PRODUCTION(_BINARY_IREGI_IREGI, _Binary_iRegI_iRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL];
        DFA_PRODUCTION(_BINARY_IREGL_IREGL, _Binary_iRegL_iRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IREGP];
        DFA_PRODUCTION(_BINARY_IREGP_IREGP, _Binary_iRegP_iRegP_rule, c)
    }
}
void  State::_sub_Op_Bool(const Node *n){
    if(         
#line 3737 "src/hotspot/cpu/riscv/riscv.ad"
n->as_Bool()->_test._test == BoolTest::ne ||
            n->as_Bool()->_test._test == BoolTest::eq ||
            n->as_Bool()->_test._test == BoolTest::le ||
            n->as_Bool()->_test._test == BoolTest::gt
#line 1423 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(CMPOPUEQNELEGT, cmpOpUEqNeLeGt_rule, c)
    }
    if(         
#line 3717 "src/hotspot/cpu/riscv/riscv.ad"
n->as_Bool()->_test._test == BoolTest::lt ||
            n->as_Bool()->_test._test == BoolTest::ge
#line 1432 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(CMPOPULTGE, cmpOpULtGe_rule, c)
    }
    if(         
#line 3697 "src/hotspot/cpu/riscv/riscv.ad"
n->as_Bool()->_test._test == BoolTest::ne ||
            n->as_Bool()->_test._test == BoolTest::eq
#line 1441 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(CMPOPEQNE, cmpOpEqNe_rule, c)
    }
    {
      unsigned int c = 1;
        DFA_PRODUCTION(CMPOPU, cmpOpU_rule, c)
    }
    {
      unsigned int c = 1;
        DFA_PRODUCTION(CMPOP, cmpOp_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 181 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 1460 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+ALU_COST * 2;
        DFA_PRODUCTION(IREGINOSP, bytes_reverse_int_b_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, bytes_reverse_int_b_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, bytes_reverse_int_b_rule, c)
        DFA_PRODUCTION(IREGI_R12, bytes_reverse_int_b_rule, c)
        DFA_PRODUCTION(IREGI_R13, bytes_reverse_int_b_rule, c)
        DFA_PRODUCTION(IREGI_R14, bytes_reverse_int_b_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+ALU_COST * 13;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, bytes_reverse_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, bytes_reverse_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, bytes_reverse_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, bytes_reverse_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, bytes_reverse_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, bytes_reverse_int_rule, c)
      }
    }
}
void  State::_sub_Op_ReverseBytesL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) &&
        (
#line 195 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 1513 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + ALU_COST;
        DFA_PRODUCTION(IREGLNOSP, bytes_reverse_long_b_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, bytes_reverse_long_b_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, bytes_reverse_long_b_rule, c)
        DFA_PRODUCTION(IREGL_R29, bytes_reverse_long_b_rule, c)
        DFA_PRODUCTION(IREGL_R30, bytes_reverse_long_b_rule, c)
        DFA_PRODUCTION(IREGL_R10, bytes_reverse_long_b_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+ALU_COST * 29;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, bytes_reverse_long_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, bytes_reverse_long_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, bytes_reverse_long_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, bytes_reverse_long_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, bytes_reverse_long_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, bytes_reverse_long_rule, c)
      }
    }
}
void  State::_sub_Op_ReverseBytesUS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 209 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 1562 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+ALU_COST * 2;
        DFA_PRODUCTION(IREGINOSP, bytes_reverse_unsigned_short_b_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, bytes_reverse_unsigned_short_b_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, bytes_reverse_unsigned_short_b_rule, c)
        DFA_PRODUCTION(IREGI_R12, bytes_reverse_unsigned_short_b_rule, c)
        DFA_PRODUCTION(IREGI_R13, bytes_reverse_unsigned_short_b_rule, c)
        DFA_PRODUCTION(IREGI_R14, bytes_reverse_unsigned_short_b_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+ALU_COST * 5;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, bytes_reverse_unsigned_short_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, bytes_reverse_unsigned_short_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, bytes_reverse_unsigned_short_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, bytes_reverse_unsigned_short_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, bytes_reverse_unsigned_short_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, bytes_reverse_unsigned_short_rule, c)
      }
    }
}
void  State::_sub_Op_ReverseBytesS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 223 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 1615 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+ALU_COST * 2;
        DFA_PRODUCTION(IREGINOSP, bytes_reverse_short_b_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, bytes_reverse_short_b_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, bytes_reverse_short_b_rule, c)
        DFA_PRODUCTION(IREGI_R12, bytes_reverse_short_b_rule, c)
        DFA_PRODUCTION(IREGI_R13, bytes_reverse_short_b_rule, c)
        DFA_PRODUCTION(IREGI_R14, bytes_reverse_short_b_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+ALU_COST * 5;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, bytes_reverse_short_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, bytes_reverse_short_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, bytes_reverse_short_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, bytes_reverse_short_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, bytes_reverse_short_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, bytes_reverse_short_rule, c)
      }
    }
}
void  State::_sub_Op_CallDynamicJava(const Node *n){
    {
      unsigned int c = BRANCH_COST + ALU_COST * 6;
        DFA_PRODUCTION(UNIVERSE, CallDynamicJavaDirect_rule, c)
    }
}
void  State::_sub_Op_CallLeaf(const Node *n){
    {
      unsigned int c = BRANCH_COST;
        DFA_PRODUCTION(UNIVERSE, CallLeafDirect_rule, c)
    }
}
void  State::_sub_Op_CallLeafNoFP(const Node *n){
    {
      unsigned int c = BRANCH_COST;
        DFA_PRODUCTION(UNIVERSE, CallLeafNoFPDirect_rule, c)
    }
}
void  State::_sub_Op_CallRuntime(const Node *n){
    {
      unsigned int c = BRANCH_COST;
        DFA_PRODUCTION(UNIVERSE, CallRuntimeDirect_rule, c)
    }
}
void  State::_sub_Op_CallStaticJava(const Node *n){
    {
      unsigned int c = BRANCH_COST;
        DFA_PRODUCTION(UNIVERSE, CallStaticJavaDirect_rule, c)
    }
}
void  State::_sub_Op_CastDD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD];
        DFA_PRODUCTION(FREGD, castDD_rule, c)
    }
}
void  State::_sub_Op_CastFF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF];
        DFA_PRODUCTION(FREGF, castFF_rule, c)
    }
}
void  State::_sub_Op_CastII(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI];
        DFA_PRODUCTION(IREGI, castII_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
    }
}
void  State::_sub_Op_CastLL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL];
        DFA_PRODUCTION(IREGL, castLL_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
    }
}
void  State::_sub_Op_CastVV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG];
        DFA_PRODUCTION(VREG, castVV_rule, c)
        DFA_PRODUCTION(VREG_V1, castVV_rule, c)
        DFA_PRODUCTION(VREG_V2, castVV_rule, c)
        DFA_PRODUCTION(VREG_V3, castVV_rule, c)
        DFA_PRODUCTION(VREG_V4, castVV_rule, c)
        DFA_PRODUCTION(VREG_V5, castVV_rule, c)
    }
}
void  State::_sub_Op_CastX2P(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + ALU_COST;
        DFA_PRODUCTION(IREGPNOSP, castX2P_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c)
        DFA_PRODUCTION(IREGP, castX2P_rule, c)
        DFA_PRODUCTION(JAVATHREAD_REGP, castX2P_rule, c)
        DFA_PRODUCTION(INDIRECT, castX2P_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
        DFA_PRODUCTION(INLINE_CACHE_REGP, castX2P_rule, c)
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
        DFA_PRODUCTION(IREGP_R10, castX2P_rule, c)
        DFA_PRODUCTION(IREGP_R11, castX2P_rule, c)
        DFA_PRODUCTION(IREGP_R12, castX2P_rule, c)
        DFA_PRODUCTION(IREGP_R13, castX2P_rule, c)
        DFA_PRODUCTION(IREGP_R14, castX2P_rule, c)
        DFA_PRODUCTION(IREGP_R15, castX2P_rule, c)
        DFA_PRODUCTION(IREGP_R16, castX2P_rule, c)
        DFA_PRODUCTION(IREGP_R28, castX2P_rule, c)
    }
}
void  State::_sub_Op_CastP2X(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_IREGN_) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_IREGN_];
        DFA_PRODUCTION(_CASTP2X__DECODEN_IREGN__, _CastP2X__DecodeN_iRegN___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP] + ALU_COST;
        DFA_PRODUCTION(IREGLNOSP, castP2X_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, castP2X_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, castP2X_rule, c)
        DFA_PRODUCTION(IREGL_R29, castP2X_rule, c)
        DFA_PRODUCTION(IREGL_R30, castP2X_rule, c)
        DFA_PRODUCTION(IREGL_R10, castP2X_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP];
        DFA_PRODUCTION(_CASTP2X_IREGP_, _CastP2X_iRegP__rule, c)
    }
}
void  State::_sub_Op_CastPP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGPNOSP) ) {
      unsigned int c = _kids[0]->_cost[IREGPNOSP];
        DFA_PRODUCTION(IREGPNOSP, castPP_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c)
        DFA_PRODUCTION(IREGP, castPP_rule, c)
        DFA_PRODUCTION(JAVATHREAD_REGP, castPP_rule, c)
        DFA_PRODUCTION(INDIRECT, castPP_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
        DFA_PRODUCTION(INLINE_CACHE_REGP, castPP_rule, c)
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
        DFA_PRODUCTION(IREGP_R10, castPP_rule, c)
        DFA_PRODUCTION(IREGP_R11, castPP_rule, c)
        DFA_PRODUCTION(IREGP_R12, castPP_rule, c)
        DFA_PRODUCTION(IREGP_R13, castPP_rule, c)
        DFA_PRODUCTION(IREGP_R14, castPP_rule, c)
        DFA_PRODUCTION(IREGP_R15, castPP_rule, c)
        DFA_PRODUCTION(IREGP_R16, castPP_rule, c)
        DFA_PRODUCTION(IREGP_R28, castPP_rule, c)
    }
}
void  State::_sub_Op_CheckCastPP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGPNOSP) ) {
      unsigned int c = _kids[0]->_cost[IREGPNOSP];
        DFA_PRODUCTION(IREGPNOSP, checkCastPP_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c)
        DFA_PRODUCTION(IREGP, checkCastPP_rule, c)
        DFA_PRODUCTION(JAVATHREAD_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION(INDIRECT, checkCastPP_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
        DFA_PRODUCTION(INLINE_CACHE_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
        DFA_PRODUCTION(IREGP_R10, checkCastPP_rule, c)
        DFA_PRODUCTION(IREGP_R11, checkCastPP_rule, c)
        DFA_PRODUCTION(IREGP_R12, checkCastPP_rule, c)
        DFA_PRODUCTION(IREGP_R13, checkCastPP_rule, c)
        DFA_PRODUCTION(IREGP_R14, checkCastPP_rule, c)
        DFA_PRODUCTION(IREGP_R15, checkCastPP_rule, c)
        DFA_PRODUCTION(IREGP_R16, checkCastPP_rule, c)
        DFA_PRODUCTION(IREGP_R28, checkCastPP_rule, c)
    }
}
void  State::_sub_Op_ClearArray(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL_R29) && STATE__VALID_CHILD(_kids[1], IREGP_R28) &&
        (
#line 2045 "src/hotspot/cpu/riscv/riscv_v.ad"
UseRVV
#line 1829 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL_R29]+_kids[1]->_cost[IREGP_R28] + DEFAULT_COST;
        DFA_PRODUCTION(UNIVERSE, vclearArray_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMML) && STATE__VALID_CHILD(_kids[1], IREGP_R28) &&
        (
#line 10328 "src/hotspot/cpu/riscv/riscv.ad"
!UseRVV && (uint64_t)n->in(2)->get_long()
            < (uint64_t)(BlockZeroingLowLimit >> LogBytesPerWord)
#line 1839 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMML]+_kids[1]->_cost[IREGP_R28]+4 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, clearArray_imm_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL_R29) && STATE__VALID_CHILD(_kids[1], IREGP_R28) &&
        (
#line 10308 "src/hotspot/cpu/riscv/riscv.ad"
!UseRVV
#line 1850 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL_R29]+_kids[1]->_cost[IREGP_R28]+4 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, clearArray_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU__CMPUL_IREGL_IREGL) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGINOSP_IREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU__CMPUL_IREGL_IREGL]+_kids[1]->_cost[_BINARY_IREGINOSP_IREGI]+ALU_COST + BRANCH_COST;
        DFA_PRODUCTION(IREGINOSP, cmovI_cmpUL_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, cmovI_cmpUL_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, cmovI_cmpUL_rule, c)
        DFA_PRODUCTION(IREGI_R12, cmovI_cmpUL_rule, c)
        DFA_PRODUCTION(IREGI_R13, cmovI_cmpUL_rule, c)
        DFA_PRODUCTION(IREGI_R14, cmovI_cmpUL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPL_IREGL_IREGL) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGINOSP_IREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPL_IREGL_IREGL]+_kids[1]->_cost[_BINARY_IREGINOSP_IREGI]+ALU_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, cmovI_cmpL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, cmovI_cmpL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, cmovI_cmpL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, cmovI_cmpL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, cmovI_cmpL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, cmovI_cmpL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU__CMPU_IREGI_IREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGINOSP_IREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU__CMPU_IREGI_IREGI]+_kids[1]->_cost[_BINARY_IREGINOSP_IREGI]+ALU_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, cmovI_cmpU_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, cmovI_cmpU_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, cmovI_cmpU_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, cmovI_cmpU_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, cmovI_cmpU_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, cmovI_cmpU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPI_IREGI_IREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGINOSP_IREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPI_IREGI_IREGI]+_kids[1]->_cost[_BINARY_IREGINOSP_IREGI]+ALU_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, cmovI_cmpI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, cmovI_cmpI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, cmovI_cmpI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, cmovI_cmpI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, cmovI_cmpI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, cmovI_cmpI_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU__CMPUL_IREGL_IREGL) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGLNOSP_IREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU__CMPUL_IREGL_IREGL]+_kids[1]->_cost[_BINARY_IREGLNOSP_IREGL]+ALU_COST + BRANCH_COST;
        DFA_PRODUCTION(IREGLNOSP, cmovL_cmpUL_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, cmovL_cmpUL_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, cmovL_cmpUL_rule, c)
        DFA_PRODUCTION(IREGL_R29, cmovL_cmpUL_rule, c)
        DFA_PRODUCTION(IREGL_R30, cmovL_cmpUL_rule, c)
        DFA_PRODUCTION(IREGL_R10, cmovL_cmpUL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPL_IREGL_IREGL) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGLNOSP_IREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPL_IREGL_IREGL]+_kids[1]->_cost[_BINARY_IREGLNOSP_IREGL]+ALU_COST + BRANCH_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, cmovL_cmpL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, cmovL_cmpL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, cmovL_cmpL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, cmovL_cmpL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, cmovL_cmpL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, cmovL_cmpL_rule, c)
      }
    }
}
void  State::_sub_Op_CmpN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGN) && STATE__VALID_CHILD(_kids[1], IMMN0) ) {
      unsigned int c = _kids[0]->_cost[IREGN]+_kids[1]->_cost[IMMN0];
        DFA_PRODUCTION(_CMPN_IREGN_IMMN0, _CmpN_iRegN_immN0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) && STATE__VALID_CHILD(_kids[1], IREGN) ) {
      unsigned int c = _kids[0]->_cost[IREGN]+_kids[1]->_cost[IREGN];
        DFA_PRODUCTION(_CMPN_IREGN_IREGN, _CmpN_iRegN_iRegN_rule, c)
    }
}
void  State::_sub_Op_CmpD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[FREGD];
        DFA_PRODUCTION(_CMPD_FREGD_FREGD, _CmpD_fRegD_fRegD_rule, c)
    }
}
void  State::_sub_Op_CmpD3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[FREGD]+XFER_COST * 2 + BRANCH_COST + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(IREGI_R12, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(IREGI_R13, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION(IREGI_R14, cmpD3_reg_reg_rule, c)
    }
}
void  State::_sub_Op_CmpF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[FREGF];
        DFA_PRODUCTION(_CMPF_FREGF_FREGF, _CmpF_fRegF_fRegF_rule, c)
    }
}
void  State::_sub_Op_CmpF3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[FREGF]+XFER_COST * 2 + BRANCH_COST + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(IREGI_R12, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(IREGI_R13, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION(IREGI_R14, cmpF3_reg_reg_rule, c)
    }
}
void  State::_sub_Op_CmpI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI0];
        DFA_PRODUCTION(_CMPI_IREGI_IMMI0, _CmpI_iRegI_immI0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI];
        DFA_PRODUCTION(_CMPI_IREGI_IREGI, _CmpI_iRegI_iRegI_rule, c)
    }
}
void  State::_sub_Op_CmpL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML0];
        DFA_PRODUCTION(_CMPL_IREGL_IMML0, _CmpL_iRegL_immL0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL];
        DFA_PRODUCTION(_CMPL_IREGL_IREGL, _CmpL_iRegL_iRegL_rule, c)
    }
}
void  State::_sub_Op_CmpL3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL]+ALU_COST * 3 + BRANCH_COST;
        DFA_PRODUCTION(IREGINOSP, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(IREGI_R12, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(IREGI_R13, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION(IREGI_R14, cmpL3_reg_reg_rule, c)
    }
}
void  State::_sub_Op_CmpLTMask(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI0] + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, cmpLTMask_reg_zero_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, cmpLTMask_reg_zero_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, cmpLTMask_reg_zero_rule, c)
        DFA_PRODUCTION(IREGI_R12, cmpLTMask_reg_zero_rule, c)
        DFA_PRODUCTION(IREGI_R13, cmpLTMask_reg_zero_rule, c)
        DFA_PRODUCTION(IREGI_R14, cmpLTMask_reg_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI]+2 * ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, cmpLTMask_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, cmpLTMask_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, cmpLTMask_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, cmpLTMask_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, cmpLTMask_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, cmpLTMask_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _PARTIALSUBTYPECHECK_IREGP_R14_IREGP_R10) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[_PARTIALSUBTYPECHECK_IREGP_R14_IREGP_R10]+_kids[1]->_cost[IMMP0]+2 * STORE_COST + 3 * LOAD_COST + 4 * ALU_COST + BRANCH_COST * 4;
        DFA_PRODUCTION(RFLAGSREG, partialSubtypeCheckVsZero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_IREGN_) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_IREGN_]+_kids[1]->_cost[IMMP0];
        DFA_PRODUCTION(_CMPP__DECODEN_IREGN__IMMP0, _CmpP__DecodeN_iRegN__immP0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IMMP0];
        DFA_PRODUCTION(_CMPP_IREGP_IMMP0, _CmpP_iRegP_immP0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IREGP];
        DFA_PRODUCTION(_CMPP_IREGP_IREGP, _CmpP_iRegP_iRegP_rule, c)
    }
}
void  State::_sub_Op_CmpU(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI0];
        DFA_PRODUCTION(_CMPU_IREGI_IMMI0, _CmpU_iRegI_immI0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI];
        DFA_PRODUCTION(_CMPU_IREGI_IREGI, _CmpU_iRegI_iRegI_rule, c)
    }
}
void  State::_sub_Op_CmpUL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML0];
        DFA_PRODUCTION(_CMPUL_IREGL_IMML0, _CmpUL_iRegL_immL0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL];
        DFA_PRODUCTION(_CMPUL_IREGL_IREGL, _CmpUL_iRegL_iRegL_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_R12_IREGI_R13) &&
        (
#line 5350 "src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2194 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_R12_IREGI_R13]+LOAD_COST + STORE_COST + ALU_COST * 10 + BRANCH_COST * 4;
        DFA_PRODUCTION(IREGINOSP, compareAndSwapBAcq_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, compareAndSwapBAcq_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, compareAndSwapBAcq_rule, c)
        DFA_PRODUCTION(IREGI_R12, compareAndSwapBAcq_rule, c)
        DFA_PRODUCTION(IREGI_R13, compareAndSwapBAcq_rule, c)
        DFA_PRODUCTION(IREGI_R14, compareAndSwapBAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_R12_IREGI_R13) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_R12_IREGI_R13]+LOAD_COST + STORE_COST + ALU_COST * 10 + BRANCH_COST * 4;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, compareAndSwapB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, compareAndSwapB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, compareAndSwapB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, compareAndSwapB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, compareAndSwapB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, compareAndSwapB_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndSwapS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_R12_IREGI_R13) &&
        (
#line 5375 "src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2247 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_R12_IREGI_R13]+LOAD_COST + STORE_COST + ALU_COST * 11 + BRANCH_COST * 4;
        DFA_PRODUCTION(IREGINOSP, compareAndSwapSAcq_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, compareAndSwapSAcq_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, compareAndSwapSAcq_rule, c)
        DFA_PRODUCTION(IREGI_R12, compareAndSwapSAcq_rule, c)
        DFA_PRODUCTION(IREGI_R13, compareAndSwapSAcq_rule, c)
        DFA_PRODUCTION(IREGI_R14, compareAndSwapSAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_R12_IREGI_R13) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_R12_IREGI_R13]+LOAD_COST + STORE_COST + ALU_COST * 11 + BRANCH_COST * 4;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, compareAndSwapS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, compareAndSwapS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, compareAndSwapS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, compareAndSwapS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, compareAndSwapS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, compareAndSwapS_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndSwapI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_IREGI) &&
        (
#line 5399 "src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2300 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_IREGI]+LOAD_COST + STORE_COST + ALU_COST * 6 + BRANCH_COST * 4;
        DFA_PRODUCTION(IREGINOSP, compareAndSwapIAcq_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, compareAndSwapIAcq_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, compareAndSwapIAcq_rule, c)
        DFA_PRODUCTION(IREGI_R12, compareAndSwapIAcq_rule, c)
        DFA_PRODUCTION(IREGI_R13, compareAndSwapIAcq_rule, c)
        DFA_PRODUCTION(IREGI_R14, compareAndSwapIAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_IREGI) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_IREGI]+LOAD_COST + STORE_COST + ALU_COST * 6 + BRANCH_COST * 4;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, compareAndSwapI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, compareAndSwapI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, compareAndSwapI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, compareAndSwapI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, compareAndSwapI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, compareAndSwapI_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndSwapL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGL_IREGL) &&
        (
#line 5417 "src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2353 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGL_IREGL]+LOAD_COST + STORE_COST + ALU_COST * 6 + BRANCH_COST * 4;
        DFA_PRODUCTION(IREGINOSP, compareAndSwapLAcq_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, compareAndSwapLAcq_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, compareAndSwapLAcq_rule, c)
        DFA_PRODUCTION(IREGI_R12, compareAndSwapLAcq_rule, c)
        DFA_PRODUCTION(IREGI_R13, compareAndSwapLAcq_rule, c)
        DFA_PRODUCTION(IREGI_R14, compareAndSwapLAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGL_IREGL]+LOAD_COST + STORE_COST + ALU_COST * 6 + BRANCH_COST * 4;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, compareAndSwapL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, compareAndSwapL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, compareAndSwapL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, compareAndSwapL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, compareAndSwapL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, compareAndSwapL_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndSwapP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) &&
        (
#line 113 "src/hotspot/cpu/riscv/gc/z/z_riscv64.ad"
UseZGC && needs_acquiring_load_reserved(n) && (n->as_LoadStore()->barrier_data() == ZLoadBarrierStrong)
#line 2406 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+2 * VOLATILE_REF_COST;
        DFA_PRODUCTION(IREGINOSP, zCompareAndSwapPAcq_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, zCompareAndSwapPAcq_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, zCompareAndSwapPAcq_rule, c)
        DFA_PRODUCTION(IREGI_R12, zCompareAndSwapPAcq_rule, c)
        DFA_PRODUCTION(IREGI_R13, zCompareAndSwapPAcq_rule, c)
        DFA_PRODUCTION(IREGI_R14, zCompareAndSwapPAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) &&
        (
#line 77 "src/hotspot/cpu/riscv/gc/z/z_riscv64.ad"
UseZGC && !needs_acquiring_load_reserved(n) && n->as_LoadStore()->barrier_data() == ZLoadBarrierStrong
#line 2424 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+2 * VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, zCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, zCompareAndSwapP_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) &&
        (
#line 5435 "src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n) && (n->as_LoadStore()->barrier_data() == 0)
#line 2462 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+LOAD_COST + STORE_COST + ALU_COST * 6 + BRANCH_COST * 4;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, compareAndSwapPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, compareAndSwapPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, compareAndSwapPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, compareAndSwapPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, compareAndSwapPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, compareAndSwapPAcq_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) &&
        (
#line 5314 "src/hotspot/cpu/riscv/riscv.ad"
n->as_LoadStore()->barrier_data() == 0
#line 2500 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+LOAD_COST + STORE_COST + ALU_COST * 6 + BRANCH_COST * 4;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, compareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, compareAndSwapP_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndSwapN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGN_IREGN) &&
        (
#line 5453 "src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2540 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGN_IREGN]+LOAD_COST + STORE_COST + ALU_COST * 8 + BRANCH_COST * 4;
        DFA_PRODUCTION(IREGINOSP, compareAndSwapNAcq_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, compareAndSwapNAcq_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, compareAndSwapNAcq_rule, c)
        DFA_PRODUCTION(IREGI_R12, compareAndSwapNAcq_rule, c)
        DFA_PRODUCTION(IREGI_R13, compareAndSwapNAcq_rule, c)
        DFA_PRODUCTION(IREGI_R14, compareAndSwapNAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGN_IREGN) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGN_IREGN]+LOAD_COST + STORE_COST + ALU_COST * 8 + BRANCH_COST * 4;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, compareAndSwapN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, compareAndSwapN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, compareAndSwapN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, compareAndSwapN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, compareAndSwapN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, compareAndSwapN_rule, c)
      }
    }
}
void  State::_sub_Op_WeakCompareAndSwapB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_R12_IREGI_R13) &&
        (
#line 5868 "src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2593 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_R12_IREGI_R13]+LOAD_COST + STORE_COST + BRANCH_COST * 2 + ALU_COST * 6;
        DFA_PRODUCTION(IREGINOSP, weakCompareAndSwapBAcq_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, weakCompareAndSwapBAcq_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, weakCompareAndSwapBAcq_rule, c)
        DFA_PRODUCTION(IREGI_R12, weakCompareAndSwapBAcq_rule, c)
        DFA_PRODUCTION(IREGI_R13, weakCompareAndSwapBAcq_rule, c)
        DFA_PRODUCTION(IREGI_R14, weakCompareAndSwapBAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_R12_IREGI_R13) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_R12_IREGI_R13]+LOAD_COST + STORE_COST + BRANCH_COST * 2 + ALU_COST * 6;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, weakCompareAndSwapB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, weakCompareAndSwapB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, weakCompareAndSwapB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, weakCompareAndSwapB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, weakCompareAndSwapB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, weakCompareAndSwapB_rule, c)
      }
    }
}
void  State::_sub_Op_WeakCompareAndSwapS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_R12_IREGI_R13) &&
        (
#line 5894 "src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2646 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_R12_IREGI_R13]+LOAD_COST + STORE_COST + BRANCH_COST * 2 + ALU_COST * 7;
        DFA_PRODUCTION(IREGINOSP, weakCompareAndSwapSAcq_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, weakCompareAndSwapSAcq_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, weakCompareAndSwapSAcq_rule, c)
        DFA_PRODUCTION(IREGI_R12, weakCompareAndSwapSAcq_rule, c)
        DFA_PRODUCTION(IREGI_R13, weakCompareAndSwapSAcq_rule, c)
        DFA_PRODUCTION(IREGI_R14, weakCompareAndSwapSAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_R12_IREGI_R13) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_R12_IREGI_R13]+LOAD_COST + STORE_COST + BRANCH_COST * 2 + ALU_COST * 7;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, weakCompareAndSwapS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, weakCompareAndSwapS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, weakCompareAndSwapS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, weakCompareAndSwapS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, weakCompareAndSwapS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, weakCompareAndSwapS_rule, c)
      }
    }
}
void  State::_sub_Op_WeakCompareAndSwapI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_IREGI) &&
        (
#line 5919 "src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2699 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_IREGI]+LOAD_COST + STORE_COST + BRANCH_COST * 2 + ALU_COST * 2;
        DFA_PRODUCTION(IREGINOSP, weakCompareAndSwapIAcq_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, weakCompareAndSwapIAcq_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, weakCompareAndSwapIAcq_rule, c)
        DFA_PRODUCTION(IREGI_R12, weakCompareAndSwapIAcq_rule, c)
        DFA_PRODUCTION(IREGI_R13, weakCompareAndSwapIAcq_rule, c)
        DFA_PRODUCTION(IREGI_R14, weakCompareAndSwapIAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_IREGI) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_IREGI]+LOAD_COST + STORE_COST + BRANCH_COST * 2 + ALU_COST * 2;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, weakCompareAndSwapI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, weakCompareAndSwapI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, weakCompareAndSwapI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, weakCompareAndSwapI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, weakCompareAndSwapI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, weakCompareAndSwapI_rule, c)
      }
    }
}
void  State::_sub_Op_WeakCompareAndSwapL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGL_IREGL) &&
        (
#line 5941 "src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2752 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGL_IREGL]+LOAD_COST + STORE_COST + BRANCH_COST * 2 + ALU_COST * 2;
        DFA_PRODUCTION(IREGINOSP, weakCompareAndSwapLAcq_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, weakCompareAndSwapLAcq_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, weakCompareAndSwapLAcq_rule, c)
        DFA_PRODUCTION(IREGI_R12, weakCompareAndSwapLAcq_rule, c)
        DFA_PRODUCTION(IREGI_R13, weakCompareAndSwapLAcq_rule, c)
        DFA_PRODUCTION(IREGI_R14, weakCompareAndSwapLAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGL_IREGL]+LOAD_COST + STORE_COST + BRANCH_COST * 2 + ALU_COST * 2;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, weakCompareAndSwapL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, weakCompareAndSwapL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, weakCompareAndSwapL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, weakCompareAndSwapL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, weakCompareAndSwapL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, weakCompareAndSwapL_rule, c)
      }
    }
}
void  State::_sub_Op_WeakCompareAndSwapP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) &&
        (
#line 113 "src/hotspot/cpu/riscv/gc/z/z_riscv64.ad"
UseZGC && needs_acquiring_load_reserved(n) && (n->as_LoadStore()->barrier_data() == ZLoadBarrierStrong)
#line 2805 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+2 * VOLATILE_REF_COST;
        DFA_PRODUCTION(IREGINOSP, zCompareAndSwapPAcq_0_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, zCompareAndSwapPAcq_0_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, zCompareAndSwapPAcq_0_rule, c)
        DFA_PRODUCTION(IREGI_R12, zCompareAndSwapPAcq_0_rule, c)
        DFA_PRODUCTION(IREGI_R13, zCompareAndSwapPAcq_0_rule, c)
        DFA_PRODUCTION(IREGI_R14, zCompareAndSwapPAcq_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) &&
        (
#line 77 "src/hotspot/cpu/riscv/gc/z/z_riscv64.ad"
UseZGC && !needs_acquiring_load_reserved(n) && n->as_LoadStore()->barrier_data() == ZLoadBarrierStrong
#line 2823 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+2 * VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, zCompareAndSwapP_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, zCompareAndSwapP_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, zCompareAndSwapP_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, zCompareAndSwapP_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, zCompareAndSwapP_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, zCompareAndSwapP_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) &&
        (
#line 5985 "src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n) && (n->as_LoadStore()->barrier_data() == 0)
#line 2861 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+LOAD_COST + STORE_COST + BRANCH_COST * 2 + ALU_COST * 2;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, weakCompareAndSwapPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, weakCompareAndSwapPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, weakCompareAndSwapPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, weakCompareAndSwapPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, weakCompareAndSwapPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, weakCompareAndSwapPAcq_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) &&
        (
#line 5846 "src/hotspot/cpu/riscv/riscv.ad"
n->as_LoadStore()->barrier_data() == 0
#line 2899 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+LOAD_COST + STORE_COST + BRANCH_COST * 2 + ALU_COST * 2;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, weakCompareAndSwapP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, weakCompareAndSwapP_rule, c)
      }
    }
}
void  State::_sub_Op_WeakCompareAndSwapN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGN_IREGN) &&
        (
#line 5963 "src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2939 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGN_IREGN]+LOAD_COST + STORE_COST + BRANCH_COST * 2 + ALU_COST * 4;
        DFA_PRODUCTION(IREGINOSP, weakCompareAndSwapNAcq_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, weakCompareAndSwapNAcq_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, weakCompareAndSwapNAcq_rule, c)
        DFA_PRODUCTION(IREGI_R12, weakCompareAndSwapNAcq_rule, c)
        DFA_PRODUCTION(IREGI_R13, weakCompareAndSwapNAcq_rule, c)
        DFA_PRODUCTION(IREGI_R14, weakCompareAndSwapNAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGN_IREGN) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGN_IREGN]+LOAD_COST + STORE_COST + BRANCH_COST * 2 + ALU_COST * 4;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, weakCompareAndSwapN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, weakCompareAndSwapN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, weakCompareAndSwapN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, weakCompareAndSwapN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, weakCompareAndSwapN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, weakCompareAndSwapN_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndExchangeB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_R12_IREGI_R13) &&
        (
#line 5603 "src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 2992 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_R12_IREGI_R13]+LOAD_COST + STORE_COST + BRANCH_COST * 3 + ALU_COST * 5;
        DFA_PRODUCTION(IREGINOSP, compareAndExchangeBAcq_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, compareAndExchangeBAcq_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, compareAndExchangeBAcq_rule, c)
        DFA_PRODUCTION(IREGI_R12, compareAndExchangeBAcq_rule, c)
        DFA_PRODUCTION(IREGI_R13, compareAndExchangeBAcq_rule, c)
        DFA_PRODUCTION(IREGI_R14, compareAndExchangeBAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_R12_IREGI_R13) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_R12_IREGI_R13]+LOAD_COST + STORE_COST + BRANCH_COST * 3 + ALU_COST * 5;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, compareAndExchangeB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, compareAndExchangeB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, compareAndExchangeB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, compareAndExchangeB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, compareAndExchangeB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, compareAndExchangeB_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndExchangeS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_R12_IREGI_R13) &&
        (
#line 5627 "src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 3045 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_R12_IREGI_R13]+LOAD_COST + STORE_COST + BRANCH_COST * 3 + ALU_COST * 6;
        DFA_PRODUCTION(IREGINOSP, compareAndExchangeSAcq_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, compareAndExchangeSAcq_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, compareAndExchangeSAcq_rule, c)
        DFA_PRODUCTION(IREGI_R12, compareAndExchangeSAcq_rule, c)
        DFA_PRODUCTION(IREGI_R13, compareAndExchangeSAcq_rule, c)
        DFA_PRODUCTION(IREGI_R14, compareAndExchangeSAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_R12_IREGI_R13) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_R12_IREGI_R13]+LOAD_COST + STORE_COST + BRANCH_COST * 3 + ALU_COST * 6;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, compareAndExchangeS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, compareAndExchangeS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, compareAndExchangeS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, compareAndExchangeS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, compareAndExchangeS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, compareAndExchangeS_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndExchangeI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_IREGI) &&
        (
#line 5650 "src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 3098 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_IREGI]+LOAD_COST + STORE_COST + BRANCH_COST * 3 + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, compareAndExchangeIAcq_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, compareAndExchangeIAcq_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, compareAndExchangeIAcq_rule, c)
        DFA_PRODUCTION(IREGI_R12, compareAndExchangeIAcq_rule, c)
        DFA_PRODUCTION(IREGI_R13, compareAndExchangeIAcq_rule, c)
        DFA_PRODUCTION(IREGI_R14, compareAndExchangeIAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_IREGI) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_IREGI]+LOAD_COST + STORE_COST + BRANCH_COST * 3 + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, compareAndExchangeI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, compareAndExchangeI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, compareAndExchangeI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, compareAndExchangeI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, compareAndExchangeI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, compareAndExchangeI_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndExchangeL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGL_IREGL) &&
        (
#line 5672 "src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 3151 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGL_IREGL]+LOAD_COST + STORE_COST + BRANCH_COST * 3 + ALU_COST;
        DFA_PRODUCTION(IREGLNOSP, compareAndExchangeLAcq_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, compareAndExchangeLAcq_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, compareAndExchangeLAcq_rule, c)
        DFA_PRODUCTION(IREGL_R29, compareAndExchangeLAcq_rule, c)
        DFA_PRODUCTION(IREGL_R30, compareAndExchangeLAcq_rule, c)
        DFA_PRODUCTION(IREGL_R10, compareAndExchangeLAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGL_IREGL]+LOAD_COST + STORE_COST + BRANCH_COST * 3 + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, compareAndExchangeL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, compareAndExchangeL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, compareAndExchangeL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, compareAndExchangeL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, compareAndExchangeL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, compareAndExchangeL_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndExchangeP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) &&
        (
#line 176 "src/hotspot/cpu/riscv/gc/z/z_riscv64.ad"
UseZGC && needs_acquiring_load_reserved(n) && n->as_LoadStore()->barrier_data() == ZLoadBarrierStrong
#line 3200 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+2 * VOLATILE_REF_COST;
        DFA_PRODUCTION(IREGPNOSP, zCompareAndExchangePAcq_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c)
        DFA_PRODUCTION(IREGP, zCompareAndExchangePAcq_rule, c)
        DFA_PRODUCTION(JAVATHREAD_REGP, zCompareAndExchangePAcq_rule, c)
        DFA_PRODUCTION(INDIRECT, zCompareAndExchangePAcq_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
        DFA_PRODUCTION(INLINE_CACHE_REGP, zCompareAndExchangePAcq_rule, c)
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
        DFA_PRODUCTION(IREGP_R10, zCompareAndExchangePAcq_rule, c)
        DFA_PRODUCTION(IREGP_R11, zCompareAndExchangePAcq_rule, c)
        DFA_PRODUCTION(IREGP_R12, zCompareAndExchangePAcq_rule, c)
        DFA_PRODUCTION(IREGP_R13, zCompareAndExchangePAcq_rule, c)
        DFA_PRODUCTION(IREGP_R14, zCompareAndExchangePAcq_rule, c)
        DFA_PRODUCTION(IREGP_R15, zCompareAndExchangePAcq_rule, c)
        DFA_PRODUCTION(IREGP_R16, zCompareAndExchangePAcq_rule, c)
        DFA_PRODUCTION(IREGP_R28, zCompareAndExchangePAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) &&
        (
#line 148 "src/hotspot/cpu/riscv/gc/z/z_riscv64.ad"
UseZGC && !needs_acquiring_load_reserved(n) && n->as_LoadStore()->barrier_data() == ZLoadBarrierStrong
#line 3226 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+2 * VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION(IREGPNOSP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(JAVATHREAD_REGP) || _cost[JAVATHREAD_REGP] > c) {
        DFA_PRODUCTION(JAVATHREAD_REGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEMA) || _cost[VMEMA] > c) {
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c) {
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION(IREGP_R10, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R11) || _cost[IREGP_R11] > c) {
        DFA_PRODUCTION(IREGP_R11, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R12) || _cost[IREGP_R12] > c) {
        DFA_PRODUCTION(IREGP_R12, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R13) || _cost[IREGP_R13] > c) {
        DFA_PRODUCTION(IREGP_R13, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R14) || _cost[IREGP_R14] > c) {
        DFA_PRODUCTION(IREGP_R14, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R15) || _cost[IREGP_R15] > c) {
        DFA_PRODUCTION(IREGP_R15, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R16) || _cost[IREGP_R16] > c) {
        DFA_PRODUCTION(IREGP_R16, zCompareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R28) || _cost[IREGP_R28] > c) {
        DFA_PRODUCTION(IREGP_R28, zCompareAndExchangeP_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) &&
        (
#line 5716 "src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n) && (n->as_LoadStore()->barrier_data() == 0)
#line 3288 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+LOAD_COST + STORE_COST + BRANCH_COST * 3 + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION(IREGPNOSP, compareAndExchangePAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, compareAndExchangePAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(JAVATHREAD_REGP) || _cost[JAVATHREAD_REGP] > c) {
        DFA_PRODUCTION(JAVATHREAD_REGP, compareAndExchangePAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, compareAndExchangePAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEMA) || _cost[VMEMA] > c) {
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, compareAndExchangePAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c) {
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION(IREGP_R10, compareAndExchangePAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R11) || _cost[IREGP_R11] > c) {
        DFA_PRODUCTION(IREGP_R11, compareAndExchangePAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R12) || _cost[IREGP_R12] > c) {
        DFA_PRODUCTION(IREGP_R12, compareAndExchangePAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R13) || _cost[IREGP_R13] > c) {
        DFA_PRODUCTION(IREGP_R13, compareAndExchangePAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R14) || _cost[IREGP_R14] > c) {
        DFA_PRODUCTION(IREGP_R14, compareAndExchangePAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R15) || _cost[IREGP_R15] > c) {
        DFA_PRODUCTION(IREGP_R15, compareAndExchangePAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R16) || _cost[IREGP_R16] > c) {
        DFA_PRODUCTION(IREGP_R16, compareAndExchangePAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R28) || _cost[IREGP_R28] > c) {
        DFA_PRODUCTION(IREGP_R28, compareAndExchangePAcq_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) &&
        (
#line 5581 "src/hotspot/cpu/riscv/riscv.ad"
n->as_LoadStore()->barrier_data() == 0
#line 3350 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+LOAD_COST + STORE_COST + BRANCH_COST * 3 + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION(IREGPNOSP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(JAVATHREAD_REGP) || _cost[JAVATHREAD_REGP] > c) {
        DFA_PRODUCTION(JAVATHREAD_REGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEMA) || _cost[VMEMA] > c) {
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c) {
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION(IREGP_R10, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R11) || _cost[IREGP_R11] > c) {
        DFA_PRODUCTION(IREGP_R11, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R12) || _cost[IREGP_R12] > c) {
        DFA_PRODUCTION(IREGP_R12, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R13) || _cost[IREGP_R13] > c) {
        DFA_PRODUCTION(IREGP_R13, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R14) || _cost[IREGP_R14] > c) {
        DFA_PRODUCTION(IREGP_R14, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R15) || _cost[IREGP_R15] > c) {
        DFA_PRODUCTION(IREGP_R15, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R16) || _cost[IREGP_R16] > c) {
        DFA_PRODUCTION(IREGP_R16, compareAndExchangeP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R28) || _cost[IREGP_R28] > c) {
        DFA_PRODUCTION(IREGP_R28, compareAndExchangeP_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndExchangeN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGN_IREGN) &&
        (
#line 5694 "src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 3414 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGN_IREGN]+LOAD_COST + STORE_COST + BRANCH_COST * 3 + ALU_COST;
        DFA_PRODUCTION(IREGNNOSP, compareAndExchangeNAcq_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegNNoSp_rule, c)
        DFA_PRODUCTION(IREGN, compareAndExchangeNAcq_rule, c)
        DFA_PRODUCTION(IREGNORP, iRegN_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegN_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGN_IREGN) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGN_IREGN]+LOAD_COST + STORE_COST + BRANCH_COST * 3 + ALU_COST * 3;
      if (STATE__NOT_YET_VALID(IREGNNOSP) || _cost[IREGNNOSP] > c) {
        DFA_PRODUCTION(IREGNNOSP, compareAndExchangeN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegNNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGN) || _cost[IREGN] > c) {
        DFA_PRODUCTION(IREGN, compareAndExchangeN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c) {
        DFA_PRODUCTION(IREGNORP, iRegN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegN_rule, c)
      }
    }
}
void  State::_sub_Op_GetAndAddI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMIADD) &&
        (
#line 6382 "src/hotspot/cpu/riscv/riscv.ad"
n->as_LoadStore()->result_not_used() && needs_acquiring_load_reserved(n)
#line 3447 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMIADD] + ALU_COST;
        DFA_PRODUCTION(UNIVERSE, get_and_addIi_no_resAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMIADD) &&
        (
#line 6365 "src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 3456 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMIADD] + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, get_and_addIiAcq_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, get_and_addIiAcq_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, get_and_addIiAcq_rule, c)
        DFA_PRODUCTION(IREGI_R12, get_and_addIiAcq_rule, c)
        DFA_PRODUCTION(IREGI_R13, get_and_addIiAcq_rule, c)
        DFA_PRODUCTION(IREGI_R14, get_and_addIiAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) &&
        (
#line 6348 "src/hotspot/cpu/riscv/riscv.ad"
n->as_LoadStore()->result_not_used() && needs_acquiring_load_reserved(n)
#line 3474 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGIORL2I] + ALU_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, get_and_addI_no_resAcq_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) &&
        (
#line 6331 "src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 3485 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGIORL2I] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, get_and_addIAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, get_and_addIAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, get_and_addIAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, get_and_addIAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, get_and_addIAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, get_and_addIAcq_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMIADD) &&
        (
#line 6247 "src/hotspot/cpu/riscv/riscv.ad"
n->as_LoadStore()->result_not_used()
#line 3523 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMIADD] + ALU_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, get_and_addIi_no_res_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMIADD) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMIADD] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, get_and_addIi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, get_and_addIi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, get_and_addIi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, get_and_addIi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, get_and_addIi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, get_and_addIi_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) &&
        (
#line 6215 "src/hotspot/cpu/riscv/riscv.ad"
n->as_LoadStore()->result_not_used()
#line 3567 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGIORL2I] + ALU_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, get_and_addI_no_res_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGIORL2I] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, get_and_addI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, get_and_addI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, get_and_addI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, get_and_addI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, get_and_addI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, get_and_addI_rule, c)
      }
    }
}
void  State::_sub_Op_GetAndAddL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMLADD) &&
        (
#line 6314 "src/hotspot/cpu/riscv/riscv.ad"
n->as_LoadStore()->result_not_used() && needs_acquiring_load_reserved(n)
#line 3613 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMLADD] + ALU_COST;
        DFA_PRODUCTION(UNIVERSE, get_and_addLi_no_resAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMLADD) &&
        (
#line 6297 "src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 3622 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMLADD] + ALU_COST;
        DFA_PRODUCTION(IREGLNOSP, get_and_addLiAcq_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, get_and_addLiAcq_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, get_and_addLiAcq_rule, c)
        DFA_PRODUCTION(IREGL_R29, get_and_addLiAcq_rule, c)
        DFA_PRODUCTION(IREGL_R30, get_and_addLiAcq_rule, c)
        DFA_PRODUCTION(IREGL_R10, get_and_addLiAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 6280 "src/hotspot/cpu/riscv/riscv.ad"
n->as_LoadStore()->result_not_used() && needs_acquiring_load_reserved(n)
#line 3639 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGL] + ALU_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, get_and_addL_no_resAcq_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 6264 "src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 3650 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGL] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, get_and_addLAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, get_and_addLAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, get_and_addLAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, get_and_addLAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, get_and_addLAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, get_and_addLAcq_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMLADD) &&
        (
#line 6183 "src/hotspot/cpu/riscv/riscv.ad"
n->as_LoadStore()->result_not_used()
#line 3685 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMLADD] + ALU_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, get_and_addLi_no_res_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IMMLADD) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IMMLADD] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, get_and_addLi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, get_and_addLi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, get_and_addLi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, get_and_addLi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, get_and_addLi_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, get_and_addLi_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 6151 "src/hotspot/cpu/riscv/riscv.ad"
n->as_LoadStore()->result_not_used()
#line 3726 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGL] + ALU_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, get_and_addL_no_res_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGL] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, get_and_addL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, get_and_addL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, get_and_addL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, get_and_addL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, get_and_addL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, get_and_addL_rule, c)
      }
    }
}
void  State::_sub_Op_GetAndSetI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 6068 "src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 3769 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGI] + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, get_and_setIAcq_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, get_and_setIAcq_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, get_and_setIAcq_rule, c)
        DFA_PRODUCTION(IREGI_R12, get_and_setIAcq_rule, c)
        DFA_PRODUCTION(IREGI_R13, get_and_setIAcq_rule, c)
        DFA_PRODUCTION(IREGI_R14, get_and_setIAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGI] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, get_and_setI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, get_and_setI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, get_and_setI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, get_and_setI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, get_and_setI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, get_and_setI_rule, c)
      }
    }
}
void  State::_sub_Op_GetAndSetL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 6085 "src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 3822 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGL] + ALU_COST;
        DFA_PRODUCTION(IREGLNOSP, get_and_setLAcq_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, get_and_setLAcq_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, get_and_setLAcq_rule, c)
        DFA_PRODUCTION(IREGL_R29, get_and_setLAcq_rule, c)
        DFA_PRODUCTION(IREGL_R30, get_and_setLAcq_rule, c)
        DFA_PRODUCTION(IREGL_R10, get_and_setLAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGL] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, get_and_setL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, get_and_setL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, get_and_setL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, get_and_setL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, get_and_setL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, get_and_setL_rule, c)
      }
    }
}
void  State::_sub_Op_GetAndSetP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGP) &&
        (
#line 221 "src/hotspot/cpu/riscv/gc/z/z_riscv64.ad"
UseZGC && needs_acquiring_load_reserved(n) && (n->as_LoadStore()->barrier_data() != 0)
#line 3871 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGP] + VOLATILE_REF_COST;
        DFA_PRODUCTION(IREGPNOSP, zGetAndSetPAcq_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c)
        DFA_PRODUCTION(IREGP, zGetAndSetPAcq_rule, c)
        DFA_PRODUCTION(JAVATHREAD_REGP, zGetAndSetPAcq_rule, c)
        DFA_PRODUCTION(INDIRECT, zGetAndSetPAcq_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
        DFA_PRODUCTION(INLINE_CACHE_REGP, zGetAndSetPAcq_rule, c)
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
        DFA_PRODUCTION(IREGP_R10, zGetAndSetPAcq_rule, c)
        DFA_PRODUCTION(IREGP_R11, zGetAndSetPAcq_rule, c)
        DFA_PRODUCTION(IREGP_R12, zGetAndSetPAcq_rule, c)
        DFA_PRODUCTION(IREGP_R13, zGetAndSetPAcq_rule, c)
        DFA_PRODUCTION(IREGP_R14, zGetAndSetPAcq_rule, c)
        DFA_PRODUCTION(IREGP_R15, zGetAndSetPAcq_rule, c)
        DFA_PRODUCTION(IREGP_R16, zGetAndSetPAcq_rule, c)
        DFA_PRODUCTION(IREGP_R28, zGetAndSetPAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGP) &&
        (
#line 204 "src/hotspot/cpu/riscv/gc/z/z_riscv64.ad"
UseZGC && !needs_acquiring_load_reserved(n) && n->as_LoadStore()->barrier_data() != 0
#line 3897 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGP]+2 * VOLATILE_REF_COST;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION(IREGPNOSP, zGetAndSetP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, zGetAndSetP_rule, c)
      }
      if (STATE__NOT_YET_VALID(JAVATHREAD_REGP) || _cost[JAVATHREAD_REGP] > c) {
        DFA_PRODUCTION(JAVATHREAD_REGP, zGetAndSetP_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, zGetAndSetP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEMA) || _cost[VMEMA] > c) {
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, zGetAndSetP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c) {
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION(IREGP_R10, zGetAndSetP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R11) || _cost[IREGP_R11] > c) {
        DFA_PRODUCTION(IREGP_R11, zGetAndSetP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R12) || _cost[IREGP_R12] > c) {
        DFA_PRODUCTION(IREGP_R12, zGetAndSetP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R13) || _cost[IREGP_R13] > c) {
        DFA_PRODUCTION(IREGP_R13, zGetAndSetP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R14) || _cost[IREGP_R14] > c) {
        DFA_PRODUCTION(IREGP_R14, zGetAndSetP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R15) || _cost[IREGP_R15] > c) {
        DFA_PRODUCTION(IREGP_R15, zGetAndSetP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R16) || _cost[IREGP_R16] > c) {
        DFA_PRODUCTION(IREGP_R16, zGetAndSetP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R28) || _cost[IREGP_R28] > c) {
        DFA_PRODUCTION(IREGP_R28, zGetAndSetP_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGP) &&
        (
#line 6119 "src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n) && (n->as_LoadStore()->barrier_data() == 0)
#line 3959 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGP] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION(IREGPNOSP, get_and_setPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, get_and_setPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(JAVATHREAD_REGP) || _cost[JAVATHREAD_REGP] > c) {
        DFA_PRODUCTION(JAVATHREAD_REGP, get_and_setPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, get_and_setPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEMA) || _cost[VMEMA] > c) {
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, get_and_setPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c) {
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION(IREGP_R10, get_and_setPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R11) || _cost[IREGP_R11] > c) {
        DFA_PRODUCTION(IREGP_R11, get_and_setPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R12) || _cost[IREGP_R12] > c) {
        DFA_PRODUCTION(IREGP_R12, get_and_setPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R13) || _cost[IREGP_R13] > c) {
        DFA_PRODUCTION(IREGP_R13, get_and_setPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R14) || _cost[IREGP_R14] > c) {
        DFA_PRODUCTION(IREGP_R14, get_and_setPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R15) || _cost[IREGP_R15] > c) {
        DFA_PRODUCTION(IREGP_R15, get_and_setPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R16) || _cost[IREGP_R16] > c) {
        DFA_PRODUCTION(IREGP_R16, get_and_setPAcq_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R28) || _cost[IREGP_R28] > c) {
        DFA_PRODUCTION(IREGP_R28, get_and_setPAcq_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGP) &&
        (
#line 6052 "src/hotspot/cpu/riscv/riscv.ad"
n->as_LoadStore()->barrier_data() == 0
#line 4021 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGP] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION(IREGPNOSP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(JAVATHREAD_REGP) || _cost[JAVATHREAD_REGP] > c) {
        DFA_PRODUCTION(JAVATHREAD_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEMA) || _cost[VMEMA] > c) {
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c) {
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION(IREGP_R10, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R11) || _cost[IREGP_R11] > c) {
        DFA_PRODUCTION(IREGP_R11, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R12) || _cost[IREGP_R12] > c) {
        DFA_PRODUCTION(IREGP_R12, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R13) || _cost[IREGP_R13] > c) {
        DFA_PRODUCTION(IREGP_R13, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R14) || _cost[IREGP_R14] > c) {
        DFA_PRODUCTION(IREGP_R14, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R15) || _cost[IREGP_R15] > c) {
        DFA_PRODUCTION(IREGP_R15, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R16) || _cost[IREGP_R16] > c) {
        DFA_PRODUCTION(IREGP_R16, get_and_setP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R28) || _cost[IREGP_R28] > c) {
        DFA_PRODUCTION(IREGP_R28, get_and_setP_rule, c)
      }
    }
}
void  State::_sub_Op_GetAndSetN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGN) &&
        (
#line 6102 "src/hotspot/cpu/riscv/riscv.ad"
needs_acquiring_load_reserved(n)
#line 4085 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGN] + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, get_and_setNAcq_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, get_and_setNAcq_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, get_and_setNAcq_rule, c)
        DFA_PRODUCTION(IREGI_R12, get_and_setNAcq_rule, c)
        DFA_PRODUCTION(IREGI_R13, get_and_setNAcq_rule, c)
        DFA_PRODUCTION(IREGI_R14, get_and_setNAcq_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], IREGN) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[IREGN] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, get_and_setN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, get_and_setN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, get_and_setN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, get_and_setN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, get_and_setN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, get_and_setN_rule, c)
      }
    }
}
void  State::_sub_Op_ConN(const Node *n){
    if(         
#line 2997 "src/hotspot/cpu/riscv/riscv.ad"
n->get_narrowcon() == 0
#line 4137 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMN0, immN0_rule, c)
        DFA_PRODUCTION(IREGNNOSP, loadConN0_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGN, loadConN0_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGNORP, iRegN_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGILNP, iRegN_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGILNPNOSP, iRegNNoSp_rule, c+ALU_COST)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMN, immN_rule, c)
      if (STATE__NOT_YET_VALID(IREGNNOSP) || _cost[IREGNNOSP] > c+ALU_COST * 4) {
        DFA_PRODUCTION(IREGNNOSP, loadConN_rule, c+ALU_COST * 4)
      }
      if (STATE__NOT_YET_VALID(IREGN) || _cost[IREGN] > c+ALU_COST * 4) {
        DFA_PRODUCTION(IREGN, loadConN_rule, c+ALU_COST * 4)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c+ALU_COST * 4) {
        DFA_PRODUCTION(IREGNORP, iRegN_rule, c+ALU_COST * 4)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c+ALU_COST * 4) {
        DFA_PRODUCTION(IREGILNP, iRegN_rule, c+ALU_COST * 4)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c+ALU_COST * 4) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegNNoSp_rule, c+ALU_COST * 4)
      }
    }
   if ( /* IREGNNOSP KNOWN_VALID || */ _cost[IREGNNOSP] > ALU_COST * 4) {
     DFA_PRODUCTION(IREGNNOSP, loadConN_rule, ALU_COST * 4)
   }
   if ( /* IREGN KNOWN_VALID || */ _cost[IREGN] > ALU_COST * 4) {
     DFA_PRODUCTION(IREGN, loadConN_rule, ALU_COST * 4)
   }
   if ( /* IREGNORP KNOWN_VALID || */ _cost[IREGNORP] > ALU_COST * 4) {
     DFA_PRODUCTION(IREGNORP, iRegN_rule, ALU_COST * 4)
   }
   if ( /* IREGILNP KNOWN_VALID || */ _cost[IREGILNP] > ALU_COST * 4) {
     DFA_PRODUCTION(IREGILNP, iRegN_rule, ALU_COST * 4)
   }
   if ( /* IREGILNPNOSP KNOWN_VALID || */ _cost[IREGILNPNOSP] > ALU_COST * 4) {
     DFA_PRODUCTION(IREGILNPNOSP, iRegNNoSp_rule, ALU_COST * 4)
   }
}
void  State::_sub_Op_ConNKlass(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMNKLASS, immNKlass_rule, c)
        DFA_PRODUCTION(IREGNNOSP, loadConNKlass_rule, c+ALU_COST * 6)
        DFA_PRODUCTION(IREGN, loadConNKlass_rule, c+ALU_COST * 6)
        DFA_PRODUCTION(IREGNORP, iRegN_rule, c+ALU_COST * 6)
        DFA_PRODUCTION(IREGILNP, iRegN_rule, c+ALU_COST * 6)
        DFA_PRODUCTION(IREGILNPNOSP, iRegNNoSp_rule, c+ALU_COST * 6)
    }
   if ( /* IREGNNOSP KNOWN_VALID || */ _cost[IREGNNOSP] > ALU_COST * 6) {
     DFA_PRODUCTION(IREGNNOSP, loadConNKlass_rule, ALU_COST * 6)
   }
   if ( /* IREGN KNOWN_VALID || */ _cost[IREGN] > ALU_COST * 6) {
     DFA_PRODUCTION(IREGN, loadConNKlass_rule, ALU_COST * 6)
   }
   if ( /* IREGNORP KNOWN_VALID || */ _cost[IREGNORP] > ALU_COST * 6) {
     DFA_PRODUCTION(IREGNORP, iRegN_rule, ALU_COST * 6)
   }
   if ( /* IREGILNP KNOWN_VALID || */ _cost[IREGILNP] > ALU_COST * 6) {
     DFA_PRODUCTION(IREGILNP, iRegN_rule, ALU_COST * 6)
   }
   if ( /* IREGILNPNOSP KNOWN_VALID || */ _cost[IREGILNPNOSP] > ALU_COST * 6) {
     DFA_PRODUCTION(IREGILNPNOSP, iRegNNoSp_rule, ALU_COST * 6)
   }
}
void  State::_sub_Op_ConD(const Node *n){
    if(         
#line 3027 "src/hotspot/cpu/riscv/riscv.ad"
jlong_cast(n->getd()) == 0
#line 4212 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMD0, immD0_rule, c)
        DFA_PRODUCTION(FREGD, loadConD0_rule, c+XFER_COST)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMD, immD_rule, c)
      if (STATE__NOT_YET_VALID(FREGD) || _cost[FREGD] > c+LOAD_COST) {
        DFA_PRODUCTION(FREGD, loadConD_rule, c+LOAD_COST)
      }
    }
}
void  State::_sub_Op_ConF(const Node *n){
    if(         
#line 3047 "src/hotspot/cpu/riscv/riscv.ad"
jint_cast(n->getf()) == 0
#line 4230 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMF0, immF0_rule, c)
        DFA_PRODUCTION(FREGF, loadConF0_rule, c+XFER_COST)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMF, immF_rule, c)
      if (STATE__NOT_YET_VALID(FREGF) || _cost[FREGF] > c+LOAD_COST) {
        DFA_PRODUCTION(FREGF, loadConF_rule, c+LOAD_COST)
      }
    }
}
void  State::_sub_Op_ConI(const Node *n){
    int _n_get_int__ = n->get_int();
    if(         
#line 3076 "src/hotspot/cpu/riscv/riscv.ad"
1 <= _n_get_int__ && (_n_get_int__ <= 3)
#line 4249 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMISCALE, immIScale_rule, c)
    }
    if(         
#line 3057 "src/hotspot/cpu/riscv/riscv.ad"
is_imm_in_range(_n_get_int__, 12, 0)
#line 4257 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMIOFFSET, immIOffset_rule, c)
    }
    if(         
#line 2921 "src/hotspot/cpu/riscv/riscv.ad"
_n_get_int__ == 0xFFFF
#line 4265 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMI_16BITS, immI_16bits_rule, c)
    }
    if(         
#line 2829 "src/hotspot/cpu/riscv/riscv.ad"
_n_get_int__ <= 15 && _n_get_int__ >= -16
#line 4273 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMI5, immI5_rule, c)
    }
    if(         
#line 2819 "src/hotspot/cpu/riscv/riscv.ad"
Assembler::operand_valid_for_add_immediate(-(int64_t)n->get_int())
#line 4281 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMISUB, immISub_rule, c)
    }
    if(         
#line 2809 "src/hotspot/cpu/riscv/riscv.ad"
Assembler::operand_valid_for_add_immediate((int64_t)n->get_int())
#line 4289 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMIADD, immIAdd_rule, c)
    }
    if(         
#line 2798 "src/hotspot/cpu/riscv/riscv.ad"
_n_get_int__ == 63
#line 4297 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMI_63, immI_63_rule, c)
    }
    if(         
#line 2788 "src/hotspot/cpu/riscv/riscv.ad"
_n_get_int__ == 31
#line 4305 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMI_31, immI_31_rule, c)
    }
    if(         
#line 2779 "src/hotspot/cpu/riscv/riscv.ad"
_n_get_int__ == 24
#line 4313 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMI_24, immI_24_rule, c)
    }
    if(         
#line 2770 "src/hotspot/cpu/riscv/riscv.ad"
_n_get_int__ == 16
#line 4321 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMI_16, immI_16_rule, c)
    }
    if(         
#line 2760 "src/hotspot/cpu/riscv/riscv.ad"
_n_get_int__ <= 4
#line 4329 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMI_LE_4, immI_le_4_rule, c)
    }
    if(         
#line 2751 "src/hotspot/cpu/riscv/riscv.ad"
((unsigned int)(_n_get_int__) < 64) && (_n_get_int__ >= 32)
#line 4337 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(UIMMI6_GE32, uimmI6_ge32_rule, c)
    }
    if(         
#line 2741 "src/hotspot/cpu/riscv/riscv.ad"
_n_get_int__ == -1
#line 4345 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMI_M1, immI_M1_rule, c)
    }
    if(         
#line 2730 "src/hotspot/cpu/riscv/riscv.ad"
_n_get_int__ == 1
#line 4353 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMI_1, immI_1_rule, c)
    }
    if(         
#line 2719 "src/hotspot/cpu/riscv/riscv.ad"
_n_get_int__ == 0
#line 4361 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMI0, immI0_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMI, immI_rule, c)
        DFA_PRODUCTION(IMMIORL, immI_rule, c)
        DFA_PRODUCTION(IREGINOSP, loadConI_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGI, loadConI_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGI_R10, loadConI_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGI_R12, loadConI_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGI_R13, loadConI_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGI_R14, loadConI_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c+ALU_COST)
    }
}
void  State::_sub_Op_ConL(const Node *n){
    jlong _n_get_long__ = n->get_long();
    if(         
#line 3066 "src/hotspot/cpu/riscv/riscv.ad"
is_imm_in_range(_n_get_long__, 12, 0)
#line 4387 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMLOFFSET, immLOffset_rule, c)
    }
    if(         
#line 2976 "src/hotspot/cpu/riscv/riscv.ad"
Assembler::operand_valid_for_add_immediate(-(_n_get_long__))
#line 4395 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMLSUB, immLSub_rule, c)
    }
    if(         
#line 2966 "src/hotspot/cpu/riscv/riscv.ad"
Assembler::operand_valid_for_add_immediate(_n_get_long__)
#line 4403 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMLADD, immLAdd_rule, c)
    }
    if(         
#line 2954 "src/hotspot/cpu/riscv/riscv.ad"
_n_get_long__ == in_bytes(JavaThread::frame_anchor_offset()) +
                             in_bytes(JavaFrameAnchor::last_Java_pc_offset())
#line 4412 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMML_PC_OFF, immL_pc_off_rule, c)
    }
    if(         
#line 2941 "src/hotspot/cpu/riscv/riscv.ad"
_n_get_long__ == -1
#line 4420 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMML_M1, immL_M1_rule, c)
    }
    if(         
#line 2931 "src/hotspot/cpu/riscv/riscv.ad"
_n_get_long__ == 0xFFFFFFFFL
#line 4428 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMML_32BITS, immL_32bits_rule, c)
    }
    if(         
#line 2862 "src/hotspot/cpu/riscv/riscv.ad"
_n_get_long__ == 0
#line 4436 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMML0, immL0_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IMML, immL_rule, c)
        DFA_PRODUCTION(IMMIORL, immL_rule, c)
        DFA_PRODUCTION(IREGLNOSP, loadConL_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGL, loadConL_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGL_R28, loadConL_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGL_R29, loadConL_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGL_R30, loadConL_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGL_R10, loadConL_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c+ALU_COST)
    }
    if(         
#line 2840 "src/hotspot/cpu/riscv/riscv.ad"
_n_get_long__ <= 15 && _n_get_long__ >= -16
#line 4458 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMML5, immL5_rule, c)
    }
}
void  State::_sub_Op_ConP(const Node *n){
    if(         
#line 2908 "src/hotspot/cpu/riscv/riscv.ad"
BarrierSet::barrier_set()->is_a(BarrierSet::CardTableBarrierSet) &&
            (CardTable::CardValue*)n->get_ptr() ==
             ((CardTableBarrierSet*)(BarrierSet::barrier_set()))->card_table()->byte_map_base()
#line 4470 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMBYTEMAPBASE, immByteMapBase_rule, c)
        DFA_PRODUCTION(IREGPNOSP, loadByteMapBase_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGP, loadByteMapBase_rule, c+ALU_COST)
        DFA_PRODUCTION(JAVATHREAD_REGP, loadByteMapBase_rule, c+ALU_COST)
        DFA_PRODUCTION(INDIRECT, loadByteMapBase_rule, c+ALU_COST)
        DFA_PRODUCTION(MEMORY, indirect_rule, c+ALU_COST)
        DFA_PRODUCTION(VMEMA, indirect_rule, c+ALU_COST)
        DFA_PRODUCTION(INLINE_CACHE_REGP, loadByteMapBase_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGP_R10, loadByteMapBase_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGP_R11, loadByteMapBase_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGP_R12, loadByteMapBase_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGP_R13, loadByteMapBase_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGP_R14, loadByteMapBase_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGP_R15, loadByteMapBase_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGP_R16, loadByteMapBase_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGP_R28, loadByteMapBase_rule, c+ALU_COST)
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c+ALU_COST)
    }
    if(         
#line 2896 "src/hotspot/cpu/riscv/riscv.ad"
n->get_ptr() == 1
#line 4496 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMP_1, immP_1_rule, c)
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c+ALU_COST) {
        DFA_PRODUCTION(IREGPNOSP, loadConP1_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP, loadConP1_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(JAVATHREAD_REGP) || _cost[JAVATHREAD_REGP] > c+ALU_COST) {
        DFA_PRODUCTION(JAVATHREAD_REGP, loadConP1_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+ALU_COST) {
        DFA_PRODUCTION(INDIRECT, loadConP1_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+ALU_COST) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(VMEMA) || _cost[VMEMA] > c+ALU_COST) {
        DFA_PRODUCTION(VMEMA, indirect_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+ALU_COST) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, loadConP1_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c+ALU_COST) {
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c+ALU_COST) {
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP_R10, loadConP1_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R11) || _cost[IREGP_R11] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP_R11, loadConP1_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R12) || _cost[IREGP_R12] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP_R12, loadConP1_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R13) || _cost[IREGP_R13] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP_R13, loadConP1_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R14) || _cost[IREGP_R14] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP_R14, loadConP1_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R15) || _cost[IREGP_R15] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP_R15, loadConP1_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R16) || _cost[IREGP_R16] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP_R16, loadConP1_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R28) || _cost[IREGP_R28] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP_R28, loadConP1_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c+ALU_COST) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c+ALU_COST)
      }
    }
    if(         
#line 2884 "src/hotspot/cpu/riscv/riscv.ad"
n->get_ptr() == 0
#line 4558 "dfa_riscv.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMP0, immP0_rule, c)
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c+ALU_COST) {
        DFA_PRODUCTION(IREGPNOSP, loadConP0_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP, loadConP0_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(JAVATHREAD_REGP) || _cost[JAVATHREAD_REGP] > c+ALU_COST) {
        DFA_PRODUCTION(JAVATHREAD_REGP, loadConP0_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+ALU_COST) {
        DFA_PRODUCTION(INDIRECT, loadConP0_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+ALU_COST) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(VMEMA) || _cost[VMEMA] > c+ALU_COST) {
        DFA_PRODUCTION(VMEMA, indirect_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+ALU_COST) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, loadConP0_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c+ALU_COST) {
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c+ALU_COST) {
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP_R10, loadConP0_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R11) || _cost[IREGP_R11] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP_R11, loadConP0_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R12) || _cost[IREGP_R12] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP_R12, loadConP0_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R13) || _cost[IREGP_R13] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP_R13, loadConP0_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R14) || _cost[IREGP_R14] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP_R14, loadConP0_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R15) || _cost[IREGP_R15] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP_R15, loadConP0_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R16) || _cost[IREGP_R16] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP_R16, loadConP0_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R28) || _cost[IREGP_R28] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP_R28, loadConP0_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c+ALU_COST) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c+ALU_COST)
      }
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IMMP, immP_rule, c)
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c+ALU_COST) {
        DFA_PRODUCTION(IREGPNOSP, loadConP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP, loadConP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(JAVATHREAD_REGP) || _cost[JAVATHREAD_REGP] > c+ALU_COST) {
        DFA_PRODUCTION(JAVATHREAD_REGP, loadConP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+ALU_COST) {
        DFA_PRODUCTION(INDIRECT, loadConP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+ALU_COST) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(VMEMA) || _cost[VMEMA] > c+ALU_COST) {
        DFA_PRODUCTION(VMEMA, indirect_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c+ALU_COST) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, loadConP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c+ALU_COST) {
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c+ALU_COST) {
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP_R10, loadConP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R11) || _cost[IREGP_R11] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP_R11, loadConP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R12) || _cost[IREGP_R12] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP_R12, loadConP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R13) || _cost[IREGP_R13] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP_R13, loadConP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R14) || _cost[IREGP_R14] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP_R14, loadConP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R15) || _cost[IREGP_R15] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP_R15, loadConP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R16) || _cost[IREGP_R16] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP_R16, loadConP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGP_R28) || _cost[IREGP_R28] > c+ALU_COST) {
        DFA_PRODUCTION(IREGP_R28, loadConP_rule, c+ALU_COST)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c+ALU_COST) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c+ALU_COST)
      }
    }
}
void  State::_sub_Op_Conv2B(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP] + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, convP2Bool_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, convP2Bool_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, convP2Bool_rule, c)
        DFA_PRODUCTION(IREGI_R12, convP2Bool_rule, c)
        DFA_PRODUCTION(IREGI_R13, convP2Bool_rule, c)
        DFA_PRODUCTION(IREGI_R14, convP2Bool_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, convI2Bool_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, convI2Bool_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, convI2Bool_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, convI2Bool_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, convI2Bool_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, convI2Bool_rule, c)
      }
    }
}
void  State::_sub_Op_ConvD2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD] + XFER_COST;
        DFA_PRODUCTION(FREGF, convD2F_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _SQRTD__CONVF2D_FREGF__) ) {
      unsigned int c = _kids[0]->_cost[_SQRTD__CONVF2D_FREGF__] + FSQRT_COST;
      if (STATE__NOT_YET_VALID(FREGF) || _cost[FREGF] > c) {
        DFA_PRODUCTION(FREGF, sqrtF_reg_rule, c)
      }
    }
}
void  State::_sub_Op_ConvD2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD] + XFER_COST;
        DFA_PRODUCTION(IREGINOSP, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(IREGI_R12, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(IREGI_R13, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION(IREGI_R14, convD2I_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvD2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD] + XFER_COST;
        DFA_PRODUCTION(IREGLNOSP, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION(IREGL_R29, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION(IREGL_R30, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION(IREGL_R10, convD2L_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvF2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF] + XFER_COST;
        DFA_PRODUCTION(FREGD, convF2D_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF];
        DFA_PRODUCTION(_CONVF2D_FREGF_, _ConvF2D_fRegF__rule, c)
    }
}
void  State::_sub_Op_ConvF2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF] + XFER_COST;
        DFA_PRODUCTION(IREGINOSP, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(IREGI_R12, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(IREGI_R13, convF2I_reg_reg_rule, c)
        DFA_PRODUCTION(IREGI_R14, convF2I_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvF2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF] + XFER_COST;
        DFA_PRODUCTION(IREGLNOSP, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION(IREGL_R29, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION(IREGL_R30, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION(IREGL_R10, convF2L_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvI2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + XFER_COST;
        DFA_PRODUCTION(FREGD, convI2D_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvI2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + XFER_COST;
        DFA_PRODUCTION(FREGF, convI2F_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvI2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I];
        DFA_PRODUCTION(_CONVI2L_IREGIORL2I_, _ConvI2L_iRegIorL2I__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + ALU_COST;
        DFA_PRODUCTION(IREGLNOSP, convI2L_reg_reg_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, convI2L_reg_reg_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, convI2L_reg_reg_rule, c)
        DFA_PRODUCTION(IREGL_R29, convI2L_reg_reg_rule, c)
        DFA_PRODUCTION(IREGL_R30, convI2L_reg_reg_rule, c)
        DFA_PRODUCTION(IREGL_R10, convI2L_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI];
        DFA_PRODUCTION(_CONVI2L_IREGI_, _ConvI2L_iRegI__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION(_CONVI2L__LOADI_MEMORY__, _ConvI2L__LoadI_memory___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_] + LOAD_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, loadI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_MEMORY_] + LOAD_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, loadUS2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_] + LOAD_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, loadS2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUB_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADUB_MEMORY_] + LOAD_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, loadUB2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_] + LOAD_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, loadB2L_rule, c)
      }
    }
}
void  State::_sub_Op_ConvL2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + XFER_COST;
        DFA_PRODUCTION(FREGD, convL2D_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvL2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + XFER_COST;
        DFA_PRODUCTION(FREGF, convL2F_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ConvL2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X_IREGP_) &&
        (
#line 106 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZba
#line 5009 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X_IREGP_] + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, convP2I_b_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, convP2I_b_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, convP2I_b_rule, c)
        DFA_PRODUCTION(IREGI_R12, convP2I_b_rule, c)
        DFA_PRODUCTION(IREGI_R13, convP2I_b_rule, c)
        DFA_PRODUCTION(IREGI_R14, convP2I_b_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X__DECODEN_IREGN__) &&
        (
#line 8183 "src/hotspot/cpu/riscv/riscv.ad"
CompressedOops::shift() == 0
#line 5027 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X__DECODEN_IREGN__] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, convN2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, convN2I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X_IREGP_) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X_IREGP_]+ALU_COST * 2;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, convP2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, convP2I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, convL2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, convL2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, convL2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, convL2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, convL2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, convL2I_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL];
        DFA_PRODUCTION(_CONVL2I_IREGL_, _ConvL2I_iRegL__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL];
        DFA_PRODUCTION(IREGL2I, iRegL2I_rule, c)
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegL2I_rule, c)
      }
    }
}
void  State::_sub_Op_CountedLoopEnd(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], CMPOPEQNE) && STATE__VALID_CHILD(_kids[1], _CMPP__DECODEN_IREGN__IMMP0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPEQNE]+_kids[1]->_cost[_CMPP__DECODEN_IREGN__IMMP0]+BRANCH_COST * 2;
        DFA_PRODUCTION(UNIVERSE, far_cmpP_narrowOop_imm0_loop_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPEQNE) && STATE__VALID_CHILD(_kids[1], _CMPN_IREGN_IMMN0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPEQNE]+_kids[1]->_cost[_CMPN_IREGN_IMMN0]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpN_imm0_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPEQNE) && STATE__VALID_CHILD(_kids[1], _CMPP_IREGP_IMMP0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPEQNE]+_kids[1]->_cost[_CMPP_IREGP_IMMP0]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpP_imm0_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPULTGE) && STATE__VALID_CHILD(_kids[1], _CMPUL_IREGL_IMML0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPULTGE]+_kids[1]->_cost[_CMPUL_IREGL_IMML0] + BRANCH_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpULLtGe_reg_imm0_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPUEQNELEGT) && STATE__VALID_CHILD(_kids[1], _CMPUL_IREGL_IMML0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUEQNELEGT]+_kids[1]->_cost[_CMPUL_IREGL_IMML0]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpULEqNeLeGt_reg_imm0_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPL_IREGL_IMML0) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPL_IREGL_IMML0]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpL_reg_imm0_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPULTGE) && STATE__VALID_CHILD(_kids[1], _CMPU_IREGI_IMMI0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPULTGE]+_kids[1]->_cost[_CMPU_IREGI_IMMI0] + BRANCH_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpULtGe_reg_imm0_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPUEQNELEGT) && STATE__VALID_CHILD(_kids[1], _CMPU_IREGI_IMMI0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUEQNELEGT]+_kids[1]->_cost[_CMPU_IREGI_IMMI0]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpUEqNeLeGt_reg_imm0_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPI_IREGI_IMMI0) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPI_IREGI_IMMI0]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpI_reg_imm0_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPD_FREGD_FREGD) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPD_FREGD_FREGD]+XFER_COST + BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpD_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPF_FREGF_FREGF) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPF_FREGF_FREGF]+XFER_COST + BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpF_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPN_IREGN_IREGN) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPN_IREGN_IREGN]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpN_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPP_IREGP_IREGP) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPP_IREGP_IREGP]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpP_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPUL_IREGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPUL_IREGL_IREGL]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpUL_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPL_IREGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPL_IREGL_IREGL]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpLloop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPU_IREGI_IREGI) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPU_IREGI_IREGI]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpU_loop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPI_IREGI_IREGI) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPI_IREGI_IREGI]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpI_loop_rule, c)
      }
    }
}
void  State::_sub_Op_CountLeadingZerosI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 312 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 5246 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, countLeadingZerosI_b_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, countLeadingZerosI_b_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, countLeadingZerosI_b_rule, c)
        DFA_PRODUCTION(IREGI_R12, countLeadingZerosI_b_rule, c)
        DFA_PRODUCTION(IREGI_R13, countLeadingZerosI_b_rule, c)
        DFA_PRODUCTION(IREGI_R14, countLeadingZerosI_b_rule, c)
    }
}
void  State::_sub_Op_CountLeadingZerosL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) &&
        (
#line 326 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 5266 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, countLeadingZerosL_b_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, countLeadingZerosL_b_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, countLeadingZerosL_b_rule, c)
        DFA_PRODUCTION(IREGI_R12, countLeadingZerosL_b_rule, c)
        DFA_PRODUCTION(IREGI_R13, countLeadingZerosL_b_rule, c)
        DFA_PRODUCTION(IREGI_R14, countLeadingZerosL_b_rule, c)
    }
}
void  State::_sub_Op_CountTrailingZerosI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 340 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 5286 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, countTrailingZerosI_b_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, countTrailingZerosI_b_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, countTrailingZerosI_b_rule, c)
        DFA_PRODUCTION(IREGI_R12, countTrailingZerosI_b_rule, c)
        DFA_PRODUCTION(IREGI_R13, countTrailingZerosI_b_rule, c)
        DFA_PRODUCTION(IREGI_R14, countTrailingZerosI_b_rule, c)
    }
}
void  State::_sub_Op_CountTrailingZerosL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) &&
        (
#line 354 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 5306 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, countTrailingZerosL_b_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, countTrailingZerosL_b_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, countTrailingZerosL_b_rule, c)
        DFA_PRODUCTION(IREGI_R12, countTrailingZerosL_b_rule, c)
        DFA_PRODUCTION(IREGI_R13, countTrailingZerosL_b_rule, c)
        DFA_PRODUCTION(IREGI_R14, countTrailingZerosL_b_rule, c)
    }
}
void  State::_sub_Op_CreateEx(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(IREGP_R10, CreateException_rule, c)
        DFA_PRODUCTION(IREGP, CreateException_rule, c)
        DFA_PRODUCTION(JAVATHREAD_REGP, CreateException_rule, c)
        DFA_PRODUCTION(INDIRECT, CreateException_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
        DFA_PRODUCTION(INLINE_CACHE_REGP, CreateException_rule, c)
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
    }
}
void  State::_sub_Op_DecodeN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGN) &&
        (
#line 8226 "src/hotspot/cpu/riscv/riscv.ad"
n->bottom_type()->is_ptr()->ptr() == TypePtr::NotNull ||
            n->bottom_type()->is_ptr()->ptr() == TypePtr::Constant
#line 5341 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGN];
        DFA_PRODUCTION(IREGPNOSP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c)
        DFA_PRODUCTION(IREGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(JAVATHREAD_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(INDIRECT, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
        DFA_PRODUCTION(INLINE_CACHE_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
        DFA_PRODUCTION(IREGP_R10, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(IREGP_R11, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(IREGP_R12, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(IREGP_R13, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(IREGP_R14, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(IREGP_R15, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(IREGP_R16, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION(IREGP_R28, decodeHeapOop_not_null_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) &&
        (
#line 8211 "src/hotspot/cpu/riscv/riscv.ad"
n->bottom_type()->is_ptr()->ptr() != TypePtr::NotNull &&
            n->bottom_type()->is_ptr()->ptr() != TypePtr::Constant
#line 5368 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGN];
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION(IREGPNOSP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(JAVATHREAD_REGP) || _cost[JAVATHREAD_REGP] > c) {
        DFA_PRODUCTION(JAVATHREAD_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEMA) || _cost[VMEMA] > c) {
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c) {
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION(IREGP_R10, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R11) || _cost[IREGP_R11] > c) {
        DFA_PRODUCTION(IREGP_R11, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R12) || _cost[IREGP_R12] > c) {
        DFA_PRODUCTION(IREGP_R12, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R13) || _cost[IREGP_R13] > c) {
        DFA_PRODUCTION(IREGP_R13, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R14) || _cost[IREGP_R14] > c) {
        DFA_PRODUCTION(IREGP_R14, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R15) || _cost[IREGP_R15] > c) {
        DFA_PRODUCTION(IREGP_R15, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R16) || _cost[IREGP_R16] > c) {
        DFA_PRODUCTION(IREGP_R16, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R28) || _cost[IREGP_R28] > c) {
        DFA_PRODUCTION(IREGP_R28, decodeHeapOop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) ) {
      unsigned int c = _kids[0]->_cost[IREGN];
        DFA_PRODUCTION(_DECODEN_IREGN_, _DecodeN_iRegN__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGN) &&
        
#line 3500 "src/hotspot/cpu/riscv/riscv.ad"
CompressedOops::shift() == 0
#line 5434 "dfa_riscv.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[IREGN];
        DFA_PRODUCTION(INDIRECTN, indirectN_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirectN_rule, c)
      }
    }
}
void  State::_sub_Op_DecodeNKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGN) ) {
      unsigned int c = _kids[0]->_cost[IREGN] + ALU_COST;
        DFA_PRODUCTION(IREGPNOSP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c)
        DFA_PRODUCTION(IREGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(JAVATHREAD_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(INDIRECT, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
        DFA_PRODUCTION(INLINE_CACHE_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
        DFA_PRODUCTION(IREGP_R10, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(IREGP_R11, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(IREGP_R12, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(IREGP_R13, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(IREGP_R14, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(IREGP_R15, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(IREGP_R16, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION(IREGP_R28, decodeKlass_not_null_rule, c)
    }
}
void  State::_sub_Op_DivD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[FREGD] + FDIV_COST;
        DFA_PRODUCTION(FREGD, divD_reg_reg_rule, c)
    }
}
void  State::_sub_Op_DivF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[FREGF] + FDIV_COST;
        DFA_PRODUCTION(FREGF, divF_reg_reg_rule, c)
    }
}
void  State::_sub_Op_DivI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I] + IDIVSI_COST;
        DFA_PRODUCTION(IREGINOSP, divI_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, divI_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, divI_rule, c)
        DFA_PRODUCTION(IREGI_R12, divI_rule, c)
        DFA_PRODUCTION(IREGI_R13, divI_rule, c)
        DFA_PRODUCTION(IREGI_R14, divI_rule, c)
    }
}
void  State::_sub_Op_DivL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + IDIVDI_COST;
        DFA_PRODUCTION(IREGLNOSP, divL_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, divL_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, divL_rule, c)
        DFA_PRODUCTION(IREGL_R29, divL_rule, c)
        DFA_PRODUCTION(IREGL_R30, divL_rule, c)
        DFA_PRODUCTION(IREGL_R10, divL_rule, c)
    }
}
void  State::_sub_Op_EncodeISOArray(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP_R12) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R11_IREGI_R13) &&
        (
#line 1956 "src/hotspot/cpu/riscv/riscv_v.ad"
UseRVV
#line 5512 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R12]+_kids[1]->_cost[_BINARY_IREGP_R11_IREGI_R13] + DEFAULT_COST;
        DFA_PRODUCTION(IREGI_R10, vencode_iso_array_rule, c)
    }
}
void  State::_sub_Op_EncodeP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP] + ALU_COST;
        DFA_PRODUCTION(IREGNNOSP, encodeHeapOop_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegNNoSp_rule, c)
        DFA_PRODUCTION(IREGN, encodeHeapOop_rule, c)
        DFA_PRODUCTION(IREGNORP, iRegN_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegN_rule, c)
    }
}
void  State::_sub_Op_EncodePKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP] + ALU_COST;
        DFA_PRODUCTION(IREGNNOSP, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegNNoSp_rule, c)
        DFA_PRODUCTION(IREGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION(IREGNORP, iRegN_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegN_rule, c)
    }
}
void  State::_sub_Op_FastLock(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IREGP]+LOAD_COST * 2 + STORE_COST * 3 + ALU_COST * 6 + BRANCH_COST * 3;
        DFA_PRODUCTION(RFLAGSREG, cmpFastLock_rule, c)
    }
}
void  State::_sub_Op_FastUnlock(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) && STATE__VALID_CHILD(_kids[1], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+_kids[1]->_cost[IREGP]+LOAD_COST * 2 + STORE_COST + ALU_COST * 2 + BRANCH_COST * 4;
        DFA_PRODUCTION(RFLAGSREG, cmpFastUnlock_rule, c)
    }
}
void  State::_sub_Op_FmaD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _NEGD_FREGD_) && STATE__VALID_CHILD(_kids[1], _BINARY_FREGD__NEGD_FREGD_) &&
        (
#line 7235 "src/hotspot/cpu/riscv/riscv.ad"
UseFMA
#line 5555 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGD_FREGD_]+_kids[1]->_cost[_BINARY_FREGD__NEGD_FREGD_] + FMUL_DOUBLE_COST;
        DFA_PRODUCTION(FREGD, nmaddD_reg_reg_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGD_FREGD_) && STATE__VALID_CHILD(_kids[1], _BINARY__NEGD_FREGD__FREGD) &&
        (
#line 7235 "src/hotspot/cpu/riscv/riscv.ad"
UseFMA
#line 5564 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGD_FREGD_]+_kids[1]->_cost[_BINARY__NEGD_FREGD__FREGD] + FMUL_DOUBLE_COST;
      if (STATE__NOT_YET_VALID(FREGD) || _cost[FREGD] > c) {
        DFA_PRODUCTION(FREGD, nmaddD_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], _BINARY_FREGD__NEGD_FREGD_) &&
        (
#line 7197 "src/hotspot/cpu/riscv/riscv.ad"
UseFMA
#line 5575 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[_BINARY_FREGD__NEGD_FREGD_] + FMUL_DOUBLE_COST;
      if (STATE__NOT_YET_VALID(FREGD) || _cost[FREGD] > c) {
        DFA_PRODUCTION(FREGD, nmsubD_reg_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], _BINARY__NEGD_FREGD__FREGD) &&
        (
#line 7197 "src/hotspot/cpu/riscv/riscv.ad"
UseFMA
#line 5586 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[_BINARY__NEGD_FREGD__FREGD] + FMUL_DOUBLE_COST;
      if (STATE__NOT_YET_VALID(FREGD) || _cost[FREGD] > c) {
        DFA_PRODUCTION(FREGD, nmsubD_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGD_FREGD_) && STATE__VALID_CHILD(_kids[1], _BINARY_FREGD_FREGD) &&
        (
#line 7160 "src/hotspot/cpu/riscv/riscv.ad"
UseFMA
#line 5597 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGD_FREGD_]+_kids[1]->_cost[_BINARY_FREGD_FREGD] + FMUL_DOUBLE_COST;
      if (STATE__NOT_YET_VALID(FREGD) || _cost[FREGD] > c) {
        DFA_PRODUCTION(FREGD, msubD_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], _BINARY_FREGD_FREGD) &&
        (
#line 7124 "src/hotspot/cpu/riscv/riscv.ad"
UseFMA
#line 5608 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[_BINARY_FREGD_FREGD] + FMUL_DOUBLE_COST;
      if (STATE__NOT_YET_VALID(FREGD) || _cost[FREGD] > c) {
        DFA_PRODUCTION(FREGD, maddD_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_FmaF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _NEGF_FREGF_) && STATE__VALID_CHILD(_kids[1], _BINARY_FREGF__NEGF_FREGF_) &&
        (
#line 7216 "src/hotspot/cpu/riscv/riscv.ad"
UseFMA
#line 5621 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGF_FREGF_]+_kids[1]->_cost[_BINARY_FREGF__NEGF_FREGF_] + FMUL_SINGLE_COST;
        DFA_PRODUCTION(FREGF, nmaddF_reg_reg_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGF_FREGF_) && STATE__VALID_CHILD(_kids[1], _BINARY__NEGF_FREGF__FREGF) &&
        (
#line 7216 "src/hotspot/cpu/riscv/riscv.ad"
UseFMA
#line 5630 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGF_FREGF_]+_kids[1]->_cost[_BINARY__NEGF_FREGF__FREGF] + FMUL_SINGLE_COST;
      if (STATE__NOT_YET_VALID(FREGF) || _cost[FREGF] > c) {
        DFA_PRODUCTION(FREGF, nmaddF_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], _BINARY_FREGF__NEGF_FREGF_) &&
        (
#line 7178 "src/hotspot/cpu/riscv/riscv.ad"
UseFMA
#line 5641 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[_BINARY_FREGF__NEGF_FREGF_] + FMUL_SINGLE_COST;
      if (STATE__NOT_YET_VALID(FREGF) || _cost[FREGF] > c) {
        DFA_PRODUCTION(FREGF, nmsubF_reg_reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], _BINARY__NEGF_FREGF__FREGF) &&
        (
#line 7178 "src/hotspot/cpu/riscv/riscv.ad"
UseFMA
#line 5652 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[_BINARY__NEGF_FREGF__FREGF] + FMUL_SINGLE_COST;
      if (STATE__NOT_YET_VALID(FREGF) || _cost[FREGF] > c) {
        DFA_PRODUCTION(FREGF, nmsubF_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGF_FREGF_) && STATE__VALID_CHILD(_kids[1], _BINARY_FREGF_FREGF) &&
        (
#line 7142 "src/hotspot/cpu/riscv/riscv.ad"
UseFMA
#line 5663 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGF_FREGF_]+_kids[1]->_cost[_BINARY_FREGF_FREGF] + FMUL_SINGLE_COST;
      if (STATE__NOT_YET_VALID(FREGF) || _cost[FREGF] > c) {
        DFA_PRODUCTION(FREGF, msubF_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], _BINARY_FREGF_FREGF) &&
        (
#line 7106 "src/hotspot/cpu/riscv/riscv.ad"
UseFMA
#line 5674 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[_BINARY_FREGF_FREGF] + FMUL_SINGLE_COST;
      if (STATE__NOT_YET_VALID(FREGF) || _cost[FREGF] > c) {
        DFA_PRODUCTION(FREGF, maddF_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_Goto(const Node *n){
    {
      unsigned int c = BRANCH_COST;
        DFA_PRODUCTION(UNIVERSE, branch_rule, c)
    }
}
void  State::_sub_Op_Halt(const Node *n){
    {
      unsigned int c = BRANCH_COST;
        DFA_PRODUCTION(UNIVERSE, ShouldNotReachHere_rule, c)
    }
}
void  State::_sub_Op_CountPositives(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP_R11) && STATE__VALID_CHILD(_kids[1], IREGI_R12) &&
        (
#line 1989 "src/hotspot/cpu/riscv/riscv_v.ad"
UseRVV
#line 5699 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R11]+_kids[1]->_cost[IREGI_R12] + DEFAULT_COST;
        DFA_PRODUCTION(IREGI_R10, vcount_positives_rule, c)
    }
}
void  State::_sub_Op_If(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], CMPOPEQNE) && STATE__VALID_CHILD(_kids[1], _CMPP__DECODEN_IREGN__IMMP0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPEQNE]+_kids[1]->_cost[_CMPP__DECODEN_IREGN__IMMP0]+BRANCH_COST * 2;
        DFA_PRODUCTION(UNIVERSE, far_cmpP_narrowOop_imm0_branch_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPEQNE) && STATE__VALID_CHILD(_kids[1], _CMPN_IREGN_IMMN0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPEQNE]+_kids[1]->_cost[_CMPN_IREGN_IMMN0]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpN_imm0_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPEQNE) && STATE__VALID_CHILD(_kids[1], _CMPP_IREGP_IMMP0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPEQNE]+_kids[1]->_cost[_CMPP_IREGP_IMMP0]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpP_imm0_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPULTGE) && STATE__VALID_CHILD(_kids[1], _CMPUL_IREGL_IMML0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPULTGE]+_kids[1]->_cost[_CMPUL_IREGL_IMML0] + BRANCH_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpULLtGe_reg_imm0_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPUEQNELEGT) && STATE__VALID_CHILD(_kids[1], _CMPUL_IREGL_IMML0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUEQNELEGT]+_kids[1]->_cost[_CMPUL_IREGL_IMML0]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpULEqNeLeGt_reg_imm0_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPL_IREGL_IMML0) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPL_IREGL_IMML0]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpL_reg_imm0_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPULTGE) && STATE__VALID_CHILD(_kids[1], _CMPU_IREGI_IMMI0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPULTGE]+_kids[1]->_cost[_CMPU_IREGI_IMMI0] + BRANCH_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpULtGe_reg_imm0_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPUEQNELEGT) && STATE__VALID_CHILD(_kids[1], _CMPU_IREGI_IMMI0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUEQNELEGT]+_kids[1]->_cost[_CMPU_IREGI_IMMI0]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpUEqNeLeGt_imm0_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPI_IREGI_IMMI0) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPI_IREGI_IMMI0]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpI_reg_imm0_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPD_FREGD_FREGD) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPD_FREGD_FREGD]+XFER_COST + BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpD_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPF_FREGF_FREGF) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPF_FREGF_FREGF]+XFER_COST + BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpF_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPN_IREGN_IREGN) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPN_IREGN_IREGN]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpN_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPP_IREGP_IREGP) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPP_IREGP_IREGP]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpP_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPUL_IREGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPUL_IREGL_IREGL]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpUL_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPL_IREGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPL_IREGL_IREGL]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpL_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPU_IREGI_IREGI) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPU_IREGI_IREGI]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpU_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPI_IREGI_IREGI) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPI_IREGI_IREGI]+BRANCH_COST * 2;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpI_branch_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], RFLAGSREG) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[RFLAGSREG] + BRANCH_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, far_cmpFlag_branch_rule, c)
      }
    }
}
void  State::_sub_Op_LShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI_16) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI_16];
        DFA_PRODUCTION(_LSHIFTI_IREGIORL2I_IMMI_16, _LShiftI_iRegIorL2I_immI_16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION(_LSHIFTI_IREGIORL2I_IMMI_24, _LShiftI_iRegIorL2I_immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI] + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, lShiftI_reg_imm_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, lShiftI_reg_imm_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, lShiftI_reg_imm_rule, c)
        DFA_PRODUCTION(IREGI_R12, lShiftI_reg_imm_rule, c)
        DFA_PRODUCTION(IREGI_R13, lShiftI_reg_imm_rule, c)
        DFA_PRODUCTION(IREGI_R14, lShiftI_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, lShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, lShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, lShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, lShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, lShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, lShiftI_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_LShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_IREGI_) && STATE__VALID_CHILD(_kids[1], IMMISCALE) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_IREGI_]+_kids[1]->_cost[IMMISCALE];
        DFA_PRODUCTION(_LSHIFTL__CONVI2L_IREGI__IMMISCALE, _LShiftL__ConvI2L_iRegI__immIScale_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMISCALE) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMISCALE];
        DFA_PRODUCTION(_LSHIFTL_IREGL_IMMISCALE, _LShiftL_iRegL_immIScale_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMI] + ALU_COST;
        DFA_PRODUCTION(IREGLNOSP, lShiftL_reg_imm_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, lShiftL_reg_imm_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, lShiftL_reg_imm_rule, c)
        DFA_PRODUCTION(IREGL_R29, lShiftL_reg_imm_rule, c)
        DFA_PRODUCTION(IREGL_R30, lShiftL_reg_imm_rule, c)
        DFA_PRODUCTION(IREGL_R10, lShiftL_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGIORL2I] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, lShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, lShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, lShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, lShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, lShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, lShiftL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_IREGI_) && STATE__VALID_CHILD(_kids[1], UIMMI6_GE32) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_IREGI_]+_kids[1]->_cost[UIMMI6_GE32] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, lShiftL_regI_immGE32_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, lShiftL_regI_immGE32_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, lShiftL_regI_immGE32_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, lShiftL_regI_immGE32_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, lShiftL_regI_immGE32_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, lShiftL_regI_immGE32_rule, c)
      }
    }
}
void  State::_sub_Op_LoadB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION(_LOADB_MEMORY_, _LoadB_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + LOAD_COST;
        DFA_PRODUCTION(IREGINOSP, loadB_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, loadB_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, loadB_rule, c)
        DFA_PRODUCTION(IREGI_R12, loadB_rule, c)
        DFA_PRODUCTION(IREGI_R13, loadB_rule, c)
        DFA_PRODUCTION(IREGI_R14, loadB_rule, c)
    }
}
void  State::_sub_Op_LoadUB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION(_LOADUB_MEMORY_, _LoadUB_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + LOAD_COST;
        DFA_PRODUCTION(IREGINOSP, loadUB_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, loadUB_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, loadUB_rule, c)
        DFA_PRODUCTION(IREGI_R12, loadUB_rule, c)
        DFA_PRODUCTION(IREGI_R13, loadUB_rule, c)
        DFA_PRODUCTION(IREGI_R14, loadUB_rule, c)
    }
}
void  State::_sub_Op_LoadUS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION(_LOADUS_MEMORY_, _LoadUS_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + LOAD_COST;
        DFA_PRODUCTION(IREGINOSP, loadUS_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, loadUS_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, loadUS_rule, c)
        DFA_PRODUCTION(IREGI_R12, loadUS_rule, c)
        DFA_PRODUCTION(IREGI_R13, loadUS_rule, c)
        DFA_PRODUCTION(IREGI_R14, loadUS_rule, c)
    }
}
void  State::_sub_Op_LoadD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + LOAD_COST;
        DFA_PRODUCTION(FREGD, loadD_rule, c)
    }
}
void  State::_sub_Op_LoadF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + LOAD_COST;
        DFA_PRODUCTION(FREGF, loadF_rule, c)
    }
}
void  State::_sub_Op_LoadI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION(_LOADI_MEMORY_, _LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + LOAD_COST;
        DFA_PRODUCTION(IREGINOSP, loadI_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, loadI_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, loadI_rule, c)
        DFA_PRODUCTION(IREGI_R12, loadI_rule, c)
        DFA_PRODUCTION(IREGI_R13, loadI_rule, c)
        DFA_PRODUCTION(IREGI_R14, loadI_rule, c)
    }
}
void  State::_sub_Op_LoadKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + LOAD_COST;
        DFA_PRODUCTION(IREGPNOSP, loadKlass_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c)
        DFA_PRODUCTION(IREGP, loadKlass_rule, c)
        DFA_PRODUCTION(JAVATHREAD_REGP, loadKlass_rule, c)
        DFA_PRODUCTION(INDIRECT, loadKlass_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
        DFA_PRODUCTION(INLINE_CACHE_REGP, loadKlass_rule, c)
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
        DFA_PRODUCTION(IREGP_R10, loadKlass_rule, c)
        DFA_PRODUCTION(IREGP_R11, loadKlass_rule, c)
        DFA_PRODUCTION(IREGP_R12, loadKlass_rule, c)
        DFA_PRODUCTION(IREGP_R13, loadKlass_rule, c)
        DFA_PRODUCTION(IREGP_R14, loadKlass_rule, c)
        DFA_PRODUCTION(IREGP_R15, loadKlass_rule, c)
        DFA_PRODUCTION(IREGP_R16, loadKlass_rule, c)
        DFA_PRODUCTION(IREGP_R28, loadKlass_rule, c)
    }
}
void  State::_sub_Op_LoadNKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + LOAD_COST;
        DFA_PRODUCTION(IREGNNOSP, loadNKlass_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegNNoSp_rule, c)
        DFA_PRODUCTION(IREGN, loadNKlass_rule, c)
        DFA_PRODUCTION(IREGNORP, iRegN_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegN_rule, c)
    }
}
void  State::_sub_Op_LoadL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + LOAD_COST;
        DFA_PRODUCTION(IREGLNOSP, loadL_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, loadL_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, loadL_rule, c)
        DFA_PRODUCTION(IREGL_R29, loadL_rule, c)
        DFA_PRODUCTION(IREGL_R30, loadL_rule, c)
        DFA_PRODUCTION(IREGL_R10, loadL_rule, c)
    }
}
void  State::_sub_Op_LoadPLocked(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+ALU_COST * 2 + LOAD_COST;
        DFA_PRODUCTION(IREGPNOSP, loadPLocked_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c)
        DFA_PRODUCTION(IREGP, loadPLocked_rule, c)
        DFA_PRODUCTION(JAVATHREAD_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION(INDIRECT, loadPLocked_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
        DFA_PRODUCTION(INLINE_CACHE_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
        DFA_PRODUCTION(IREGP_R10, loadPLocked_rule, c)
        DFA_PRODUCTION(IREGP_R11, loadPLocked_rule, c)
        DFA_PRODUCTION(IREGP_R12, loadPLocked_rule, c)
        DFA_PRODUCTION(IREGP_R13, loadPLocked_rule, c)
        DFA_PRODUCTION(IREGP_R14, loadPLocked_rule, c)
        DFA_PRODUCTION(IREGP_R15, loadPLocked_rule, c)
        DFA_PRODUCTION(IREGP_R16, loadPLocked_rule, c)
        DFA_PRODUCTION(IREGP_R28, loadPLocked_rule, c)
    }
}
void  State::_sub_Op_LoadP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 58 "src/hotspot/cpu/riscv/gc/z/z_riscv64.ad"
UseZGC && (n->as_Load()->barrier_data() != 0)
#line 6114 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+4 * DEFAULT_COST;
        DFA_PRODUCTION(IREGPNOSP, zLoadP_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c)
        DFA_PRODUCTION(IREGP, zLoadP_rule, c)
        DFA_PRODUCTION(JAVATHREAD_REGP, zLoadP_rule, c)
        DFA_PRODUCTION(INDIRECT, zLoadP_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
        DFA_PRODUCTION(INLINE_CACHE_REGP, zLoadP_rule, c)
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
        DFA_PRODUCTION(IREGP_R10, zLoadP_rule, c)
        DFA_PRODUCTION(IREGP_R11, zLoadP_rule, c)
        DFA_PRODUCTION(IREGP_R12, zLoadP_rule, c)
        DFA_PRODUCTION(IREGP_R13, zLoadP_rule, c)
        DFA_PRODUCTION(IREGP_R14, zLoadP_rule, c)
        DFA_PRODUCTION(IREGP_R15, zLoadP_rule, c)
        DFA_PRODUCTION(IREGP_R16, zLoadP_rule, c)
        DFA_PRODUCTION(IREGP_R28, zLoadP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 4598 "src/hotspot/cpu/riscv/riscv.ad"
n->as_Load()->barrier_data() == 0
#line 6140 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + LOAD_COST;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION(IREGPNOSP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(JAVATHREAD_REGP) || _cost[JAVATHREAD_REGP] > c) {
        DFA_PRODUCTION(JAVATHREAD_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEMA) || _cost[VMEMA] > c) {
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c) {
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION(IREGP_R10, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R11) || _cost[IREGP_R11] > c) {
        DFA_PRODUCTION(IREGP_R11, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R12) || _cost[IREGP_R12] > c) {
        DFA_PRODUCTION(IREGP_R12, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R13) || _cost[IREGP_R13] > c) {
        DFA_PRODUCTION(IREGP_R13, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R14) || _cost[IREGP_R14] > c) {
        DFA_PRODUCTION(IREGP_R14, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R15) || _cost[IREGP_R15] > c) {
        DFA_PRODUCTION(IREGP_R15, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R16) || _cost[IREGP_R16] > c) {
        DFA_PRODUCTION(IREGP_R16, loadP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R28) || _cost[IREGP_R28] > c) {
        DFA_PRODUCTION(IREGP_R28, loadP_rule, c)
      }
    }
}
void  State::_sub_Op_LoadN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + LOAD_COST;
        DFA_PRODUCTION(IREGNNOSP, loadN_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegNNoSp_rule, c)
        DFA_PRODUCTION(IREGN, loadN_rule, c)
        DFA_PRODUCTION(IREGNORP, iRegN_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegN_rule, c)
    }
}
void  State::_sub_Op_LoadRange(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + LOAD_COST;
        DFA_PRODUCTION(IREGINOSP, loadRange_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, loadRange_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, loadRange_rule, c)
        DFA_PRODUCTION(IREGI_R12, loadRange_rule, c)
        DFA_PRODUCTION(IREGI_R13, loadRange_rule, c)
        DFA_PRODUCTION(IREGI_R14, loadRange_rule, c)
    }
}
void  State::_sub_Op_LoadS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION(_LOADS_MEMORY_, _LoadS_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + LOAD_COST;
        DFA_PRODUCTION(IREGINOSP, loadS_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, loadS_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, loadS_rule, c)
        DFA_PRODUCTION(IREGI_R12, loadS_rule, c)
        DFA_PRODUCTION(IREGI_R13, loadS_rule, c)
        DFA_PRODUCTION(IREGI_R14, loadS_rule, c)
    }
}
void  State::_sub_Op_MaxI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 413 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 6248 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI] + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, maxI_reg_b_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, maxI_reg_b_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, maxI_reg_b_rule, c)
        DFA_PRODUCTION(IREGI_R12, maxI_reg_b_rule, c)
        DFA_PRODUCTION(IREGI_R13, maxI_reg_b_rule, c)
        DFA_PRODUCTION(IREGI_R14, maxI_reg_b_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI]+BRANCH_COST + ALU_COST * 2;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, maxI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, maxI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, maxI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, maxI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, maxI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, maxI_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_MaxD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[FREGD] + DEFAULT_COST;
        DFA_PRODUCTION(FREGD, maxD_reg_reg_rule, c)
    }
}
void  State::_sub_Op_MaxF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[FREGF] + DEFAULT_COST;
        DFA_PRODUCTION(FREGF, maxF_reg_reg_rule, c)
    }
}
void  State::_sub_Op_MemBarAcquire(const Node *n){
    {
      unsigned int c = ALU_COST;
        DFA_PRODUCTION(UNIVERSE, membar_acquire_rule, c)
    }
}
void  State::_sub_Op_LoadFence(const Node *n){
    {
      unsigned int c = ALU_COST;
        DFA_PRODUCTION(UNIVERSE, load_fence_rule, c)
    }
}
void  State::_sub_Op_MemBarAcquireLock(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(UNIVERSE, membar_acquire_lock_rule, c)
    }
}
void  State::_sub_Op_MemBarRelease(const Node *n){
    {
      unsigned int c = ALU_COST;
        DFA_PRODUCTION(UNIVERSE, membar_release_rule, c)
    }
}
void  State::_sub_Op_StoreFence(const Node *n){
    {
      unsigned int c = ALU_COST;
        DFA_PRODUCTION(UNIVERSE, store_fence_rule, c)
    }
}
void  State::_sub_Op_StoreStoreFence(const Node *n){
    {
      unsigned int c = ALU_COST;
        DFA_PRODUCTION(UNIVERSE, membar_storestore_0_rule, c)
    }
}
void  State::_sub_Op_MemBarReleaseLock(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(UNIVERSE, membar_release_lock_rule, c)
    }
}
void  State::_sub_Op_MemBarVolatile(const Node *n){
    {
      unsigned int c = ALU_COST;
        DFA_PRODUCTION(UNIVERSE, membar_volatile_rule, c)
    }
}
void  State::_sub_Op_MemBarStoreStore(const Node *n){
    {
      unsigned int c = ALU_COST;
        DFA_PRODUCTION(UNIVERSE, membar_storestore_rule, c)
    }
}
void  State::_sub_Op_MinI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 399 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 6367 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI] + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, minI_reg_b_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, minI_reg_b_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, minI_reg_b_rule, c)
        DFA_PRODUCTION(IREGI_R12, minI_reg_b_rule, c)
        DFA_PRODUCTION(IREGI_R13, minI_reg_b_rule, c)
        DFA_PRODUCTION(IREGI_R14, minI_reg_b_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI]+BRANCH_COST + ALU_COST * 2;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, minI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, minI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, minI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, minI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, minI_rReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, minI_rReg_rule, c)
      }
    }
}
void  State::_sub_Op_MinF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[FREGF] + DEFAULT_COST;
        DFA_PRODUCTION(FREGF, minF_reg_reg_rule, c)
    }
}
void  State::_sub_Op_MinD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[FREGD] + DEFAULT_COST;
        DFA_PRODUCTION(FREGD, minD_reg_reg_rule, c)
    }
}
void  State::_sub_Op_ModI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I] + IDIVSI_COST;
        DFA_PRODUCTION(IREGINOSP, modI_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, modI_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, modI_rule, c)
        DFA_PRODUCTION(IREGI_R12, modI_rule, c)
        DFA_PRODUCTION(IREGI_R13, modI_rule, c)
        DFA_PRODUCTION(IREGI_R14, modI_rule, c)
    }
}
void  State::_sub_Op_ModL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + IDIVDI_COST;
        DFA_PRODUCTION(IREGLNOSP, modL_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, modL_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, modL_rule, c)
        DFA_PRODUCTION(IREGL_R29, modL_rule, c)
        DFA_PRODUCTION(IREGL_R30, modL_rule, c)
        DFA_PRODUCTION(IREGL_R10, modL_rule, c)
    }
}
void  State::_sub_Op_MoveI2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI] + XFER_COST;
        DFA_PRODUCTION(FREGF, MoveI2F_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI] + STORE_COST;
        DFA_PRODUCTION(STACKSLOTF, MoveI2F_reg_stack_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTI) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTI] + LOAD_COST;
      if (STATE__NOT_YET_VALID(FREGF) || _cost[FREGF] > c) {
        DFA_PRODUCTION(FREGF, MoveI2F_stack_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MoveF2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF] + XFER_COST;
        DFA_PRODUCTION(IREGINOSP, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(IREGI_R12, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(IREGI_R13, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION(IREGI_R14, MoveF2I_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF] + STORE_COST;
        DFA_PRODUCTION(STACKSLOTI, MoveF2I_reg_stack_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTF) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTF] + LOAD_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, MoveF2I_stack_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MoveL2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + XFER_COST;
        DFA_PRODUCTION(FREGD, MoveL2D_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + STORE_COST;
        DFA_PRODUCTION(STACKSLOTD, MoveL2D_reg_stack_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTL) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTL] + LOAD_COST;
      if (STATE__NOT_YET_VALID(FREGD) || _cost[FREGD] > c) {
        DFA_PRODUCTION(FREGD, MoveL2D_stack_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MoveD2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD] + XFER_COST;
        DFA_PRODUCTION(IREGLNOSP, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION(IREGL_R29, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION(IREGL_R30, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION(IREGL_R10, MoveD2L_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD] + STORE_COST;
        DFA_PRODUCTION(STACKSLOTL, MoveD2L_reg_stack_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTD) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTD] + LOAD_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, MoveD2L_stack_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MulD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[FREGD] + FMUL_DOUBLE_COST;
        DFA_PRODUCTION(FREGD, mulD_reg_reg_rule, c)
    }
}
void  State::_sub_Op_MulF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[FREGF] + FMUL_SINGLE_COST;
        DFA_PRODUCTION(FREGF, mulF_reg_reg_rule, c)
    }
}
void  State::_sub_Op_MulHiL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + IMUL_COST;
        DFA_PRODUCTION(IREGLNOSP, mulHiL_rReg_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, mulHiL_rReg_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, mulHiL_rReg_rule, c)
        DFA_PRODUCTION(IREGL_R29, mulHiL_rReg_rule, c)
        DFA_PRODUCTION(IREGL_R30, mulHiL_rReg_rule, c)
        DFA_PRODUCTION(IREGL_R10, mulHiL_rReg_rule, c)
    }
}
void  State::_sub_Op_MulI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I] + IMUL_COST;
        DFA_PRODUCTION(IREGINOSP, mulI_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, mulI_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, mulI_rule, c)
        DFA_PRODUCTION(IREGI_R12, mulI_rule, c)
        DFA_PRODUCTION(IREGI_R13, mulI_rule, c)
        DFA_PRODUCTION(IREGI_R14, mulI_rule, c)
    }
}
void  State::_sub_Op_MulL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + IMUL_COST;
        DFA_PRODUCTION(IREGLNOSP, mulL_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, mulL_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, mulL_rule, c)
        DFA_PRODUCTION(IREGL_R29, mulL_rule, c)
        DFA_PRODUCTION(IREGL_R30, mulL_rule, c)
        DFA_PRODUCTION(IREGL_R10, mulL_rule, c)
    }
}
void  State::_sub_Op_NegD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD] + XFER_COST;
        DFA_PRODUCTION(FREGD, negD_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD];
        DFA_PRODUCTION(_NEGD_FREGD_, _NegD_fRegD__rule, c)
    }
}
void  State::_sub_Op_NegF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF] + XFER_COST;
        DFA_PRODUCTION(FREGF, negF_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF];
        DFA_PRODUCTION(_NEGF_FREGF_, _NegF_fRegF__rule, c)
    }
}
void  State::_sub_Op_OrI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _XORI_IREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 498 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 6668 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORI_IREGI_IMMI_M1]+_kids[1]->_cost[IREGI] + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, ornI_reg_reg_b_0_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, ornI_reg_reg_b_0_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, ornI_reg_reg_b_0_rule, c)
        DFA_PRODUCTION(IREGI_R12, ornI_reg_reg_b_0_rule, c)
        DFA_PRODUCTION(IREGI_R13, ornI_reg_reg_b_0_rule, c)
        DFA_PRODUCTION(IREGI_R14, ornI_reg_reg_b_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], _XORI_IREGI_IMMI_M1) &&
        (
#line 498 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 6686 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[_XORI_IREGI_IMMI_M1] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, ornI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, ornI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, ornI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, ornI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, ornI_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, ornI_reg_reg_b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMIADD) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMIADD] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, orI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, orI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, orI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, orI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, orI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, orI_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, orI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, orI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, orI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, orI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, orI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, orI_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_OrL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _XORL_IREGL_IMML_M1) && STATE__VALID_CHILD(_kids[1], IREGL) &&
        (
#line 514 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 6792 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_XORL_IREGL_IMML_M1]+_kids[1]->_cost[IREGL] + ALU_COST;
        DFA_PRODUCTION(IREGLNOSP, ornL_reg_reg_b_0_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, ornL_reg_reg_b_0_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, ornL_reg_reg_b_0_rule, c)
        DFA_PRODUCTION(IREGL_R29, ornL_reg_reg_b_0_rule, c)
        DFA_PRODUCTION(IREGL_R30, ornL_reg_reg_b_0_rule, c)
        DFA_PRODUCTION(IREGL_R10, ornL_reg_reg_b_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], _XORL_IREGL_IMML_M1) &&
        (
#line 514 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 6809 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[_XORL_IREGL_IMML_M1] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, ornL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, ornL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, ornL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, ornL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, ornL_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, ornL_reg_reg_b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMLADD) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMLADD] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, orL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, orL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, orL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, orL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, orL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, orL_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, orL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, orL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, orL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, orL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, orL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, orL_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_PartialSubtypeCheck(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP_R14) && STATE__VALID_CHILD(_kids[1], IREGP_R10) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R14]+_kids[1]->_cost[IREGP_R10];
        DFA_PRODUCTION(_PARTIALSUBTYPECHECK_IREGP_R14_IREGP_R10, _PartialSubtypeCheck_iRegP_R14_iRegP_R10_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGP_R14) && STATE__VALID_CHILD(_kids[1], IREGP_R10) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R14]+_kids[1]->_cost[IREGP_R10]+2 * STORE_COST + 3 * LOAD_COST + 4 * ALU_COST + BRANCH_COST * 4;
        DFA_PRODUCTION(IREGP_R15, partialSubtypeCheck_rule, c)
    }
}
void  State::_sub_Op_PopCountI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 369 "src/hotspot/cpu/riscv/riscv_b.ad"
UsePopCountInstruction
#line 6916 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, popCountI_b_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, popCountI_b_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, popCountI_b_rule, c)
        DFA_PRODUCTION(IREGI_R12, popCountI_b_rule, c)
        DFA_PRODUCTION(IREGI_R13, popCountI_b_rule, c)
        DFA_PRODUCTION(IREGI_R14, popCountI_b_rule, c)
    }
}
void  State::_sub_Op_PopCountL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) &&
        (
#line 384 "src/hotspot/cpu/riscv/riscv_b.ad"
UsePopCountInstruction
#line 6936 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, popCountL_b_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, popCountL_b_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, popCountL_b_rule, c)
        DFA_PRODUCTION(IREGI_R12, popCountL_b_rule, c)
        DFA_PRODUCTION(IREGI_R13, popCountL_b_rule, c)
        DFA_PRODUCTION(IREGI_R14, popCountL_b_rule, c)
    }
}
void  State::_sub_Op_RShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_IREGIORL2I_IMMI_16) && STATE__VALID_CHILD(_kids[1], IMMI_16) &&
        (
#line 136 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 6956 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_IREGIORL2I_IMMI_16]+_kids[1]->_cost[IMMI_16] + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, convI2S_reg_reg_b_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, convI2S_reg_reg_b_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, convI2S_reg_reg_b_rule, c)
        DFA_PRODUCTION(IREGI_R12, convI2S_reg_reg_b_rule, c)
        DFA_PRODUCTION(IREGI_R13, convI2S_reg_reg_b_rule, c)
        DFA_PRODUCTION(IREGI_R14, convI2S_reg_reg_b_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_IREGIORL2I_IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        (
#line 121 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 6974 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_IREGIORL2I_IMMI_24]+_kids[1]->_cost[IMMI_24] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, convB2I_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, convB2I_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, convB2I_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, convB2I_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, convB2I_reg_reg_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, convB2I_reg_reg_b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, rShiftI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, rShiftI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, rShiftI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, rShiftI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, rShiftI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, rShiftI_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, rShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, rShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, rShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, rShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, rShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, rShiftI_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI_31) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI_31];
        DFA_PRODUCTION(_RSHIFTI_IREGIORL2I_IMMI_31, _RShiftI_iRegIorL2I_immI_31_rule, c)
    }
}
void  State::_sub_Op_RShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMI] + ALU_COST;
        DFA_PRODUCTION(IREGLNOSP, rShiftL_reg_imm_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, rShiftL_reg_imm_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, rShiftL_reg_imm_rule, c)
        DFA_PRODUCTION(IREGL_R29, rShiftL_reg_imm_rule, c)
        DFA_PRODUCTION(IREGL_R30, rShiftL_reg_imm_rule, c)
        DFA_PRODUCTION(IREGL_R10, rShiftL_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGIORL2I] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, rShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, rShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, rShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, rShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, rShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, rShiftL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMI_63) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMI_63];
        DFA_PRODUCTION(_RSHIFTL_IREGL_IMMI_63, _RShiftL_iRegL_immI_63_rule, c)
    }
}
void  State::_sub_Op_Rethrow(const Node *n){
    {
      unsigned int c = BRANCH_COST;
        DFA_PRODUCTION(UNIVERSE, RethrowException_rule, c)
    }
}
void  State::_sub_Op_Return(const Node *n){
    {
      unsigned int c = BRANCH_COST;
        DFA_PRODUCTION(UNIVERSE, Ret_rule, c)
    }
}
void  State::_sub_Op_RoundDoubleModeV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 1097 "src/hotspot/cpu/riscv/riscv_v.ad"
n->bottom_type()->is_vect()->element_basic_type() == T_DOUBLE
#line 7144 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[IMMI] + DEFAULT_COST;
        DFA_PRODUCTION(VREG, vroundD_rule, c)
        DFA_PRODUCTION(VREG_V1, vroundD_rule, c)
        DFA_PRODUCTION(VREG_V2, vroundD_rule, c)
        DFA_PRODUCTION(VREG_V3, vroundD_rule, c)
        DFA_PRODUCTION(VREG_V4, vroundD_rule, c)
        DFA_PRODUCTION(VREG_V5, vroundD_rule, c)
    }
}
void  State::_sub_Op_RotateLeft(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 93 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 7160 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGI] + ALU_COST;
        DFA_PRODUCTION(IREGLNOSP, rolL_reg_b_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, rolL_reg_b_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, rolL_reg_b_rule, c)
        DFA_PRODUCTION(IREGL_R29, rolL_reg_b_rule, c)
        DFA_PRODUCTION(IREGL_R30, rolL_reg_b_rule, c)
        DFA_PRODUCTION(IREGL_R10, rolL_reg_b_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 81 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 7177 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI] + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, rolI_reg_b_rule, c)
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
        DFA_PRODUCTION(IREGI, rolI_reg_b_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
        DFA_PRODUCTION(IREGI_R10, rolI_reg_b_rule, c)
        DFA_PRODUCTION(IREGI_R12, rolI_reg_b_rule, c)
        DFA_PRODUCTION(IREGI_R13, rolI_reg_b_rule, c)
        DFA_PRODUCTION(IREGI_R14, rolI_reg_b_rule, c)
    }
}
void  State::_sub_Op_RotateRight(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 69 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 7203 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGI] + ALU_COST;
        DFA_PRODUCTION(IREGLNOSP, rorL_reg_b_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, rorL_reg_b_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, rorL_reg_b_rule, c)
        DFA_PRODUCTION(IREGL_R29, rorL_reg_b_rule, c)
        DFA_PRODUCTION(IREGL_R30, rorL_reg_b_rule, c)
        DFA_PRODUCTION(IREGL_R10, rorL_reg_b_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) &&
        (
#line 57 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 7220 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI] + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, rorI_reg_b_rule, c)
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
        DFA_PRODUCTION(IREGI, rorI_reg_b_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
        DFA_PRODUCTION(IREGI_R10, rorI_reg_b_rule, c)
        DFA_PRODUCTION(IREGI_R12, rorI_reg_b_rule, c)
        DFA_PRODUCTION(IREGI_R13, rorI_reg_b_rule, c)
        DFA_PRODUCTION(IREGI_R14, rorI_reg_b_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 43 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 7244 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMI] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, rorL_imm_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, rorL_imm_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, rorL_imm_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, rorL_imm_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, rorL_imm_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, rorL_imm_b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI) &&
        (
#line 29 "src/hotspot/cpu/riscv/riscv_b.ad"
UseZbb
#line 7279 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, rorI_imm_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, rorI_imm_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, rorI_imm_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, rorI_imm_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, rorI_imm_b_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, rorI_imm_b_rule, c)
      }
    }
}
void  State::_sub_Op_SafePoint(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP) ) {
      unsigned int c = _kids[0]->_cost[IREGP]+2 * LOAD_COST;
        DFA_PRODUCTION(UNIVERSE, safePoint_rule, c)
    }
}
void  State::_sub_Op_ShenandoahCompareAndExchangeP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) &&
        (
#line 201 "src/hotspot/cpu/riscv/gc/shenandoah/shenandoah_riscv64.ad"
needs_acquiring_load_reserved(n)
#line 7325 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+10 * DEFAULT_COST;
        DFA_PRODUCTION(IREGPNOSP, compareAndExchangePAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c)
        DFA_PRODUCTION(IREGP, compareAndExchangePAcq_shenandoah_rule, c)
        DFA_PRODUCTION(JAVATHREAD_REGP, compareAndExchangePAcq_shenandoah_rule, c)
        DFA_PRODUCTION(INDIRECT, compareAndExchangePAcq_shenandoah_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
        DFA_PRODUCTION(INLINE_CACHE_REGP, compareAndExchangePAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
        DFA_PRODUCTION(IREGP_R10, compareAndExchangePAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGP_R11, compareAndExchangePAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGP_R12, compareAndExchangePAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGP_R13, compareAndExchangePAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGP_R14, compareAndExchangePAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGP_R15, compareAndExchangePAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGP_R16, compareAndExchangePAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGP_R28, compareAndExchangePAcq_shenandoah_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+10 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGPNOSP) || _cost[IREGPNOSP] > c) {
        DFA_PRODUCTION(IREGPNOSP, compareAndExchangeP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegPNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP) || _cost[IREGP] > c) {
        DFA_PRODUCTION(IREGP, compareAndExchangeP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(JAVATHREAD_REGP) || _cost[JAVATHREAD_REGP] > c) {
        DFA_PRODUCTION(JAVATHREAD_REGP, compareAndExchangeP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION(INDIRECT, compareAndExchangeP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(VMEMA) || _cost[VMEMA] > c) {
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(INLINE_CACHE_REGP) || _cost[INLINE_CACHE_REGP] > c) {
        DFA_PRODUCTION(INLINE_CACHE_REGP, compareAndExchangeP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c) {
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R10) || _cost[IREGP_R10] > c) {
        DFA_PRODUCTION(IREGP_R10, compareAndExchangeP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R11) || _cost[IREGP_R11] > c) {
        DFA_PRODUCTION(IREGP_R11, compareAndExchangeP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R12) || _cost[IREGP_R12] > c) {
        DFA_PRODUCTION(IREGP_R12, compareAndExchangeP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R13) || _cost[IREGP_R13] > c) {
        DFA_PRODUCTION(IREGP_R13, compareAndExchangeP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R14) || _cost[IREGP_R14] > c) {
        DFA_PRODUCTION(IREGP_R14, compareAndExchangeP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R15) || _cost[IREGP_R15] > c) {
        DFA_PRODUCTION(IREGP_R15, compareAndExchangeP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R16) || _cost[IREGP_R16] > c) {
        DFA_PRODUCTION(IREGP_R16, compareAndExchangeP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGP_R28) || _cost[IREGP_R28] > c) {
        DFA_PRODUCTION(IREGP_R28, compareAndExchangeP_shenandoah_rule, c)
      }
    }
}
void  State::_sub_Op_ShenandoahCompareAndExchangeN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGN_IREGN) &&
        (
#line 180 "src/hotspot/cpu/riscv/gc/shenandoah/shenandoah_riscv64.ad"
needs_acquiring_load_reserved(n)
#line 7410 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGN_IREGN]+10 * DEFAULT_COST;
        DFA_PRODUCTION(IREGNNOSP, compareAndExchangeNAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegNNoSp_rule, c)
        DFA_PRODUCTION(IREGN, compareAndExchangeNAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGNORP, iRegN_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegN_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGN_IREGN) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGN_IREGN]+10 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGNNOSP) || _cost[IREGNNOSP] > c) {
        DFA_PRODUCTION(IREGNNOSP, compareAndExchangeN_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegNNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGN) || _cost[IREGN] > c) {
        DFA_PRODUCTION(IREGN, compareAndExchangeN_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGNORP) || _cost[IREGNORP] > c) {
        DFA_PRODUCTION(IREGNORP, iRegN_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegN_rule, c)
      }
    }
}
void  State::_sub_Op_ShenandoahCompareAndSwapN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGN_IREGN) &&
        (
#line 96 "src/hotspot/cpu/riscv/gc/shenandoah/shenandoah_riscv64.ad"
needs_acquiring_load_reserved(n)
#line 7443 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGN_IREGN]+10 * DEFAULT_COST;
        DFA_PRODUCTION(IREGINOSP, compareAndSwapNAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, compareAndSwapNAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, compareAndSwapNAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGI_R12, compareAndSwapNAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGI_R13, compareAndSwapNAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGI_R14, compareAndSwapNAcq_shenandoah_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGN_IREGN) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGN_IREGN]+10 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, compareAndSwapN_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, compareAndSwapN_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, compareAndSwapN_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, compareAndSwapN_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, compareAndSwapN_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, compareAndSwapN_shenandoah_rule, c)
      }
    }
}
void  State::_sub_Op_ShenandoahCompareAndSwapP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) &&
        (
#line 74 "src/hotspot/cpu/riscv/gc/shenandoah/shenandoah_riscv64.ad"
needs_acquiring_load_reserved(n)
#line 7496 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+10 * DEFAULT_COST;
        DFA_PRODUCTION(IREGINOSP, compareAndSwapPAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, compareAndSwapPAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, compareAndSwapPAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGI_R12, compareAndSwapPAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGI_R13, compareAndSwapPAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGI_R14, compareAndSwapPAcq_shenandoah_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+10 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, compareAndSwapP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, compareAndSwapP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, compareAndSwapP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, compareAndSwapP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, compareAndSwapP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, compareAndSwapP_shenandoah_rule, c)
      }
    }
}
void  State::_sub_Op_ShenandoahWeakCompareAndSwapN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGN_IREGN) &&
        (
#line 242 "src/hotspot/cpu/riscv/gc/shenandoah/shenandoah_riscv64.ad"
needs_acquiring_load_reserved(n)
#line 7549 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGN_IREGN]+10 * DEFAULT_COST;
        DFA_PRODUCTION(IREGINOSP, weakCompareAndSwapNAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, weakCompareAndSwapNAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, weakCompareAndSwapNAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGI_R12, weakCompareAndSwapNAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGI_R13, weakCompareAndSwapNAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGI_R14, weakCompareAndSwapNAcq_shenandoah_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGN_IREGN) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGN_IREGN]+10 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, weakCompareAndSwapN_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, weakCompareAndSwapN_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, weakCompareAndSwapN_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, weakCompareAndSwapN_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, weakCompareAndSwapN_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, weakCompareAndSwapN_shenandoah_rule, c)
      }
    }
}
void  State::_sub_Op_ShenandoahWeakCompareAndSwapP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) &&
        (
#line 265 "src/hotspot/cpu/riscv/gc/shenandoah/shenandoah_riscv64.ad"
needs_acquiring_load_reserved(n)
#line 7602 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+10 * DEFAULT_COST;
        DFA_PRODUCTION(IREGINOSP, weakCompareAndSwapPAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, weakCompareAndSwapPAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, weakCompareAndSwapPAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGI_R12, weakCompareAndSwapPAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGI_R13, weakCompareAndSwapPAcq_shenandoah_rule, c)
        DFA_PRODUCTION(IREGI_R14, weakCompareAndSwapPAcq_shenandoah_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+10 * DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, weakCompareAndSwapP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, weakCompareAndSwapP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, weakCompareAndSwapP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, weakCompareAndSwapP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, weakCompareAndSwapP_shenandoah_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, weakCompareAndSwapP_shenandoah_rule, c)
      }
    }
}
void  State::_sub_Op_SqrtD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD] + FSQRT_COST;
        DFA_PRODUCTION(FREGD, sqrtD_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVF2D_FREGF_) ) {
      unsigned int c = _kids[0]->_cost[_CONVF2D_FREGF_];
        DFA_PRODUCTION(_SQRTD__CONVF2D_FREGF__, _SqrtD__ConvF2D_fRegF___rule, c)
    }
}
void  State::_sub_Op_StoreB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI0] + STORE_COST;
        DFA_PRODUCTION(UNIVERSE, storeimmB0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGIORL2I] + STORE_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeB_rule, c)
      }
    }
}
void  State::_sub_Op_StoreC(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI0] + STORE_COST;
        DFA_PRODUCTION(UNIVERSE, storeimmC0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGIORL2I] + STORE_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeC_rule, c)
      }
    }
}
void  State::_sub_Op_StoreCM(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI0] + STORE_COST;
        DFA_PRODUCTION(UNIVERSE, storeimmCM0_rule, c)
    }
}
void  State::_sub_Op_StorePConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_IREGP) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_IREGP_IREGP]+ALU_COST * 2 + STORE_COST;
        DFA_PRODUCTION(RFLAGSREG, storePConditional_rule, c)
    }
}
void  State::_sub_Op_StoreIConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGI_IREGI) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGI_IREGI]+LOAD_COST + STORE_COST + BRANCH_COST * 2;
        DFA_PRODUCTION(RFLAGSREG, storeIConditional_rule, c)
    }
}
void  State::_sub_Op_StoreLConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], INDIRECT) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGL_IREGL) ) {
      unsigned int c = _kids[0]->_cost[INDIRECT]+_kids[1]->_cost[_BINARY_IREGL_IREGL]+LOAD_COST + STORE_COST + 2 * BRANCH_COST;
        DFA_PRODUCTION(RFLAGSREG, storeLConditional_rule, c)
    }
}
void  State::_sub_Op_StoreD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], FREGD) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[FREGD] + STORE_COST;
        DFA_PRODUCTION(UNIVERSE, storeD_rule, c)
    }
}
void  State::_sub_Op_StoreF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], FREGF) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[FREGF] + STORE_COST;
        DFA_PRODUCTION(UNIVERSE, storeF_rule, c)
    }
}
void  State::_sub_Op_StoreI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI0] + STORE_COST;
        DFA_PRODUCTION(UNIVERSE, storeimmI0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGIORL2I] + STORE_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeI_rule, c)
      }
    }
}
void  State::_sub_Op_StoreL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMML0] + STORE_COST;
        DFA_PRODUCTION(UNIVERSE, storeimmL0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGL] + STORE_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeL_rule, c)
      }
    }
}
void  State::_sub_Op_StoreP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMP0] + STORE_COST;
        DFA_PRODUCTION(UNIVERSE, storeimmP0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGP) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGP] + STORE_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeP_rule, c)
      }
    }
}
void  State::_sub_Op_StoreN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMN0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMN0] + STORE_COST;
        DFA_PRODUCTION(UNIVERSE, storeImmN0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGN) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGN] + STORE_COST;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION(UNIVERSE, storeN_rule, c)
      }
    }
}
void  State::_sub_Op_StoreNKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IREGN) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IREGN] + STORE_COST;
        DFA_PRODUCTION(UNIVERSE, storeNKlass_rule, c)
    }
}
void  State::_sub_Op_StrComp(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R13_IREGI_R14) &&
        (
#line 1922 "src/hotspot/cpu/riscv/riscv_v.ad"
UseRVV && ((StrCompNode *)n)->encoding() == StrIntrinsicNode::LU
#line 7779 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[_BINARY_IREGP_R13_IREGI_R14] + DEFAULT_COST;
        DFA_PRODUCTION(IREGI_R10, vstring_compareLU_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R13_IREGI_R14) &&
        (
#line 1904 "src/hotspot/cpu/riscv/riscv_v.ad"
UseRVV && ((StrCompNode *)n)->encoding() == StrIntrinsicNode::UL
#line 7788 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[_BINARY_IREGP_R13_IREGI_R14] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, vstring_compareUL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R13_IREGI_R14) &&
        (
#line 1885 "src/hotspot/cpu/riscv/riscv_v.ad"
UseRVV && ((StrCompNode *)n)->encoding() == StrIntrinsicNode::LL
#line 7799 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[_BINARY_IREGP_R13_IREGI_R14] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, vstring_compareL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R13_IREGI_R14) &&
        (
#line 1866 "src/hotspot/cpu/riscv/riscv_v.ad"
UseRVV && ((StrCompNode *)n)->encoding() == StrIntrinsicNode::UU
#line 7810 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[_BINARY_IREGP_R13_IREGI_R14] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, vstring_compareU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R13_IREGI_R14) &&
        (
#line 10127 "src/hotspot/cpu/riscv/riscv.ad"
!UseRVV && ((StrCompNode *)n)->encoding() == StrIntrinsicNode::LU
#line 7821 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[_BINARY_IREGP_R13_IREGI_R14] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, string_compareLU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R13_IREGI_R14) &&
        (
#line 10109 "src/hotspot/cpu/riscv/riscv.ad"
!UseRVV && ((StrCompNode *)n)->encoding() == StrIntrinsicNode::UL
#line 7832 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[_BINARY_IREGP_R13_IREGI_R14] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, string_compareUL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R13_IREGI_R14) &&
        (
#line 10092 "src/hotspot/cpu/riscv/riscv.ad"
!UseRVV && ((StrCompNode *)n)->encoding() == StrIntrinsicNode::LL
#line 7843 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[_BINARY_IREGP_R13_IREGI_R14] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, string_compareL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R13_IREGI_R14) &&
        (
#line 10074 "src/hotspot/cpu/riscv/riscv.ad"
!UseRVV && ((StrCompNode *)n)->encoding() == StrIntrinsicNode::UU
#line 7854 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[_BINARY_IREGP_R13_IREGI_R14] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, string_compareU_rule, c)
      }
    }
}
void  State::_sub_Op_StrCompressedCopy(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP_R12) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R11_IREGI_R13) &&
        (
#line 1973 "src/hotspot/cpu/riscv/riscv_v.ad"
UseRVV
#line 7867 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R12]+_kids[1]->_cost[_BINARY_IREGP_R11_IREGI_R13] + DEFAULT_COST;
        DFA_PRODUCTION(IREGI_R10, vstring_compress_rule, c)
    }
}
void  State::_sub_Op_StrEquals(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGP_R13) && STATE__VALID_CHILD(_kids[1], IREGI_R14) &&
        (
#line 1819 "src/hotspot/cpu/riscv/riscv_v.ad"
UseRVV && ((StrEqualsNode*)n)->encoding() == StrIntrinsicNode::UU
#line 7878 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGP_R13]+_kids[1]->_cost[IREGI_R14] + DEFAULT_COST;
        DFA_PRODUCTION(IREGI_R10, vstring_equalsU_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGP_R13) && STATE__VALID_CHILD(_kids[1], IREGI_R14) &&
        (
#line 1802 "src/hotspot/cpu/riscv/riscv_v.ad"
UseRVV && ((StrEqualsNode*)n)->encoding() == StrIntrinsicNode::LL
#line 7887 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGP_R13]+_kids[1]->_cost[IREGI_R14] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, vstring_equalsL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGP_R13) && STATE__VALID_CHILD(_kids[1], IREGI_R14) &&
        (
#line 10362 "src/hotspot/cpu/riscv/riscv.ad"
!UseRVV && ((StrEqualsNode*)n)->encoding() == StrIntrinsicNode::UU
#line 7898 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGP_R13]+_kids[1]->_cost[IREGI_R14] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, string_equalsU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGP_R13) && STATE__VALID_CHILD(_kids[1], IREGI_R14) &&
        (
#line 10346 "src/hotspot/cpu/riscv/riscv.ad"
!UseRVV && ((StrEqualsNode*)n)->encoding() == StrIntrinsicNode::LL
#line 7909 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGP_R13]+_kids[1]->_cost[IREGI_R14] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, string_equalsL_rule, c)
      }
    }
}
void  State::_sub_Op_StrIndexOf(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R13_IMMI_1) &&
        (
#line 10251 "src/hotspot/cpu/riscv/riscv.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UL
#line 7922 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[_BINARY_IREGP_R13_IMMI_1] + DEFAULT_COST;
        DFA_PRODUCTION(IREGI_R10, string_indexof_conUL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R13_IMMI_LE_4) &&
        (
#line 10230 "src/hotspot/cpu/riscv/riscv.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::LL
#line 7931 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[_BINARY_IREGP_R13_IMMI_LE_4] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, string_indexof_conLL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R13_IMMI_LE_4) &&
        (
#line 10208 "src/hotspot/cpu/riscv/riscv.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UU
#line 7942 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[_BINARY_IREGP_R13_IMMI_LE_4] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, string_indexof_conUU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R13_IREGI_R14) &&
        (
#line 10187 "src/hotspot/cpu/riscv/riscv.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UL
#line 7953 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[_BINARY_IREGP_R13_IREGI_R14] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, string_indexofUL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R13_IREGI_R14) &&
        (
#line 10166 "src/hotspot/cpu/riscv/riscv.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::LL
#line 7964 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[_BINARY_IREGP_R13_IREGI_R14] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, string_indexofLL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R13_IREGI_R14) &&
        (
#line 10145 "src/hotspot/cpu/riscv/riscv.ad"
((StrIndexOfNode*)n)->encoding() == StrIntrinsicNode::UU
#line 7975 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[_BINARY_IREGP_R13_IREGI_R14] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, string_indexofUU_rule, c)
      }
    }
}
void  State::_sub_Op_StrIndexOfChar(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], IREGI_R13) &&
        (
#line 2025 "src/hotspot/cpu/riscv/riscv_v.ad"
UseRVV && (((StrIndexOfCharNode*)n)->encoding() == StrIntrinsicNode::L)
#line 7988 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[IREGI_R13] + DEFAULT_COST;
        DFA_PRODUCTION(IREGI_R10, vstringL_indexof_char_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], IREGI_R13) &&
        (
#line 2005 "src/hotspot/cpu/riscv/riscv_v.ad"
UseRVV && (((StrIndexOfCharNode*)n)->encoding() == StrIntrinsicNode::U)
#line 7997 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[IREGI_R13] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, vstringU_indexof_char_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], IREGI_R13) &&
        (
#line 10292 "src/hotspot/cpu/riscv/riscv.ad"
!UseRVV && (((StrIndexOfCharNode*)n)->encoding() == StrIntrinsicNode::L)
#line 8008 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[IREGI_R13] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, stringL_indexof_char_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_IREGP_R11_IREGI_R12) && STATE__VALID_CHILD(_kids[1], IREGI_R13) &&
        (
#line 10273 "src/hotspot/cpu/riscv/riscv.ad"
!UseRVV && (((StrIndexOfCharNode*)n)->encoding() == StrIntrinsicNode::U)
#line 8019 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_IREGP_R11_IREGI_R12]+_kids[1]->_cost[IREGI_R13] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, stringU_indexof_char_rule, c)
      }
    }
}
void  State::_sub_Op_StrInflatedCopy(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGP_R10) && STATE__VALID_CHILD(_kids[1], _BINARY_IREGP_R11_IREGI_R12) &&
        (
#line 1941 "src/hotspot/cpu/riscv/riscv_v.ad"
UseRVV
#line 8032 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGP_R10]+_kids[1]->_cost[_BINARY_IREGP_R11_IREGI_R12] + DEFAULT_COST;
        DFA_PRODUCTION(UNIVERSE, vstring_inflate_rule, c)
    }
}
void  State::_sub_Op_SubD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[FREGD] + FMUL_DOUBLE_COST;
        DFA_PRODUCTION(FREGD, subD_reg_reg_rule, c)
    }
}
void  State::_sub_Op_SubF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[FREGF] + FMUL_SINGLE_COST;
        DFA_PRODUCTION(FREGF, subF_reg_reg_rule, c)
    }
}
void  State::_sub_Op_SubI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[IREGIORL2I] + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, negI_reg_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, negI_reg_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, negI_reg_rule, c)
        DFA_PRODUCTION(IREGI_R12, negI_reg_rule, c)
        DFA_PRODUCTION(IREGI_R13, negI_reg_rule, c)
        DFA_PRODUCTION(IREGI_R14, negI_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMISUB) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMISUB] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, subI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, subI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, subI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, subI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, subI_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, subI_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, subI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, subI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, subI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, subI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, subI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, subI_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_SubL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMML0) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+_kids[1]->_cost[IREGL] + ALU_COST;
        DFA_PRODUCTION(IREGLNOSP, negL_reg_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, negL_reg_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, negL_reg_rule, c)
        DFA_PRODUCTION(IREGL_R29, negL_reg_rule, c)
        DFA_PRODUCTION(IREGL_R30, negL_reg_rule, c)
        DFA_PRODUCTION(IREGL_R10, negL_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMLSUB) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMLSUB] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, subL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, subL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, subL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, subL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, subL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, subL_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, subL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, subL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, subL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, subL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, subL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, subL_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_TailCall(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGPNOSP) && STATE__VALID_CHILD(_kids[1], INLINE_CACHE_REGP) ) {
      unsigned int c = _kids[0]->_cost[IREGPNOSP]+_kids[1]->_cost[INLINE_CACHE_REGP] + BRANCH_COST;
        DFA_PRODUCTION(UNIVERSE, TailCalljmpInd_rule, c)
    }
}
void  State::_sub_Op_TailJump(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGPNOSP) && STATE__VALID_CHILD(_kids[1], IREGP_R10) ) {
      unsigned int c = _kids[0]->_cost[IREGPNOSP]+_kids[1]->_cost[IREGP_R10]+ALU_COST + BRANCH_COST;
        DFA_PRODUCTION(UNIVERSE, TailjmpInd_rule, c)
    }
}
void  State::_sub_Op_ThreadLocal(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION(JAVATHREAD_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(IREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(INDIRECT, tlsLoadP_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)
        DFA_PRODUCTION(VMEMA, indirect_rule, c)
        DFA_PRODUCTION(INLINE_CACHE_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION(IREGNORP, iRegP_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegP_rule, c)
    }
}
void  State::_sub_Op_URShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IMMI] + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, urShiftI_reg_imm_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, urShiftI_reg_imm_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, urShiftI_reg_imm_rule, c)
        DFA_PRODUCTION(IREGI_R12, urShiftI_reg_imm_rule, c)
        DFA_PRODUCTION(IREGI_R13, urShiftI_reg_imm_rule, c)
        DFA_PRODUCTION(IREGI_R14, urShiftI_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[IREGIORL2I] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, urShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, urShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, urShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, urShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, urShiftI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, urShiftI_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTI_IREGIORL2I_IMMI_31) && STATE__VALID_CHILD(_kids[1], IMMI_31) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTI_IREGIORL2I_IMMI_31]+_kids[1]->_cost[IMMI_31] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, signExtract_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, signExtract_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, signExtract_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, signExtract_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, signExtract_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, signExtract_rule, c)
      }
    }
}
void  State::_sub_Op_URShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X_IREGP_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X_IREGP_]+_kids[1]->_cost[IMMI] + ALU_COST;
        DFA_PRODUCTION(IREGLNOSP, urShiftP_reg_imm_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, urShiftP_reg_imm_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, urShiftP_reg_imm_rule, c)
        DFA_PRODUCTION(IREGL_R29, urShiftP_reg_imm_rule, c)
        DFA_PRODUCTION(IREGL_R30, urShiftP_reg_imm_rule, c)
        DFA_PRODUCTION(IREGL_R10, urShiftP_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMI] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, urShiftL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, urShiftL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, urShiftL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, urShiftL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, urShiftL_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, urShiftL_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGIORL2I] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, urShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, urShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, urShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, urShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, urShiftL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, urShiftL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL_IREGL_IMMI_63) && STATE__VALID_CHILD(_kids[1], IMMI_63) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL_IREGL_IMMI_63]+_kids[1]->_cost[IMMI_63] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, signExtractL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, signExtractL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, signExtractL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, signExtractL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, signExtractL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, signExtractL_rule, c)
      }
    }
}
void  State::_sub_Op_XorI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION(_XORI_IREGI_IMMI_M1, _XorI_iRegI_immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMIADD) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMIADD] + ALU_COST;
        DFA_PRODUCTION(IREGINOSP, xorI_reg_imm_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, xorI_reg_imm_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, xorI_reg_imm_rule, c)
        DFA_PRODUCTION(IREGI_R12, xorI_reg_imm_rule, c)
        DFA_PRODUCTION(IREGI_R13, xorI_reg_imm_rule, c)
        DFA_PRODUCTION(IREGI_R14, xorI_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IREGI) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IREGI] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, xorI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, xorI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, xorI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, xorI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, xorI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, xorI_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[IMMI_M1] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, regI_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, regI_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, regI_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, regI_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, regI_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, regI_not_reg_rule, c)
      }
    }
}
void  State::_sub_Op_XorL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML_M1];
        DFA_PRODUCTION(_XORL_IREGL_IMML_M1, _XorL_iRegL_immL_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMMLADD) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMMLADD] + ALU_COST;
        DFA_PRODUCTION(IREGLNOSP, xorL_reg_imm_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, xorL_reg_imm_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, xorL_reg_imm_rule, c)
        DFA_PRODUCTION(IREGL_R29, xorL_reg_imm_rule, c)
        DFA_PRODUCTION(IREGL_R30, xorL_reg_imm_rule, c)
        DFA_PRODUCTION(IREGL_R10, xorL_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IREGL] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, xorL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, xorL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, xorL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, xorL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, xorL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, xorL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[IMML_M1] + ALU_COST;
      if (STATE__NOT_YET_VALID(IREGLNOSP) || _cost[IREGLNOSP] > c) {
        DFA_PRODUCTION(IREGLNOSP, regL_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL) || _cost[IREGL] > c) {
        DFA_PRODUCTION(IREGL, regL_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R28) || _cost[IREGL_R28] > c) {
        DFA_PRODUCTION(IREGL_R28, regL_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R29) || _cost[IREGL_R29] > c) {
        DFA_PRODUCTION(IREGL_R29, regL_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R30) || _cost[IREGL_R30] > c) {
        DFA_PRODUCTION(IREGL_R30, regL_not_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGL_R10) || _cost[IREGL_R10] > c) {
        DFA_PRODUCTION(IREGL_R10, regL_not_reg_rule, c)
      }
    }
}
void  State::_sub_Op_AddVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _MULVB_VREG_VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[_MULVB_VREG_VREG]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vmlaB_0_rule, c)
        DFA_PRODUCTION(VREG_V1, vmlaB_0_rule, c)
        DFA_PRODUCTION(VREG_V2, vmlaB_0_rule, c)
        DFA_PRODUCTION(VREG_V3, vmlaB_0_rule, c)
        DFA_PRODUCTION(VREG_V4, vmlaB_0_rule, c)
        DFA_PRODUCTION(VREG_V5, vmlaB_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _MULVB_VREG_VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_MULVB_VREG_VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vmlaB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vmlaB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vmlaB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vmlaB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vmlaB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vmlaB_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vaddB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vaddB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vaddB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vaddB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vaddB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vaddB_rule, c)
      }
    }
}
void  State::_sub_Op_AddVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _MULVS_VREG_VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[_MULVS_VREG_VREG]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vmlaS_0_rule, c)
        DFA_PRODUCTION(VREG_V1, vmlaS_0_rule, c)
        DFA_PRODUCTION(VREG_V2, vmlaS_0_rule, c)
        DFA_PRODUCTION(VREG_V3, vmlaS_0_rule, c)
        DFA_PRODUCTION(VREG_V4, vmlaS_0_rule, c)
        DFA_PRODUCTION(VREG_V5, vmlaS_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _MULVS_VREG_VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_MULVS_VREG_VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vmlaS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vmlaS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vmlaS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vmlaS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vmlaS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vmlaS_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vaddS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vaddS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vaddS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vaddS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vaddS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vaddS_rule, c)
      }
    }
}
void  State::_sub_Op_AddVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _MULVI_VREG_VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[_MULVI_VREG_VREG]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vmlaI_0_rule, c)
        DFA_PRODUCTION(VREG_V1, vmlaI_0_rule, c)
        DFA_PRODUCTION(VREG_V2, vmlaI_0_rule, c)
        DFA_PRODUCTION(VREG_V3, vmlaI_0_rule, c)
        DFA_PRODUCTION(VREG_V4, vmlaI_0_rule, c)
        DFA_PRODUCTION(VREG_V5, vmlaI_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _MULVI_VREG_VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_MULVI_VREG_VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vmlaI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vmlaI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vmlaI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vmlaI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vmlaI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vmlaI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vaddI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vaddI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vaddI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vaddI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vaddI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vaddI_rule, c)
      }
    }
}
void  State::_sub_Op_AddReductionVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], VREG) &&
        (
#line 827 "src/hotspot/cpu/riscv/riscv_v.ad"
n->in(2)->bottom_type()->is_vect()->element_basic_type() == T_INT
#line 8742 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(IREGINOSP, reduce_addI_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
        DFA_PRODUCTION(IREGI, reduce_addI_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
        DFA_PRODUCTION(IREGI_R10, reduce_addI_rule, c)
        DFA_PRODUCTION(IREGI_R12, reduce_addI_rule, c)
        DFA_PRODUCTION(IREGI_R13, reduce_addI_rule, c)
        DFA_PRODUCTION(IREGI_R14, reduce_addI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], VREG) &&
        (
#line 809 "src/hotspot/cpu/riscv/riscv_v.ad"
n->in(2)->bottom_type()->is_vect()->element_basic_type() == T_SHORT
#line 8760 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, reduce_addS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, reduce_addS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, reduce_addS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, reduce_addS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, reduce_addS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, reduce_addS_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], VREG) &&
        (
#line 791 "src/hotspot/cpu/riscv/riscv_v.ad"
n->in(2)->bottom_type()->is_vect()->element_basic_type() == T_BYTE
#line 8798 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, reduce_addB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, reduce_addB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, reduce_addB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, reduce_addB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, reduce_addB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, reduce_addB_rule, c)
      }
    }
}
void  State::_sub_Op_AddVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _MULVL_VREG_VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[_MULVL_VREG_VREG]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vmlaL_0_rule, c)
        DFA_PRODUCTION(VREG_V1, vmlaL_0_rule, c)
        DFA_PRODUCTION(VREG_V2, vmlaL_0_rule, c)
        DFA_PRODUCTION(VREG_V3, vmlaL_0_rule, c)
        DFA_PRODUCTION(VREG_V4, vmlaL_0_rule, c)
        DFA_PRODUCTION(VREG_V5, vmlaL_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _MULVL_VREG_VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_MULVL_VREG_VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vmlaL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vmlaL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vmlaL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vmlaL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vmlaL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vmlaL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vaddL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vaddL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vaddL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vaddL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vaddL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vaddL_rule, c)
      }
    }
}
void  State::_sub_Op_AddReductionVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], VREG) &&
        (
#line 845 "src/hotspot/cpu/riscv/riscv_v.ad"
n->in(2)->bottom_type()->is_vect()->element_basic_type() == T_LONG
#line 8891 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(IREGLNOSP, reduce_addL_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, reduce_addL_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, reduce_addL_rule, c)
        DFA_PRODUCTION(IREGL_R29, reduce_addL_rule, c)
        DFA_PRODUCTION(IREGL_R30, reduce_addL_rule, c)
        DFA_PRODUCTION(IREGL_R10, reduce_addL_rule, c)
    }
}
void  State::_sub_Op_AddVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vaddF_rule, c)
        DFA_PRODUCTION(VREG_V1, vaddF_rule, c)
        DFA_PRODUCTION(VREG_V2, vaddF_rule, c)
        DFA_PRODUCTION(VREG_V3, vaddF_rule, c)
        DFA_PRODUCTION(VREG_V4, vaddF_rule, c)
        DFA_PRODUCTION(VREG_V5, vaddF_rule, c)
    }
}
void  State::_sub_Op_AddReductionVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(FREGF, reduce_addF_rule, c)
    }
}
void  State::_sub_Op_AddVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vaddD_rule, c)
        DFA_PRODUCTION(VREG_V1, vaddD_rule, c)
        DFA_PRODUCTION(VREG_V2, vaddD_rule, c)
        DFA_PRODUCTION(VREG_V3, vaddD_rule, c)
        DFA_PRODUCTION(VREG_V4, vaddD_rule, c)
        DFA_PRODUCTION(VREG_V5, vaddD_rule, c)
    }
}
void  State::_sub_Op_AddReductionVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(FREGD, reduce_addD_rule, c)
    }
}
void  State::_sub_Op_SubVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vsubB_rule, c)
        DFA_PRODUCTION(VREG_V1, vsubB_rule, c)
        DFA_PRODUCTION(VREG_V2, vsubB_rule, c)
        DFA_PRODUCTION(VREG_V3, vsubB_rule, c)
        DFA_PRODUCTION(VREG_V4, vsubB_rule, c)
        DFA_PRODUCTION(VREG_V5, vsubB_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _MULVB_VREG_VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_MULVB_VREG_VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vmlsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vmlsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vmlsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vmlsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vmlsB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vmlsB_rule, c)
      }
    }
}
void  State::_sub_Op_SubVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vsubS_rule, c)
        DFA_PRODUCTION(VREG_V1, vsubS_rule, c)
        DFA_PRODUCTION(VREG_V2, vsubS_rule, c)
        DFA_PRODUCTION(VREG_V3, vsubS_rule, c)
        DFA_PRODUCTION(VREG_V4, vsubS_rule, c)
        DFA_PRODUCTION(VREG_V5, vsubS_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _MULVS_VREG_VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_MULVS_VREG_VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vmlsS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vmlsS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vmlsS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vmlsS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vmlsS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vmlsS_rule, c)
      }
    }
}
void  State::_sub_Op_SubVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vsubI_rule, c)
        DFA_PRODUCTION(VREG_V1, vsubI_rule, c)
        DFA_PRODUCTION(VREG_V2, vsubI_rule, c)
        DFA_PRODUCTION(VREG_V3, vsubI_rule, c)
        DFA_PRODUCTION(VREG_V4, vsubI_rule, c)
        DFA_PRODUCTION(VREG_V5, vsubI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _MULVI_VREG_VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_MULVI_VREG_VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vmlsI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vmlsI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vmlsI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vmlsI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vmlsI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vmlsI_rule, c)
      }
    }
}
void  State::_sub_Op_SubVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vsubL_rule, c)
        DFA_PRODUCTION(VREG_V1, vsubL_rule, c)
        DFA_PRODUCTION(VREG_V2, vsubL_rule, c)
        DFA_PRODUCTION(VREG_V3, vsubL_rule, c)
        DFA_PRODUCTION(VREG_V4, vsubL_rule, c)
        DFA_PRODUCTION(VREG_V5, vsubL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _MULVL_VREG_VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_MULVL_VREG_VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vmlsL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vmlsL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vmlsL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vmlsL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vmlsL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vmlsL_rule, c)
      }
    }
}
void  State::_sub_Op_SubVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vsubF_rule, c)
        DFA_PRODUCTION(VREG_V1, vsubF_rule, c)
        DFA_PRODUCTION(VREG_V2, vsubF_rule, c)
        DFA_PRODUCTION(VREG_V3, vsubF_rule, c)
        DFA_PRODUCTION(VREG_V4, vsubF_rule, c)
        DFA_PRODUCTION(VREG_V5, vsubF_rule, c)
    }
}
void  State::_sub_Op_SubVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vsubD_rule, c)
        DFA_PRODUCTION(VREG_V1, vsubD_rule, c)
        DFA_PRODUCTION(VREG_V2, vsubD_rule, c)
        DFA_PRODUCTION(VREG_V3, vsubD_rule, c)
        DFA_PRODUCTION(VREG_V4, vsubD_rule, c)
        DFA_PRODUCTION(VREG_V5, vsubD_rule, c)
    }
}
void  State::_sub_Op_MulVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vmulB_rule, c)
        DFA_PRODUCTION(VREG_V1, vmulB_rule, c)
        DFA_PRODUCTION(VREG_V2, vmulB_rule, c)
        DFA_PRODUCTION(VREG_V3, vmulB_rule, c)
        DFA_PRODUCTION(VREG_V4, vmulB_rule, c)
        DFA_PRODUCTION(VREG_V5, vmulB_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG];
        DFA_PRODUCTION(_MULVB_VREG_VREG, _MulVB_vReg_vReg_rule, c)
    }
}
void  State::_sub_Op_MulVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vmulS_rule, c)
        DFA_PRODUCTION(VREG_V1, vmulS_rule, c)
        DFA_PRODUCTION(VREG_V2, vmulS_rule, c)
        DFA_PRODUCTION(VREG_V3, vmulS_rule, c)
        DFA_PRODUCTION(VREG_V4, vmulS_rule, c)
        DFA_PRODUCTION(VREG_V5, vmulS_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG];
        DFA_PRODUCTION(_MULVS_VREG_VREG, _MulVS_vReg_vReg_rule, c)
    }
}
void  State::_sub_Op_MulVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vmulI_rule, c)
        DFA_PRODUCTION(VREG_V1, vmulI_rule, c)
        DFA_PRODUCTION(VREG_V2, vmulI_rule, c)
        DFA_PRODUCTION(VREG_V3, vmulI_rule, c)
        DFA_PRODUCTION(VREG_V4, vmulI_rule, c)
        DFA_PRODUCTION(VREG_V5, vmulI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG];
        DFA_PRODUCTION(_MULVI_VREG_VREG, _MulVI_vReg_vReg_rule, c)
    }
}
void  State::_sub_Op_MulVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vmulL_rule, c)
        DFA_PRODUCTION(VREG_V1, vmulL_rule, c)
        DFA_PRODUCTION(VREG_V2, vmulL_rule, c)
        DFA_PRODUCTION(VREG_V3, vmulL_rule, c)
        DFA_PRODUCTION(VREG_V4, vmulL_rule, c)
        DFA_PRODUCTION(VREG_V5, vmulL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG];
        DFA_PRODUCTION(_MULVL_VREG_VREG, _MulVL_vReg_vReg_rule, c)
    }
}
void  State::_sub_Op_MulVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vmulF_rule, c)
        DFA_PRODUCTION(VREG_V1, vmulF_rule, c)
        DFA_PRODUCTION(VREG_V2, vmulF_rule, c)
        DFA_PRODUCTION(VREG_V3, vmulF_rule, c)
        DFA_PRODUCTION(VREG_V4, vmulF_rule, c)
        DFA_PRODUCTION(VREG_V5, vmulF_rule, c)
    }
}
void  State::_sub_Op_MulVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vmulD_rule, c)
        DFA_PRODUCTION(VREG_V1, vmulD_rule, c)
        DFA_PRODUCTION(VREG_V2, vmulD_rule, c)
        DFA_PRODUCTION(VREG_V3, vmulD_rule, c)
        DFA_PRODUCTION(VREG_V4, vmulD_rule, c)
        DFA_PRODUCTION(VREG_V5, vmulD_rule, c)
    }
}
void  State::_sub_Op_FmaVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _NEGVD_VREG_) && STATE__VALID_CHILD(_kids[1], _BINARY_VREG_VREG) &&
        (
#line 570 "src/hotspot/cpu/riscv/riscv_v.ad"
UseFMA
#line 9176 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGVD_VREG_]+_kids[1]->_cost[_BINARY_VREG_VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vfnmlsD_rule, c)
        DFA_PRODUCTION(VREG_V1, vfnmlsD_rule, c)
        DFA_PRODUCTION(VREG_V2, vfnmlsD_rule, c)
        DFA_PRODUCTION(VREG_V3, vfnmlsD_rule, c)
        DFA_PRODUCTION(VREG_V4, vfnmlsD_rule, c)
        DFA_PRODUCTION(VREG_V5, vfnmlsD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGVD_VREG_) && STATE__VALID_CHILD(_kids[1], _BINARY_VREG__NEGVD_VREG_) &&
        (
#line 539 "src/hotspot/cpu/riscv/riscv_v.ad"
UseFMA
#line 9190 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGVD_VREG_]+_kids[1]->_cost[_BINARY_VREG__NEGVD_VREG_] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vfnmlaD_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vfnmlaD_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vfnmlaD_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vfnmlaD_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vfnmlaD_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vfnmlaD_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGVD_VREG_) && STATE__VALID_CHILD(_kids[1], _BINARY__NEGVD_VREG__VREG) &&
        (
#line 539 "src/hotspot/cpu/riscv/riscv_v.ad"
UseFMA
#line 9216 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGVD_VREG_]+_kids[1]->_cost[_BINARY__NEGVD_VREG__VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vfnmlaD_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vfnmlaD_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vfnmlaD_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vfnmlaD_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vfnmlaD_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vfnmlaD_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _BINARY_VREG__NEGVD_VREG_) &&
        (
#line 505 "src/hotspot/cpu/riscv/riscv_v.ad"
UseFMA
#line 9242 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_BINARY_VREG__NEGVD_VREG_] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vfmlsD_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vfmlsD_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vfmlsD_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vfmlsD_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vfmlsD_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vfmlsD_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _BINARY__NEGVD_VREG__VREG) &&
        (
#line 505 "src/hotspot/cpu/riscv/riscv_v.ad"
UseFMA
#line 9268 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_BINARY__NEGVD_VREG__VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vfmlsD_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vfmlsD_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vfmlsD_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vfmlsD_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vfmlsD_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vfmlsD_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _BINARY_VREG_VREG) &&
        (
#line 472 "src/hotspot/cpu/riscv/riscv_v.ad"
UseFMA
#line 9294 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_BINARY_VREG_VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vfmlaD_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vfmlaD_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vfmlaD_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vfmlaD_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vfmlaD_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vfmlaD_rule, c)
      }
    }
}
void  State::_sub_Op_FmaVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _NEGVF_VREG_) && STATE__VALID_CHILD(_kids[1], _BINARY_VREG_VREG) &&
        (
#line 556 "src/hotspot/cpu/riscv/riscv_v.ad"
UseFMA
#line 9322 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGVF_VREG_]+_kids[1]->_cost[_BINARY_VREG_VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vfnmlsF_rule, c)
        DFA_PRODUCTION(VREG_V1, vfnmlsF_rule, c)
        DFA_PRODUCTION(VREG_V2, vfnmlsF_rule, c)
        DFA_PRODUCTION(VREG_V3, vfnmlsF_rule, c)
        DFA_PRODUCTION(VREG_V4, vfnmlsF_rule, c)
        DFA_PRODUCTION(VREG_V5, vfnmlsF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGVF_VREG_) && STATE__VALID_CHILD(_kids[1], _BINARY_VREG__NEGVF_VREG_) &&
        (
#line 523 "src/hotspot/cpu/riscv/riscv_v.ad"
UseFMA
#line 9336 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGVF_VREG_]+_kids[1]->_cost[_BINARY_VREG__NEGVF_VREG_] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vfnmlaF_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vfnmlaF_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vfnmlaF_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vfnmlaF_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vfnmlaF_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vfnmlaF_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _NEGVF_VREG_) && STATE__VALID_CHILD(_kids[1], _BINARY__NEGVF_VREG__VREG) &&
        (
#line 523 "src/hotspot/cpu/riscv/riscv_v.ad"
UseFMA
#line 9362 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_NEGVF_VREG_]+_kids[1]->_cost[_BINARY__NEGVF_VREG__VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vfnmlaF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vfnmlaF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vfnmlaF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vfnmlaF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vfnmlaF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vfnmlaF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _BINARY_VREG__NEGVF_VREG_) &&
        (
#line 489 "src/hotspot/cpu/riscv/riscv_v.ad"
UseFMA
#line 9388 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_BINARY_VREG__NEGVF_VREG_] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vfmlsF_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vfmlsF_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vfmlsF_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vfmlsF_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vfmlsF_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vfmlsF_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _BINARY__NEGVF_VREG__VREG) &&
        (
#line 489 "src/hotspot/cpu/riscv/riscv_v.ad"
UseFMA
#line 9414 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_BINARY__NEGVF_VREG__VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vfmlsF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vfmlsF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vfmlsF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vfmlsF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vfmlsF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vfmlsF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _BINARY_VREG_VREG) &&
        (
#line 458 "src/hotspot/cpu/riscv/riscv_v.ad"
UseFMA
#line 9440 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_BINARY_VREG_VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vfmlaF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vfmlaF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vfmlaF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vfmlaF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vfmlaF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vfmlaF_rule, c)
      }
    }
}
void  State::_sub_Op_DivVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vdivF_rule, c)
        DFA_PRODUCTION(VREG_V1, vdivF_rule, c)
        DFA_PRODUCTION(VREG_V2, vdivF_rule, c)
        DFA_PRODUCTION(VREG_V3, vdivF_rule, c)
        DFA_PRODUCTION(VREG_V4, vdivF_rule, c)
        DFA_PRODUCTION(VREG_V5, vdivF_rule, c)
    }
}
void  State::_sub_Op_DivVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vdivD_rule, c)
        DFA_PRODUCTION(VREG_V1, vdivD_rule, c)
        DFA_PRODUCTION(VREG_V2, vdivD_rule, c)
        DFA_PRODUCTION(VREG_V3, vdivD_rule, c)
        DFA_PRODUCTION(VREG_V4, vdivD_rule, c)
        DFA_PRODUCTION(VREG_V5, vdivD_rule, c)
    }
}
void  State::_sub_Op_AbsVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vabsB_rule, c)
        DFA_PRODUCTION(VREG_V1, vabsB_rule, c)
        DFA_PRODUCTION(VREG_V2, vabsB_rule, c)
        DFA_PRODUCTION(VREG_V3, vabsB_rule, c)
        DFA_PRODUCTION(VREG_V4, vabsB_rule, c)
        DFA_PRODUCTION(VREG_V5, vabsB_rule, c)
    }
}
void  State::_sub_Op_AbsVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vabsS_rule, c)
        DFA_PRODUCTION(VREG_V1, vabsS_rule, c)
        DFA_PRODUCTION(VREG_V2, vabsS_rule, c)
        DFA_PRODUCTION(VREG_V3, vabsS_rule, c)
        DFA_PRODUCTION(VREG_V4, vabsS_rule, c)
        DFA_PRODUCTION(VREG_V5, vabsS_rule, c)
    }
}
void  State::_sub_Op_AbsVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vabsI_rule, c)
        DFA_PRODUCTION(VREG_V1, vabsI_rule, c)
        DFA_PRODUCTION(VREG_V2, vabsI_rule, c)
        DFA_PRODUCTION(VREG_V3, vabsI_rule, c)
        DFA_PRODUCTION(VREG_V4, vabsI_rule, c)
        DFA_PRODUCTION(VREG_V5, vabsI_rule, c)
    }
}
void  State::_sub_Op_AbsVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vabsL_rule, c)
        DFA_PRODUCTION(VREG_V1, vabsL_rule, c)
        DFA_PRODUCTION(VREG_V2, vabsL_rule, c)
        DFA_PRODUCTION(VREG_V3, vabsL_rule, c)
        DFA_PRODUCTION(VREG_V4, vabsL_rule, c)
        DFA_PRODUCTION(VREG_V5, vabsL_rule, c)
    }
}
void  State::_sub_Op_AbsVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vabsF_rule, c)
        DFA_PRODUCTION(VREG_V1, vabsF_rule, c)
        DFA_PRODUCTION(VREG_V2, vabsF_rule, c)
        DFA_PRODUCTION(VREG_V3, vabsF_rule, c)
        DFA_PRODUCTION(VREG_V4, vabsF_rule, c)
        DFA_PRODUCTION(VREG_V5, vabsF_rule, c)
    }
}
void  State::_sub_Op_AbsVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vabsD_rule, c)
        DFA_PRODUCTION(VREG_V1, vabsD_rule, c)
        DFA_PRODUCTION(VREG_V2, vabsD_rule, c)
        DFA_PRODUCTION(VREG_V3, vabsD_rule, c)
        DFA_PRODUCTION(VREG_V4, vabsD_rule, c)
        DFA_PRODUCTION(VREG_V5, vabsD_rule, c)
    }
}
void  State::_sub_Op_NegVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vnegF_rule, c)
        DFA_PRODUCTION(VREG_V1, vnegF_rule, c)
        DFA_PRODUCTION(VREG_V2, vnegF_rule, c)
        DFA_PRODUCTION(VREG_V3, vnegF_rule, c)
        DFA_PRODUCTION(VREG_V4, vnegF_rule, c)
        DFA_PRODUCTION(VREG_V5, vnegF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG];
        DFA_PRODUCTION(_NEGVF_VREG_, _NegVF_vReg__rule, c)
    }
}
void  State::_sub_Op_NegVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vnegD_rule, c)
        DFA_PRODUCTION(VREG_V1, vnegD_rule, c)
        DFA_PRODUCTION(VREG_V2, vnegD_rule, c)
        DFA_PRODUCTION(VREG_V3, vnegD_rule, c)
        DFA_PRODUCTION(VREG_V4, vnegD_rule, c)
        DFA_PRODUCTION(VREG_V5, vnegD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG];
        DFA_PRODUCTION(_NEGVD_VREG_, _NegVD_vReg__rule, c)
    }
}
void  State::_sub_Op_SqrtVD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vsqrtD_rule, c)
        DFA_PRODUCTION(VREG_V1, vsqrtD_rule, c)
        DFA_PRODUCTION(VREG_V2, vsqrtD_rule, c)
        DFA_PRODUCTION(VREG_V3, vsqrtD_rule, c)
        DFA_PRODUCTION(VREG_V4, vsqrtD_rule, c)
        DFA_PRODUCTION(VREG_V5, vsqrtD_rule, c)
    }
}
void  State::_sub_Op_SqrtVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vsqrtF_rule, c)
        DFA_PRODUCTION(VREG_V1, vsqrtF_rule, c)
        DFA_PRODUCTION(VREG_V2, vsqrtF_rule, c)
        DFA_PRODUCTION(VREG_V3, vsqrtF_rule, c)
        DFA_PRODUCTION(VREG_V4, vsqrtF_rule, c)
        DFA_PRODUCTION(VREG_V5, vsqrtF_rule, c)
    }
}
void  State::_sub_Op_LShiftCntV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 1689 "src/hotspot/cpu/riscv/riscv_v.ad"
n->bottom_type()->is_vect()->element_basic_type() == T_LONG
#line 9608 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + DEFAULT_COST;
        DFA_PRODUCTION(VREG, vshiftcntL_rule, c)
        DFA_PRODUCTION(VREG_V1, vshiftcntL_rule, c)
        DFA_PRODUCTION(VREG_V2, vshiftcntL_rule, c)
        DFA_PRODUCTION(VREG_V3, vshiftcntL_rule, c)
        DFA_PRODUCTION(VREG_V4, vshiftcntL_rule, c)
        DFA_PRODUCTION(VREG_V5, vshiftcntL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 1677 "src/hotspot/cpu/riscv/riscv_v.ad"
n->bottom_type()->is_vect()->element_basic_type() == T_INT
#line 9622 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vshiftcntI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vshiftcntI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vshiftcntI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vshiftcntI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vshiftcntI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vshiftcntI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 1664 "src/hotspot/cpu/riscv/riscv_v.ad"
n->bottom_type()->is_vect()->element_basic_type() == T_SHORT ||
            n->bottom_type()->is_vect()->element_basic_type() == T_CHAR
#line 9649 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vshiftcntS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vshiftcntS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vshiftcntS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vshiftcntS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vshiftcntS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vshiftcntS_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 1652 "src/hotspot/cpu/riscv/riscv_v.ad"
n->bottom_type()->is_vect()->element_basic_type() == T_BYTE
#line 9675 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vshiftcntB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vshiftcntB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vshiftcntB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vshiftcntB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vshiftcntB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vshiftcntB_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IMMI];
        DFA_PRODUCTION(_LSHIFTCNTV_IMMI_, _LShiftCntV_immI__rule, c)
    }
}
void  State::_sub_Op_RShiftCntV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 1689 "src/hotspot/cpu/riscv/riscv_v.ad"
n->bottom_type()->is_vect()->element_basic_type() == T_LONG
#line 9707 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + DEFAULT_COST;
        DFA_PRODUCTION(VREG, vshiftcntL_0_rule, c)
        DFA_PRODUCTION(VREG_V1, vshiftcntL_0_rule, c)
        DFA_PRODUCTION(VREG_V2, vshiftcntL_0_rule, c)
        DFA_PRODUCTION(VREG_V3, vshiftcntL_0_rule, c)
        DFA_PRODUCTION(VREG_V4, vshiftcntL_0_rule, c)
        DFA_PRODUCTION(VREG_V5, vshiftcntL_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 1677 "src/hotspot/cpu/riscv/riscv_v.ad"
n->bottom_type()->is_vect()->element_basic_type() == T_INT
#line 9721 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vshiftcntI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vshiftcntI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vshiftcntI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vshiftcntI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vshiftcntI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vshiftcntI_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 1664 "src/hotspot/cpu/riscv/riscv_v.ad"
n->bottom_type()->is_vect()->element_basic_type() == T_SHORT ||
            n->bottom_type()->is_vect()->element_basic_type() == T_CHAR
#line 9748 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vshiftcntS_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vshiftcntS_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vshiftcntS_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vshiftcntS_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vshiftcntS_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vshiftcntS_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) &&
        (
#line 1652 "src/hotspot/cpu/riscv/riscv_v.ad"
n->bottom_type()->is_vect()->element_basic_type() == T_BYTE
#line 9774 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + DEFAULT_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vshiftcntB_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vshiftcntB_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vshiftcntB_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vshiftcntB_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vshiftcntB_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vshiftcntB_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) ) {
      unsigned int c = _kids[0]->_cost[IMMI];
        DFA_PRODUCTION(_RSHIFTCNTV_IMMI_, _RShiftCntV_immI__rule, c)
    }
}
void  State::_sub_Op_LShiftVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _LSHIFTCNTV_IMMI_) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_LSHIFTCNTV_IMMI_] + VEC_COST;
        DFA_PRODUCTION(VREG, vlslB_imm_rule, c)
        DFA_PRODUCTION(VREG_V1, vlslB_imm_rule, c)
        DFA_PRODUCTION(VREG_V2, vlslB_imm_rule, c)
        DFA_PRODUCTION(VREG_V3, vlslB_imm_rule, c)
        DFA_PRODUCTION(VREG_V4, vlslB_imm_rule, c)
        DFA_PRODUCTION(VREG_V5, vlslB_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vlslB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vlslB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vlslB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vlslB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vlslB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vlslB_rule, c)
      }
    }
}
void  State::_sub_Op_LShiftVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _LSHIFTCNTV_IMMI_) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_LSHIFTCNTV_IMMI_] + VEC_COST;
        DFA_PRODUCTION(VREG, vlslS_imm_rule, c)
        DFA_PRODUCTION(VREG_V1, vlslS_imm_rule, c)
        DFA_PRODUCTION(VREG_V2, vlslS_imm_rule, c)
        DFA_PRODUCTION(VREG_V3, vlslS_imm_rule, c)
        DFA_PRODUCTION(VREG_V4, vlslS_imm_rule, c)
        DFA_PRODUCTION(VREG_V5, vlslS_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vlslS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vlslS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vlslS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vlslS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vlslS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vlslS_rule, c)
      }
    }
}
void  State::_sub_Op_LShiftVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _LSHIFTCNTV_IMMI_) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_LSHIFTCNTV_IMMI_] + VEC_COST;
        DFA_PRODUCTION(VREG, vlslI_imm_rule, c)
        DFA_PRODUCTION(VREG_V1, vlslI_imm_rule, c)
        DFA_PRODUCTION(VREG_V2, vlslI_imm_rule, c)
        DFA_PRODUCTION(VREG_V3, vlslI_imm_rule, c)
        DFA_PRODUCTION(VREG_V4, vlslI_imm_rule, c)
        DFA_PRODUCTION(VREG_V5, vlslI_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vlslI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vlslI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vlslI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vlslI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vlslI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vlslI_rule, c)
      }
    }
}
void  State::_sub_Op_LShiftVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _LSHIFTCNTV_IMMI_) &&
        (
#line 1639 "src/hotspot/cpu/riscv/riscv_v.ad"
(n->in(2)->in(1)->get_int() & 0x3f) < 32
#line 9902 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_LSHIFTCNTV_IMMI_] + VEC_COST;
        DFA_PRODUCTION(VREG, vlslL_imm_rule, c)
        DFA_PRODUCTION(VREG_V1, vlslL_imm_rule, c)
        DFA_PRODUCTION(VREG_V2, vlslL_imm_rule, c)
        DFA_PRODUCTION(VREG_V3, vlslL_imm_rule, c)
        DFA_PRODUCTION(VREG_V4, vlslL_imm_rule, c)
        DFA_PRODUCTION(VREG_V5, vlslL_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vlslL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vlslL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vlslL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vlslL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vlslL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vlslL_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _RSHIFTCNTV_IMMI_) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_RSHIFTCNTV_IMMI_] + VEC_COST;
        DFA_PRODUCTION(VREG, vasrB_imm_rule, c)
        DFA_PRODUCTION(VREG_V1, vasrB_imm_rule, c)
        DFA_PRODUCTION(VREG_V2, vasrB_imm_rule, c)
        DFA_PRODUCTION(VREG_V3, vasrB_imm_rule, c)
        DFA_PRODUCTION(VREG_V4, vasrB_imm_rule, c)
        DFA_PRODUCTION(VREG_V5, vasrB_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vasrB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vasrB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vasrB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vasrB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vasrB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vasrB_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _RSHIFTCNTV_IMMI_) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_RSHIFTCNTV_IMMI_] + VEC_COST;
        DFA_PRODUCTION(VREG, vasrS_imm_rule, c)
        DFA_PRODUCTION(VREG_V1, vasrS_imm_rule, c)
        DFA_PRODUCTION(VREG_V2, vasrS_imm_rule, c)
        DFA_PRODUCTION(VREG_V3, vasrS_imm_rule, c)
        DFA_PRODUCTION(VREG_V4, vasrS_imm_rule, c)
        DFA_PRODUCTION(VREG_V5, vasrS_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vasrS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vasrS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vasrS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vasrS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vasrS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vasrS_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _RSHIFTCNTV_IMMI_) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_RSHIFTCNTV_IMMI_] + VEC_COST;
        DFA_PRODUCTION(VREG, vasrI_imm_rule, c)
        DFA_PRODUCTION(VREG_V1, vasrI_imm_rule, c)
        DFA_PRODUCTION(VREG_V2, vasrI_imm_rule, c)
        DFA_PRODUCTION(VREG_V3, vasrI_imm_rule, c)
        DFA_PRODUCTION(VREG_V4, vasrI_imm_rule, c)
        DFA_PRODUCTION(VREG_V5, vasrI_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vasrI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vasrI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vasrI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vasrI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vasrI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vasrI_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _RSHIFTCNTV_IMMI_) &&
        (
#line 1496 "src/hotspot/cpu/riscv/riscv_v.ad"
(n->in(2)->in(1)->get_int() & 0x3f) < 32
#line 10035 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_RSHIFTCNTV_IMMI_] + VEC_COST;
        DFA_PRODUCTION(VREG, vasrL_imm_rule, c)
        DFA_PRODUCTION(VREG_V1, vasrL_imm_rule, c)
        DFA_PRODUCTION(VREG_V2, vasrL_imm_rule, c)
        DFA_PRODUCTION(VREG_V3, vasrL_imm_rule, c)
        DFA_PRODUCTION(VREG_V4, vasrL_imm_rule, c)
        DFA_PRODUCTION(VREG_V5, vasrL_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vasrL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vasrL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vasrL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vasrL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vasrL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vasrL_rule, c)
      }
    }
}
void  State::_sub_Op_URShiftVB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _RSHIFTCNTV_IMMI_) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_RSHIFTCNTV_IMMI_] + VEC_COST;
        DFA_PRODUCTION(VREG, vlsrB_imm_rule, c)
        DFA_PRODUCTION(VREG_V1, vlsrB_imm_rule, c)
        DFA_PRODUCTION(VREG_V2, vlsrB_imm_rule, c)
        DFA_PRODUCTION(VREG_V3, vlsrB_imm_rule, c)
        DFA_PRODUCTION(VREG_V4, vlsrB_imm_rule, c)
        DFA_PRODUCTION(VREG_V5, vlsrB_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vlsrB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vlsrB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vlsrB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vlsrB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vlsrB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vlsrB_rule, c)
      }
    }
}
void  State::_sub_Op_URShiftVS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _RSHIFTCNTV_IMMI_) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_RSHIFTCNTV_IMMI_] + VEC_COST;
        DFA_PRODUCTION(VREG, vlsrS_imm_rule, c)
        DFA_PRODUCTION(VREG_V1, vlsrS_imm_rule, c)
        DFA_PRODUCTION(VREG_V2, vlsrS_imm_rule, c)
        DFA_PRODUCTION(VREG_V3, vlsrS_imm_rule, c)
        DFA_PRODUCTION(VREG_V4, vlsrS_imm_rule, c)
        DFA_PRODUCTION(VREG_V5, vlsrS_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vlsrS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vlsrS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vlsrS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vlsrS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vlsrS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vlsrS_rule, c)
      }
    }
}
void  State::_sub_Op_URShiftVI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _RSHIFTCNTV_IMMI_) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_RSHIFTCNTV_IMMI_] + VEC_COST;
        DFA_PRODUCTION(VREG, vlsrI_imm_rule, c)
        DFA_PRODUCTION(VREG_V1, vlsrI_imm_rule, c)
        DFA_PRODUCTION(VREG_V2, vlsrI_imm_rule, c)
        DFA_PRODUCTION(VREG_V3, vlsrI_imm_rule, c)
        DFA_PRODUCTION(VREG_V4, vlsrI_imm_rule, c)
        DFA_PRODUCTION(VREG_V5, vlsrI_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vlsrI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vlsrI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vlsrI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vlsrI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vlsrI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vlsrI_rule, c)
      }
    }
}
void  State::_sub_Op_URShiftVL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], _RSHIFTCNTV_IMMI_) &&
        (
#line 1575 "src/hotspot/cpu/riscv/riscv_v.ad"
(n->in(2)->in(1)->get_int() & 0x3f) < 32
#line 10168 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[_RSHIFTCNTV_IMMI_] + VEC_COST;
        DFA_PRODUCTION(VREG, vlsrL_imm_rule, c)
        DFA_PRODUCTION(VREG_V1, vlsrL_imm_rule, c)
        DFA_PRODUCTION(VREG_V2, vlsrL_imm_rule, c)
        DFA_PRODUCTION(VREG_V3, vlsrL_imm_rule, c)
        DFA_PRODUCTION(VREG_V4, vlsrL_imm_rule, c)
        DFA_PRODUCTION(VREG_V5, vlsrL_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vlsrL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vlsrL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vlsrL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vlsrL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vlsrL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vlsrL_rule, c)
      }
    }
}
void  State::_sub_Op_AndV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vand_rule, c)
        DFA_PRODUCTION(VREG_V1, vand_rule, c)
        DFA_PRODUCTION(VREG_V2, vand_rule, c)
        DFA_PRODUCTION(VREG_V3, vand_rule, c)
        DFA_PRODUCTION(VREG_V4, vand_rule, c)
        DFA_PRODUCTION(VREG_V5, vand_rule, c)
    }
}
void  State::_sub_Op_OrV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vor_rule, c)
        DFA_PRODUCTION(VREG_V1, vor_rule, c)
        DFA_PRODUCTION(VREG_V2, vor_rule, c)
        DFA_PRODUCTION(VREG_V3, vor_rule, c)
        DFA_PRODUCTION(VREG_V4, vor_rule, c)
        DFA_PRODUCTION(VREG_V5, vor_rule, c)
    }
}
void  State::_sub_Op_XorV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vxor_rule, c)
        DFA_PRODUCTION(VREG_V1, vxor_rule, c)
        DFA_PRODUCTION(VREG_V2, vxor_rule, c)
        DFA_PRODUCTION(VREG_V3, vxor_rule, c)
        DFA_PRODUCTION(VREG_V4, vxor_rule, c)
        DFA_PRODUCTION(VREG_V5, vxor_rule, c)
    }
}
void  State::_sub_Op_MinV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) &&
        (
#line 441 "src/hotspot/cpu/riscv/riscv_v.ad"
n->bottom_type()->is_vect()->element_basic_type() == T_DOUBLE
#line 10238 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vminD_rule, c)
        DFA_PRODUCTION(VREG_V1, vminD_rule, c)
        DFA_PRODUCTION(VREG_V2, vminD_rule, c)
        DFA_PRODUCTION(VREG_V3, vminD_rule, c)
        DFA_PRODUCTION(VREG_V4, vminD_rule, c)
        DFA_PRODUCTION(VREG_V5, vminD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) &&
        (
#line 427 "src/hotspot/cpu/riscv/riscv_v.ad"
n->bottom_type()->is_vect()->element_basic_type() == T_FLOAT
#line 10252 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vminF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vminF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vminF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vminF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vminF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vminF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) &&
        (
#line 381 "src/hotspot/cpu/riscv/riscv_v.ad"
n->bottom_type()->is_vect()->element_basic_type() != T_FLOAT &&
            n->bottom_type()->is_vect()->element_basic_type() != T_DOUBLE
#line 10279 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vmin_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vmin_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vmin_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vmin_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vmin_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vmin_rule, c)
      }
    }
}
void  State::_sub_Op_MaxV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) &&
        (
#line 413 "src/hotspot/cpu/riscv/riscv_v.ad"
n->bottom_type()->is_vect()->element_basic_type() == T_DOUBLE
#line 10307 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(VREG, vmaxD_rule, c)
        DFA_PRODUCTION(VREG_V1, vmaxD_rule, c)
        DFA_PRODUCTION(VREG_V2, vmaxD_rule, c)
        DFA_PRODUCTION(VREG_V3, vmaxD_rule, c)
        DFA_PRODUCTION(VREG_V4, vmaxD_rule, c)
        DFA_PRODUCTION(VREG_V5, vmaxD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) &&
        (
#line 399 "src/hotspot/cpu/riscv/riscv_v.ad"
n->bottom_type()->is_vect()->element_basic_type() == T_FLOAT
#line 10321 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vmaxF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vmaxF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vmaxF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vmaxF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vmaxF_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vmaxF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], VREG) && STATE__VALID_CHILD(_kids[1], VREG) &&
        (
#line 365 "src/hotspot/cpu/riscv/riscv_v.ad"
n->bottom_type()->is_vect()->element_basic_type() != T_FLOAT &&
            n->bottom_type()->is_vect()->element_basic_type() != T_DOUBLE
#line 10348 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VREG]+_kids[1]->_cost[VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, vmax_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, vmax_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, vmax_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, vmax_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, vmax_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, vmax_rule, c)
      }
    }
}
void  State::_sub_Op_MinReductionV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], VREG) &&
        (
#line 1080 "src/hotspot/cpu/riscv/riscv_v.ad"
n->in(2)->bottom_type()->is_vect()->element_basic_type() == T_DOUBLE
#line 10376 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(FREGD, vreduce_minD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], VREG) &&
        (
#line 1065 "src/hotspot/cpu/riscv/riscv_v.ad"
n->in(2)->bottom_type()->is_vect()->element_basic_type() == T_FLOAT
#line 10385 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(FREGF, vreduce_minF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], VREG) &&
        (
#line 1016 "src/hotspot/cpu/riscv/riscv_v.ad"
n->in(2)->bottom_type()->is_vect()->element_basic_type() == T_LONG
#line 10394 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(IREGLNOSP, vreduce_minL_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, vreduce_minL_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, vreduce_minL_rule, c)
        DFA_PRODUCTION(IREGL_R29, vreduce_minL_rule, c)
        DFA_PRODUCTION(IREGL_R30, vreduce_minL_rule, c)
        DFA_PRODUCTION(IREGL_R10, vreduce_minL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], VREG) &&
        (
#line 1001 "src/hotspot/cpu/riscv/riscv_v.ad"
n->in(2)->bottom_type()->is_vect()->element_basic_type() == T_INT
#line 10411 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(IREGINOSP, vreduce_minI_rule, c)
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
        DFA_PRODUCTION(IREGI, vreduce_minI_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
        DFA_PRODUCTION(IREGI_R10, vreduce_minI_rule, c)
        DFA_PRODUCTION(IREGI_R12, vreduce_minI_rule, c)
        DFA_PRODUCTION(IREGI_R13, vreduce_minI_rule, c)
        DFA_PRODUCTION(IREGI_R14, vreduce_minI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], VREG) &&
        (
#line 983 "src/hotspot/cpu/riscv/riscv_v.ad"
n->in(2)->bottom_type()->is_vect()->element_basic_type() == T_SHORT
#line 10435 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, vreduce_minS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, vreduce_minS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, vreduce_minS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, vreduce_minS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, vreduce_minS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, vreduce_minS_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], VREG) &&
        (
#line 965 "src/hotspot/cpu/riscv/riscv_v.ad"
n->in(2)->bottom_type()->is_vect()->element_basic_type() == T_BYTE
#line 10473 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, vreduce_minB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, vreduce_minB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, vreduce_minB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, vreduce_minB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, vreduce_minB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, vreduce_minB_rule, c)
      }
    }
}
void  State::_sub_Op_MaxReductionV(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) && STATE__VALID_CHILD(_kids[1], VREG) &&
        (
#line 1048 "src/hotspot/cpu/riscv/riscv_v.ad"
n->in(2)->bottom_type()->is_vect()->element_basic_type() == T_DOUBLE
#line 10513 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[FREGD]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(FREGD, vreduce_maxD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], FREGF) && STATE__VALID_CHILD(_kids[1], VREG) &&
        (
#line 1033 "src/hotspot/cpu/riscv/riscv_v.ad"
n->in(2)->bottom_type()->is_vect()->element_basic_type() == T_FLOAT
#line 10522 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[FREGF]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(FREGF, vreduce_maxF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) && STATE__VALID_CHILD(_kids[1], VREG) &&
        (
#line 949 "src/hotspot/cpu/riscv/riscv_v.ad"
n->in(2)->bottom_type()->is_vect()->element_basic_type() == T_LONG
#line 10531 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGL]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(IREGLNOSP, vreduce_maxL_rule, c)
        DFA_PRODUCTION(IREGILNPNOSP, iRegLNoSp_rule, c)
        DFA_PRODUCTION(IREGL, vreduce_maxL_rule, c)
        DFA_PRODUCTION(IREGIORL, iRegL_rule, c)
        DFA_PRODUCTION(IREGILNP, iRegL_rule, c)
        DFA_PRODUCTION(IREGL_R28, vreduce_maxL_rule, c)
        DFA_PRODUCTION(IREGL_R29, vreduce_maxL_rule, c)
        DFA_PRODUCTION(IREGL_R30, vreduce_maxL_rule, c)
        DFA_PRODUCTION(IREGL_R10, vreduce_maxL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) && STATE__VALID_CHILD(_kids[1], VREG) &&
        (
#line 934 "src/hotspot/cpu/riscv/riscv_v.ad"
n->in(2)->bottom_type()->is_vect()->element_basic_type() == T_INT
#line 10548 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(IREGINOSP, vreduce_maxI_rule, c)
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
        DFA_PRODUCTION(IREGI, vreduce_maxI_rule, c)
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
        DFA_PRODUCTION(IREGI_R10, vreduce_maxI_rule, c)
        DFA_PRODUCTION(IREGI_R12, vreduce_maxI_rule, c)
        DFA_PRODUCTION(IREGI_R13, vreduce_maxI_rule, c)
        DFA_PRODUCTION(IREGI_R14, vreduce_maxI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], VREG) &&
        (
#line 916 "src/hotspot/cpu/riscv/riscv_v.ad"
n->in(2)->bottom_type()->is_vect()->element_basic_type() == T_SHORT
#line 10572 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, vreduce_maxS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, vreduce_maxS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, vreduce_maxS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, vreduce_maxS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, vreduce_maxS_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, vreduce_maxS_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IREGI) && STATE__VALID_CHILD(_kids[1], VREG) &&
        (
#line 898 "src/hotspot/cpu/riscv/riscv_v.ad"
n->in(2)->bottom_type()->is_vect()->element_basic_type() == T_BYTE
#line 10610 "dfa_riscv.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IREGI]+_kids[1]->_cost[VREG] + VEC_COST;
      if (STATE__NOT_YET_VALID(IREGINOSP) || _cost[IREGINOSP] > c) {
        DFA_PRODUCTION(IREGINOSP, vreduce_maxB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNPNOSP) || _cost[IREGILNPNOSP] > c) {
        DFA_PRODUCTION(IREGILNPNOSP, iRegINoSp_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI) || _cost[IREGI] > c) {
        DFA_PRODUCTION(IREGI, vreduce_maxB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL2I) || _cost[IREGIORL2I] > c) {
        DFA_PRODUCTION(IREGIORL2I, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGIORL) || _cost[IREGIORL] > c) {
        DFA_PRODUCTION(IREGIORL, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGILNP) || _cost[IREGILNP] > c) {
        DFA_PRODUCTION(IREGILNP, iRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R10) || _cost[IREGI_R10] > c) {
        DFA_PRODUCTION(IREGI_R10, vreduce_maxB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R12) || _cost[IREGI_R12] > c) {
        DFA_PRODUCTION(IREGI_R12, vreduce_maxB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R13) || _cost[IREGI_R13] > c) {
        DFA_PRODUCTION(IREGI_R13, vreduce_maxB_rule, c)
      }
      if (STATE__NOT_YET_VALID(IREGI_R14) || _cost[IREGI_R14] > c) {
        DFA_PRODUCTION(IREGI_R14, vreduce_maxB_rule, c)
      }
    }
}
void  State::_sub_Op_LoadVector(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VMEMA) ) {
      unsigned int c = _kids[0]->_cost[VMEMA] + VEC_COST;
        DFA_PRODUCTION(VREG, loadV_rule, c)
        DFA_PRODUCTION(VREG_V1, loadV_rule, c)
        DFA_PRODUCTION(VREG_V2, loadV_rule, c)
        DFA_PRODUCTION(VREG_V3, loadV_rule, c)
        DFA_PRODUCTION(VREG_V4, loadV_rule, c)
        DFA_PRODUCTION(VREG_V5, loadV_rule, c)
    }
}
void  State::_sub_Op_StoreVector(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VMEMA) && STATE__VALID_CHILD(_kids[1], VREG) ) {
      unsigned int c = _kids[0]->_cost[VMEMA]+_kids[1]->_cost[VREG] + VEC_COST;
        DFA_PRODUCTION(UNIVERSE, storeV_rule, c)
    }
}
void  State::_sub_Op_ReplicateB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI5) ) {
      unsigned int c = _kids[0]->_cost[IMMI5] + VEC_COST;
        DFA_PRODUCTION(VREG, replicateB_imm5_rule, c)
        DFA_PRODUCTION(VREG_V1, replicateB_imm5_rule, c)
        DFA_PRODUCTION(VREG_V2, replicateB_imm5_rule, c)
        DFA_PRODUCTION(VREG_V3, replicateB_imm5_rule, c)
        DFA_PRODUCTION(VREG_V4, replicateB_imm5_rule, c)
        DFA_PRODUCTION(VREG_V5, replicateB_imm5_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, replicateB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, replicateB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, replicateB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, replicateB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, replicateB_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, replicateB_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI5) ) {
      unsigned int c = _kids[0]->_cost[IMMI5] + VEC_COST;
        DFA_PRODUCTION(VREG, replicateS_imm5_rule, c)
        DFA_PRODUCTION(VREG_V1, replicateS_imm5_rule, c)
        DFA_PRODUCTION(VREG_V2, replicateS_imm5_rule, c)
        DFA_PRODUCTION(VREG_V3, replicateS_imm5_rule, c)
        DFA_PRODUCTION(VREG_V4, replicateS_imm5_rule, c)
        DFA_PRODUCTION(VREG_V5, replicateS_imm5_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, replicateS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, replicateS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, replicateS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, replicateS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, replicateS_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, replicateS_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI5) ) {
      unsigned int c = _kids[0]->_cost[IMMI5] + VEC_COST;
        DFA_PRODUCTION(VREG, replicateI_imm5_rule, c)
        DFA_PRODUCTION(VREG_V1, replicateI_imm5_rule, c)
        DFA_PRODUCTION(VREG_V2, replicateI_imm5_rule, c)
        DFA_PRODUCTION(VREG_V3, replicateI_imm5_rule, c)
        DFA_PRODUCTION(VREG_V4, replicateI_imm5_rule, c)
        DFA_PRODUCTION(VREG_V5, replicateI_imm5_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGIORL2I) ) {
      unsigned int c = _kids[0]->_cost[IREGIORL2I] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, replicateI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, replicateI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, replicateI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, replicateI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, replicateI_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, replicateI_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMML5) ) {
      unsigned int c = _kids[0]->_cost[IMML5] + VEC_COST;
        DFA_PRODUCTION(VREG, replicateL_imm5_rule, c)
        DFA_PRODUCTION(VREG_V1, replicateL_imm5_rule, c)
        DFA_PRODUCTION(VREG_V2, replicateL_imm5_rule, c)
        DFA_PRODUCTION(VREG_V3, replicateL_imm5_rule, c)
        DFA_PRODUCTION(VREG_V4, replicateL_imm5_rule, c)
        DFA_PRODUCTION(VREG_V5, replicateL_imm5_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IREGL) ) {
      unsigned int c = _kids[0]->_cost[IREGL] + VEC_COST;
      if (STATE__NOT_YET_VALID(VREG) || _cost[VREG] > c) {
        DFA_PRODUCTION(VREG, replicateL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V1) || _cost[VREG_V1] > c) {
        DFA_PRODUCTION(VREG_V1, replicateL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V2) || _cost[VREG_V2] > c) {
        DFA_PRODUCTION(VREG_V2, replicateL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V3) || _cost[VREG_V3] > c) {
        DFA_PRODUCTION(VREG_V3, replicateL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V4) || _cost[VREG_V4] > c) {
        DFA_PRODUCTION(VREG_V4, replicateL_rule, c)
      }
      if (STATE__NOT_YET_VALID(VREG_V5) || _cost[VREG_V5] > c) {
        DFA_PRODUCTION(VREG_V5, replicateL_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGF) ) {
      unsigned int c = _kids[0]->_cost[FREGF] + VEC_COST;
        DFA_PRODUCTION(VREG, replicateF_rule, c)
        DFA_PRODUCTION(VREG_V1, replicateF_rule, c)
        DFA_PRODUCTION(VREG_V2, replicateF_rule, c)
        DFA_PRODUCTION(VREG_V3, replicateF_rule, c)
        DFA_PRODUCTION(VREG_V4, replicateF_rule, c)
        DFA_PRODUCTION(VREG_V5, replicateF_rule, c)
    }
}
void  State::_sub_Op_ReplicateD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], FREGD) ) {
      unsigned int c = _kids[0]->_cost[FREGD] + VEC_COST;
        DFA_PRODUCTION(VREG, replicateD_rule, c)
        DFA_PRODUCTION(VREG_V1, replicateD_rule, c)
        DFA_PRODUCTION(VREG_V2, replicateD_rule, c)
        DFA_PRODUCTION(VREG_V3, replicateD_rule, c)
        DFA_PRODUCTION(VREG_V4, replicateD_rule, c)
        DFA_PRODUCTION(VREG_V5, replicateD_rule, c)
    }
}
bool State::DFA(int opcode, const Node *n) {
  switch(opcode) {
  case Op_RegN: { _sub_Op_RegN(n);
    break;
  }
  case Op_RegI: { _sub_Op_RegI(n);
    break;
  }
  case Op_RegP: { _sub_Op_RegP(n);
    break;
  }
  case Op_RegF: { _sub_Op_RegF(n);
    break;
  }
  case Op_RegD: { _sub_Op_RegD(n);
    break;
  }
  case Op_RegL: { _sub_Op_RegL(n);
    break;
  }
  case Op_VecA: { _sub_Op_VecA(n);
    break;
  }
  case Op_RegFlags: { _sub_Op_RegFlags(n);
    break;
  }
  case Op_AbsD: { _sub_Op_AbsD(n);
    break;
  }
  case Op_AbsF: { _sub_Op_AbsF(n);
    break;
  }
  case Op_AbsI: { _sub_Op_AbsI(n);
    break;
  }
  case Op_AbsL: { _sub_Op_AbsL(n);
    break;
  }
  case Op_AddD: { _sub_Op_AddD(n);
    break;
  }
  case Op_AddF: { _sub_Op_AddF(n);
    break;
  }
  case Op_AddI: { _sub_Op_AddI(n);
    break;
  }
  case Op_AddL: { _sub_Op_AddL(n);
    break;
  }
  case Op_AddP: { _sub_Op_AddP(n);
    break;
  }
  case Op_AndI: { _sub_Op_AndI(n);
    break;
  }
  case Op_AndL: { _sub_Op_AndL(n);
    break;
  }
  case Op_AryEq: { _sub_Op_AryEq(n);
    break;
  }
  case Op_Binary: { _sub_Op_Binary(n);
    break;
  }
  case Op_Bool: { _sub_Op_Bool(n);
    break;
  }
  case Op_ReverseBytesI: { _sub_Op_ReverseBytesI(n);
    break;
  }
  case Op_ReverseBytesL: { _sub_Op_ReverseBytesL(n);
    break;
  }
  case Op_ReverseBytesUS: { _sub_Op_ReverseBytesUS(n);
    break;
  }
  case Op_ReverseBytesS: { _sub_Op_ReverseBytesS(n);
    break;
  }
  case Op_CallDynamicJava: { _sub_Op_CallDynamicJava(n);
    break;
  }
  case Op_CallLeaf: { _sub_Op_CallLeaf(n);
    break;
  }
  case Op_CallLeafNoFP: { _sub_Op_CallLeafNoFP(n);
    break;
  }
  case Op_CallRuntime: { _sub_Op_CallRuntime(n);
    break;
  }
  case Op_CallStaticJava: { _sub_Op_CallStaticJava(n);
    break;
  }
  case Op_CastDD: { _sub_Op_CastDD(n);
    break;
  }
  case Op_CastFF: { _sub_Op_CastFF(n);
    break;
  }
  case Op_CastII: { _sub_Op_CastII(n);
    break;
  }
  case Op_CastLL: { _sub_Op_CastLL(n);
    break;
  }
  case Op_CastVV: { _sub_Op_CastVV(n);
    break;
  }
  case Op_CastX2P: { _sub_Op_CastX2P(n);
    break;
  }
  case Op_CastP2X: { _sub_Op_CastP2X(n);
    break;
  }
  case Op_CastPP: { _sub_Op_CastPP(n);
    break;
  }
  case Op_CheckCastPP: { _sub_Op_CheckCastPP(n);
    break;
  }
  case Op_ClearArray: { _sub_Op_ClearArray(n);
    break;
  }
  case Op_CMoveI: { _sub_Op_CMoveI(n);
    break;
  }
  case Op_CMoveL: { _sub_Op_CMoveL(n);
    break;
  }
  case Op_CmpN: { _sub_Op_CmpN(n);
    break;
  }
  case Op_CmpD: { _sub_Op_CmpD(n);
    break;
  }
  case Op_CmpD3: { _sub_Op_CmpD3(n);
    break;
  }
  case Op_CmpF: { _sub_Op_CmpF(n);
    break;
  }
  case Op_CmpF3: { _sub_Op_CmpF3(n);
    break;
  }
  case Op_CmpI: { _sub_Op_CmpI(n);
    break;
  }
  case Op_CmpL: { _sub_Op_CmpL(n);
    break;
  }
  case Op_CmpL3: { _sub_Op_CmpL3(n);
    break;
  }
  case Op_CmpLTMask: { _sub_Op_CmpLTMask(n);
    break;
  }
  case Op_CmpP: { _sub_Op_CmpP(n);
    break;
  }
  case Op_CmpU: { _sub_Op_CmpU(n);
    break;
  }
  case Op_CmpUL: { _sub_Op_CmpUL(n);
    break;
  }
  case Op_CompareAndSwapB: { _sub_Op_CompareAndSwapB(n);
    break;
  }
  case Op_CompareAndSwapS: { _sub_Op_CompareAndSwapS(n);
    break;
  }
  case Op_CompareAndSwapI: { _sub_Op_CompareAndSwapI(n);
    break;
  }
  case Op_CompareAndSwapL: { _sub_Op_CompareAndSwapL(n);
    break;
  }
  case Op_CompareAndSwapP: { _sub_Op_CompareAndSwapP(n);
    break;
  }
  case Op_CompareAndSwapN: { _sub_Op_CompareAndSwapN(n);
    break;
  }
  case Op_WeakCompareAndSwapB: { _sub_Op_WeakCompareAndSwapB(n);
    break;
  }
  case Op_WeakCompareAndSwapS: { _sub_Op_WeakCompareAndSwapS(n);
    break;
  }
  case Op_WeakCompareAndSwapI: { _sub_Op_WeakCompareAndSwapI(n);
    break;
  }
  case Op_WeakCompareAndSwapL: { _sub_Op_WeakCompareAndSwapL(n);
    break;
  }
  case Op_WeakCompareAndSwapP: { _sub_Op_WeakCompareAndSwapP(n);
    break;
  }
  case Op_WeakCompareAndSwapN: { _sub_Op_WeakCompareAndSwapN(n);
    break;
  }
  case Op_CompareAndExchangeB: { _sub_Op_CompareAndExchangeB(n);
    break;
  }
  case Op_CompareAndExchangeS: { _sub_Op_CompareAndExchangeS(n);
    break;
  }
  case Op_CompareAndExchangeI: { _sub_Op_CompareAndExchangeI(n);
    break;
  }
  case Op_CompareAndExchangeL: { _sub_Op_CompareAndExchangeL(n);
    break;
  }
  case Op_CompareAndExchangeP: { _sub_Op_CompareAndExchangeP(n);
    break;
  }
  case Op_CompareAndExchangeN: { _sub_Op_CompareAndExchangeN(n);
    break;
  }
  case Op_GetAndAddI: { _sub_Op_GetAndAddI(n);
    break;
  }
  case Op_GetAndAddL: { _sub_Op_GetAndAddL(n);
    break;
  }
  case Op_GetAndSetI: { _sub_Op_GetAndSetI(n);
    break;
  }
  case Op_GetAndSetL: { _sub_Op_GetAndSetL(n);
    break;
  }
  case Op_GetAndSetP: { _sub_Op_GetAndSetP(n);
    break;
  }
  case Op_GetAndSetN: { _sub_Op_GetAndSetN(n);
    break;
  }
  case Op_ConN: { _sub_Op_ConN(n);
    break;
  }
  case Op_ConNKlass: { _sub_Op_ConNKlass(n);
    break;
  }
  case Op_ConD: { _sub_Op_ConD(n);
    break;
  }
  case Op_ConF: { _sub_Op_ConF(n);
    break;
  }
  case Op_ConI: { _sub_Op_ConI(n);
    break;
  }
  case Op_ConL: { _sub_Op_ConL(n);
    break;
  }
  case Op_ConP: { _sub_Op_ConP(n);
    break;
  }
  case Op_Conv2B: { _sub_Op_Conv2B(n);
    break;
  }
  case Op_ConvD2F: { _sub_Op_ConvD2F(n);
    break;
  }
  case Op_ConvD2I: { _sub_Op_ConvD2I(n);
    break;
  }
  case Op_ConvD2L: { _sub_Op_ConvD2L(n);
    break;
  }
  case Op_ConvF2D: { _sub_Op_ConvF2D(n);
    break;
  }
  case Op_ConvF2I: { _sub_Op_ConvF2I(n);
    break;
  }
  case Op_ConvF2L: { _sub_Op_ConvF2L(n);
    break;
  }
  case Op_ConvI2D: { _sub_Op_ConvI2D(n);
    break;
  }
  case Op_ConvI2F: { _sub_Op_ConvI2F(n);
    break;
  }
  case Op_ConvI2L: { _sub_Op_ConvI2L(n);
    break;
  }
  case Op_ConvL2D: { _sub_Op_ConvL2D(n);
    break;
  }
  case Op_ConvL2F: { _sub_Op_ConvL2F(n);
    break;
  }
  case Op_ConvL2I: { _sub_Op_ConvL2I(n);
    break;
  }
  case Op_CountedLoopEnd: { _sub_Op_CountedLoopEnd(n);
    break;
  }
  case Op_CountLeadingZerosI: { _sub_Op_CountLeadingZerosI(n);
    break;
  }
  case Op_CountLeadingZerosL: { _sub_Op_CountLeadingZerosL(n);
    break;
  }
  case Op_CountTrailingZerosI: { _sub_Op_CountTrailingZerosI(n);
    break;
  }
  case Op_CountTrailingZerosL: { _sub_Op_CountTrailingZerosL(n);
    break;
  }
  case Op_CreateEx: { _sub_Op_CreateEx(n);
    break;
  }
  case Op_DecodeN: { _sub_Op_DecodeN(n);
    break;
  }
  case Op_DecodeNKlass: { _sub_Op_DecodeNKlass(n);
    break;
  }
  case Op_DivD: { _sub_Op_DivD(n);
    break;
  }
  case Op_DivF: { _sub_Op_DivF(n);
    break;
  }
  case Op_DivI: { _sub_Op_DivI(n);
    break;
  }
  case Op_DivL: { _sub_Op_DivL(n);
    break;
  }
  case Op_EncodeISOArray: { _sub_Op_EncodeISOArray(n);
    break;
  }
  case Op_EncodeP: { _sub_Op_EncodeP(n);
    break;
  }
  case Op_EncodePKlass: { _sub_Op_EncodePKlass(n);
    break;
  }
  case Op_FastLock: { _sub_Op_FastLock(n);
    break;
  }
  case Op_FastUnlock: { _sub_Op_FastUnlock(n);
    break;
  }
  case Op_FmaD: { _sub_Op_FmaD(n);
    break;
  }
  case Op_FmaF: { _sub_Op_FmaF(n);
    break;
  }
  case Op_Goto: { _sub_Op_Goto(n);
    break;
  }
  case Op_Halt: { _sub_Op_Halt(n);
    break;
  }
  case Op_CountPositives: { _sub_Op_CountPositives(n);
    break;
  }
  case Op_If: { _sub_Op_If(n);
    break;
  }
  case Op_LShiftI: { _sub_Op_LShiftI(n);
    break;
  }
  case Op_LShiftL: { _sub_Op_LShiftL(n);
    break;
  }
  case Op_LoadB: { _sub_Op_LoadB(n);
    break;
  }
  case Op_LoadUB: { _sub_Op_LoadUB(n);
    break;
  }
  case Op_LoadUS: { _sub_Op_LoadUS(n);
    break;
  }
  case Op_LoadD: { _sub_Op_LoadD(n);
    break;
  }
  case Op_LoadF: { _sub_Op_LoadF(n);
    break;
  }
  case Op_LoadI: { _sub_Op_LoadI(n);
    break;
  }
  case Op_LoadKlass: { _sub_Op_LoadKlass(n);
    break;
  }
  case Op_LoadNKlass: { _sub_Op_LoadNKlass(n);
    break;
  }
  case Op_LoadL: { _sub_Op_LoadL(n);
    break;
  }
  case Op_LoadPLocked: { _sub_Op_LoadPLocked(n);
    break;
  }
  case Op_LoadP: { _sub_Op_LoadP(n);
    break;
  }
  case Op_LoadN: { _sub_Op_LoadN(n);
    break;
  }
  case Op_LoadRange: { _sub_Op_LoadRange(n);
    break;
  }
  case Op_LoadS: { _sub_Op_LoadS(n);
    break;
  }
  case Op_MaxI: { _sub_Op_MaxI(n);
    break;
  }
  case Op_MaxD: { _sub_Op_MaxD(n);
    break;
  }
  case Op_MaxF: { _sub_Op_MaxF(n);
    break;
  }
  case Op_MemBarAcquire: { _sub_Op_MemBarAcquire(n);
    break;
  }
  case Op_LoadFence: { _sub_Op_LoadFence(n);
    break;
  }
  case Op_MemBarAcquireLock: { _sub_Op_MemBarAcquireLock(n);
    break;
  }
  case Op_MemBarRelease: { _sub_Op_MemBarRelease(n);
    break;
  }
  case Op_StoreFence: { _sub_Op_StoreFence(n);
    break;
  }
  case Op_StoreStoreFence: { _sub_Op_StoreStoreFence(n);
    break;
  }
  case Op_MemBarReleaseLock: { _sub_Op_MemBarReleaseLock(n);
    break;
  }
  case Op_MemBarVolatile: { _sub_Op_MemBarVolatile(n);
    break;
  }
  case Op_MemBarStoreStore: { _sub_Op_MemBarStoreStore(n);
    break;
  }
  case Op_MinI: { _sub_Op_MinI(n);
    break;
  }
  case Op_MinF: { _sub_Op_MinF(n);
    break;
  }
  case Op_MinD: { _sub_Op_MinD(n);
    break;
  }
  case Op_ModI: { _sub_Op_ModI(n);
    break;
  }
  case Op_ModL: { _sub_Op_ModL(n);
    break;
  }
  case Op_MoveI2F: { _sub_Op_MoveI2F(n);
    break;
  }
  case Op_MoveF2I: { _sub_Op_MoveF2I(n);
    break;
  }
  case Op_MoveL2D: { _sub_Op_MoveL2D(n);
    break;
  }
  case Op_MoveD2L: { _sub_Op_MoveD2L(n);
    break;
  }
  case Op_MulD: { _sub_Op_MulD(n);
    break;
  }
  case Op_MulF: { _sub_Op_MulF(n);
    break;
  }
  case Op_MulHiL: { _sub_Op_MulHiL(n);
    break;
  }
  case Op_MulI: { _sub_Op_MulI(n);
    break;
  }
  case Op_MulL: { _sub_Op_MulL(n);
    break;
  }
  case Op_NegD: { _sub_Op_NegD(n);
    break;
  }
  case Op_NegF: { _sub_Op_NegF(n);
    break;
  }
  case Op_OrI: { _sub_Op_OrI(n);
    break;
  }
  case Op_OrL: { _sub_Op_OrL(n);
    break;
  }
  case Op_PartialSubtypeCheck: { _sub_Op_PartialSubtypeCheck(n);
    break;
  }
  case Op_PopCountI: { _sub_Op_PopCountI(n);
    break;
  }
  case Op_PopCountL: { _sub_Op_PopCountL(n);
    break;
  }
  case Op_RShiftI: { _sub_Op_RShiftI(n);
    break;
  }
  case Op_RShiftL: { _sub_Op_RShiftL(n);
    break;
  }
  case Op_Rethrow: { _sub_Op_Rethrow(n);
    break;
  }
  case Op_Return: { _sub_Op_Return(n);
    break;
  }
  case Op_RoundDoubleModeV: { _sub_Op_RoundDoubleModeV(n);
    break;
  }
  case Op_RotateLeft: { _sub_Op_RotateLeft(n);
    break;
  }
  case Op_RotateRight: { _sub_Op_RotateRight(n);
    break;
  }
  case Op_SafePoint: { _sub_Op_SafePoint(n);
    break;
  }
  case Op_ShenandoahCompareAndExchangeP: { _sub_Op_ShenandoahCompareAndExchangeP(n);
    break;
  }
  case Op_ShenandoahCompareAndExchangeN: { _sub_Op_ShenandoahCompareAndExchangeN(n);
    break;
  }
  case Op_ShenandoahCompareAndSwapN: { _sub_Op_ShenandoahCompareAndSwapN(n);
    break;
  }
  case Op_ShenandoahCompareAndSwapP: { _sub_Op_ShenandoahCompareAndSwapP(n);
    break;
  }
  case Op_ShenandoahWeakCompareAndSwapN: { _sub_Op_ShenandoahWeakCompareAndSwapN(n);
    break;
  }
  case Op_ShenandoahWeakCompareAndSwapP: { _sub_Op_ShenandoahWeakCompareAndSwapP(n);
    break;
  }
  case Op_SqrtD: { _sub_Op_SqrtD(n);
    break;
  }
  case Op_StoreB: { _sub_Op_StoreB(n);
    break;
  }
  case Op_StoreC: { _sub_Op_StoreC(n);
    break;
  }
  case Op_StoreCM: { _sub_Op_StoreCM(n);
    break;
  }
  case Op_StorePConditional: { _sub_Op_StorePConditional(n);
    break;
  }
  case Op_StoreIConditional: { _sub_Op_StoreIConditional(n);
    break;
  }
  case Op_StoreLConditional: { _sub_Op_StoreLConditional(n);
    break;
  }
  case Op_StoreD: { _sub_Op_StoreD(n);
    break;
  }
  case Op_StoreF: { _sub_Op_StoreF(n);
    break;
  }
  case Op_StoreI: { _sub_Op_StoreI(n);
    break;
  }
  case Op_StoreL: { _sub_Op_StoreL(n);
    break;
  }
  case Op_StoreP: { _sub_Op_StoreP(n);
    break;
  }
  case Op_StoreN: { _sub_Op_StoreN(n);
    break;
  }
  case Op_StoreNKlass: { _sub_Op_StoreNKlass(n);
    break;
  }
  case Op_StrComp: { _sub_Op_StrComp(n);
    break;
  }
  case Op_StrCompressedCopy: { _sub_Op_StrCompressedCopy(n);
    break;
  }
  case Op_StrEquals: { _sub_Op_StrEquals(n);
    break;
  }
  case Op_StrIndexOf: { _sub_Op_StrIndexOf(n);
    break;
  }
  case Op_StrIndexOfChar: { _sub_Op_StrIndexOfChar(n);
    break;
  }
  case Op_StrInflatedCopy: { _sub_Op_StrInflatedCopy(n);
    break;
  }
  case Op_SubD: { _sub_Op_SubD(n);
    break;
  }
  case Op_SubF: { _sub_Op_SubF(n);
    break;
  }
  case Op_SubI: { _sub_Op_SubI(n);
    break;
  }
  case Op_SubL: { _sub_Op_SubL(n);
    break;
  }
  case Op_TailCall: { _sub_Op_TailCall(n);
    break;
  }
  case Op_TailJump: { _sub_Op_TailJump(n);
    break;
  }
  case Op_ThreadLocal: { _sub_Op_ThreadLocal(n);
    break;
  }
  case Op_URShiftI: { _sub_Op_URShiftI(n);
    break;
  }
  case Op_URShiftL: { _sub_Op_URShiftL(n);
    break;
  }
  case Op_XorI: { _sub_Op_XorI(n);
    break;
  }
  case Op_XorL: { _sub_Op_XorL(n);
    break;
  }
  case Op_AddVB: { _sub_Op_AddVB(n);
    break;
  }
  case Op_AddVS: { _sub_Op_AddVS(n);
    break;
  }
  case Op_AddVI: { _sub_Op_AddVI(n);
    break;
  }
  case Op_AddReductionVI: { _sub_Op_AddReductionVI(n);
    break;
  }
  case Op_AddVL: { _sub_Op_AddVL(n);
    break;
  }
  case Op_AddReductionVL: { _sub_Op_AddReductionVL(n);
    break;
  }
  case Op_AddVF: { _sub_Op_AddVF(n);
    break;
  }
  case Op_AddReductionVF: { _sub_Op_AddReductionVF(n);
    break;
  }
  case Op_AddVD: { _sub_Op_AddVD(n);
    break;
  }
  case Op_AddReductionVD: { _sub_Op_AddReductionVD(n);
    break;
  }
  case Op_SubVB: { _sub_Op_SubVB(n);
    break;
  }
  case Op_SubVS: { _sub_Op_SubVS(n);
    break;
  }
  case Op_SubVI: { _sub_Op_SubVI(n);
    break;
  }
  case Op_SubVL: { _sub_Op_SubVL(n);
    break;
  }
  case Op_SubVF: { _sub_Op_SubVF(n);
    break;
  }
  case Op_SubVD: { _sub_Op_SubVD(n);
    break;
  }
  case Op_MulVB: { _sub_Op_MulVB(n);
    break;
  }
  case Op_MulVS: { _sub_Op_MulVS(n);
    break;
  }
  case Op_MulVI: { _sub_Op_MulVI(n);
    break;
  }
  case Op_MulVL: { _sub_Op_MulVL(n);
    break;
  }
  case Op_MulVF: { _sub_Op_MulVF(n);
    break;
  }
  case Op_MulVD: { _sub_Op_MulVD(n);
    break;
  }
  case Op_FmaVD: { _sub_Op_FmaVD(n);
    break;
  }
  case Op_FmaVF: { _sub_Op_FmaVF(n);
    break;
  }
  case Op_DivVF: { _sub_Op_DivVF(n);
    break;
  }
  case Op_DivVD: { _sub_Op_DivVD(n);
    break;
  }
  case Op_AbsVB: { _sub_Op_AbsVB(n);
    break;
  }
  case Op_AbsVS: { _sub_Op_AbsVS(n);
    break;
  }
  case Op_AbsVI: { _sub_Op_AbsVI(n);
    break;
  }
  case Op_AbsVL: { _sub_Op_AbsVL(n);
    break;
  }
  case Op_AbsVF: { _sub_Op_AbsVF(n);
    break;
  }
  case Op_AbsVD: { _sub_Op_AbsVD(n);
    break;
  }
  case Op_NegVF: { _sub_Op_NegVF(n);
    break;
  }
  case Op_NegVD: { _sub_Op_NegVD(n);
    break;
  }
  case Op_SqrtVD: { _sub_Op_SqrtVD(n);
    break;
  }
  case Op_SqrtVF: { _sub_Op_SqrtVF(n);
    break;
  }
  case Op_LShiftCntV: { _sub_Op_LShiftCntV(n);
    break;
  }
  case Op_RShiftCntV: { _sub_Op_RShiftCntV(n);
    break;
  }
  case Op_LShiftVB: { _sub_Op_LShiftVB(n);
    break;
  }
  case Op_LShiftVS: { _sub_Op_LShiftVS(n);
    break;
  }
  case Op_LShiftVI: { _sub_Op_LShiftVI(n);
    break;
  }
  case Op_LShiftVL: { _sub_Op_LShiftVL(n);
    break;
  }
  case Op_RShiftVB: { _sub_Op_RShiftVB(n);
    break;
  }
  case Op_RShiftVS: { _sub_Op_RShiftVS(n);
    break;
  }
  case Op_RShiftVI: { _sub_Op_RShiftVI(n);
    break;
  }
  case Op_RShiftVL: { _sub_Op_RShiftVL(n);
    break;
  }
  case Op_URShiftVB: { _sub_Op_URShiftVB(n);
    break;
  }
  case Op_URShiftVS: { _sub_Op_URShiftVS(n);
    break;
  }
  case Op_URShiftVI: { _sub_Op_URShiftVI(n);
    break;
  }
  case Op_URShiftVL: { _sub_Op_URShiftVL(n);
    break;
  }
  case Op_AndV: { _sub_Op_AndV(n);
    break;
  }
  case Op_OrV: { _sub_Op_OrV(n);
    break;
  }
  case Op_XorV: { _sub_Op_XorV(n);
    break;
  }
  case Op_MinV: { _sub_Op_MinV(n);
    break;
  }
  case Op_MaxV: { _sub_Op_MaxV(n);
    break;
  }
  case Op_MinReductionV: { _sub_Op_MinReductionV(n);
    break;
  }
  case Op_MaxReductionV: { _sub_Op_MaxReductionV(n);
    break;
  }
  case Op_LoadVector: { _sub_Op_LoadVector(n);
    break;
  }
  case Op_StoreVector: { _sub_Op_StoreVector(n);
    break;
  }
  case Op_ReplicateB: { _sub_Op_ReplicateB(n);
    break;
  }
  case Op_ReplicateS: { _sub_Op_ReplicateS(n);
    break;
  }
  case Op_ReplicateI: { _sub_Op_ReplicateI(n);
    break;
  }
  case Op_ReplicateL: { _sub_Op_ReplicateL(n);
    break;
  }
  case Op_ReplicateF: { _sub_Op_ReplicateF(n);
    break;
  }
  case Op_ReplicateD: { _sub_Op_ReplicateD(n);
    break;
  }
  
  default:
    tty->print("Default case invoked for: \n");
    tty->print("   opcode  = %d, \"%s\"\n", opcode, NodeClassNames[opcode]);
    return false;
  }
  return true;
}
